﻿


'/*
'
' -----------------------------------------------------------------
' IDENTIFICACION.:
'    Versión .....: 2013/02/19
'    Module Name..: EscribeConLetras 
'----------------
'    Creada inicialmente en el proyecto: [NumerosToLetrasDll]
'    Versión de la plantilla de fecha..: [2012-12-12] 
'----------------
'    Lenguaje .: .NET Framework 4.0.30319.18033 - 
'                 Microsoft Visual Basic .NET 2012 - [2013]
'    Usuario ..: AGUILA8 - Joaquin
'
'----------------
' DESCRIPCION.:
'
'En resumen
' Para escribir el numero en letras se usa la clase [OperacionesEscribeNumeroConLetras]
' Para tratar la parte entera esta la calse [OperacionesEscribeLaParteEntera]
' Para tratar la parte decimal esta la clase [OperacionesEscribeLaParteDecimal]
' Para organizar todas las operaciones esta la clase [EscribeConLetrasDirector]
' Para contener los datos comunes a todas ellas esta la clase base [OperacionesDatosComunes]
'
' Esta clase se encarga de escribir en letras el número COMPLETO recibido.
' La clase recibe un número, y trata de forma separada, la parte entera y la parte decimal
' para ello usa dos clases contenidas que realizan ese trabajo
'
' A continuación junta las dos cadenas para devolver el resultado
' También añade las unidades de la parte entera y las de la parte decimal
'
' Si los decimales no llevan unidades se pone las unidades por defecto para evitar ambigüedades
' Por ejemplo las cifras 2,2 y 2,02  se escriben en letras de la misma forma 
' [dos con dos] sin embargo hace falta la unidad para diferenciarlas.
' [dos con dos decimas] [dos con dos centésimas]
'
' Si la cadena es un cero(0) devuelve una cadena con el valor [cero]
' Si la cadena tiene el valor [Empty] se  devuelve una cadena con el valor [Empty]
'
' La clase puede escribir en letras números de cualquier tamaño pero solo 
' nombra las unidades (miles, millones billones, etc) de los 15 primeros 
' dígitos decimales hasta los [cuatrivigentillones] 
' las unidades correspondientes a las cantidades más elevadas las muestra 
' en forma de múltiplos de 10 de esta manera --> cuatro [10^(156)]llones 
'
' La clase puede escribir y nombrar cualquier cantidad de números decimales, 
' pero las unidades estándar de los números decimales solo se nombran 
' hasta la 60 cifra decimal,  que corresponde a las [vigentillonésimas],
' las cantidades mas 'pequeñas' se muestran en formato de múltiplos 
' de 10 de esta manera --> veintitrés [10^(-63)]llonésimas
'
'----------------
' OBSERVACIONES.:
'    ### Falta  mas observaciones###
'
'----------------
' INTERFAZ.:
'    Implementa la interfaz IDisposable, INumeroToLetras
'
'----------------
' BIBLIOGRAFIA.:
'  Anexo:Nombres de los números en español
'  http://es.wikipedia.org/wiki/Nombres_de_los_n%C3%BAmeros_en_espa%C3%B1ol
'
'----------------
#Region "Copyright"

' COPYRIGHT.:
'      Copyright (c).:  [2013]  Joaquin 'jms32' Medina Serrano
'      Emilio .......:  mailto:joaquin@medina.name
'      Web ..........:  http://joaquin.medina.name
'
'
'  Yo, titular de los derechos de autor de esta obra, la publico 
'  en los términos de las siguientes licencias:
'
'  A pesar de las ¿Exhaustivas? , ¿Intesas?, 
'  y ¿cuidadosas? (ja, ja, ja..) pruebas a que he  
'  sometido este codigo, el principio de Murphy siempre 
'  esta trabajando y dice que si algo puede ir mal seguro 
'  que va mal. Por esa razon, Este codigo se porporciona 
'  *Como esta* sin ninguna garantia de ninguna clase 
'
'  Este codigo es BirraWare, es decir, si lo empleas, 
'  estas obligado de forma ineludible a:
'  a) Indicar claramente el autor (o sea mi nombre) 
'     y el sitio Web de donde se lo has copiado 
'     (o sea mi web) 
'  b) invitar a una birrita fresquita al creador del mismo
'     (o sea soy yo el que tiene que beberse la cerveza).
'  c) Si no me localizas, me conformo con que me envies 
'     un *emilio* contandome para que lo has empleado.
'     tengo curiosidad por saber por donde circula, 
'     (la curiosidad me puede)
'  d) Si haces algo interesante enviame una copia, me gustaria verlo 
'
' Se autoriza la copia, distribución y modificación de este documento 
' bajo los términos de la licencia de documentación libre GNU,  
' versión 1.2 o cualquier otra que posteriormente publique la  
' Fundación para el Software Libre; sin secciones invariables,  
' textos de portada, ni textos de contraportada.  
' Se incluye una copia de la dicha licencia en la sección titulada  
' Licencia de Documentación Libre GNU. Se puede consultar una copia  
' de la licencia en http://www.gnu.org/copyleft/fdl.html
'
'Este archivo se encuentra bajo la licencia  
' Creative Commons de Atribución/Compartir-Igual 
'Eres libre:
'  - Para compartir – para copiar, distribuir y transmitir el trabajo
'  - Para remezclar – para adaptar el trabajo
' Bajo las siguientes condiciones: 
'  - Atribución – Debes atribuir el trabajo de la manera especificada  
'    por el autor o persona que lo haya licenciado (pero no de manera  
'    que sugiera que estas personas te respaldan o respaldan el uso  
'    que hagas del trabajo).
'  - Compartir similar – En caso de alterar, transformar o ampliar  
'    este trabajo, deberá distribuir el trabajo resultante sólo  
'    bajo la misma licencia o una similar.
'
#End Region
'----------------
' MODIFICACIONES  [aaaa-mm-dd] 
' - 2013/02/19- Creación 
' - 2013/02/19 - Revisado con FxCop 
'
' -----------------------------------------------------------------
'
'*/
'
' -------------------------------------------------
Option Explicit On
Option Strict On
Option Infer Off
Option Compare Binary




''' <summary>
'''   Clase que escribe un numero en letras. (incluyendo sus unidades)
'''   El numero puede tener cualquier formato con decimales o no
''' </summary>
''' <remarks></remarks>
<Serializable()> _
Friend Class EscribeConLetrasDirector
    Implements INumeroToLetras, IDisposable


#Region "Variables de la clase"

    ''' <summary>
    '''  Objeto contenido cuya labor es escribir en letras (únicamente) la parte entera del numero
    ''' </summary>
    Private _localObjEscritorNumeroEntero As OperacionesEscribeLaParteEntera = Nothing
    ''' <summary>
    '''  Objeto contenido cuya labor es escribir en letras (únicamente) la parte decimal del numero
    ''' </summary>
    Private _localObjEscritorNumeroDecimal As OperacionesEscribeLaParteDecimal = Nothing

    ''' <summary>
    ''' La cadena que contiene el numero recibido sin modificaciones
    ''' </summary>
    Private _cadenaNumericaOriginal As String = String.Empty

    ''' <summary>
    ''' La cadena que contiene el numero recibido sin modificaciones
    ''' </summary>
    Friend Property CadenaNumericaOriginal As String
        Get
            Return _cadenaNumericaOriginal
        End Get
        Set(value As String)
            If _cadenaNumericaOriginal <> value Then
                _cadenaNumericaOriginal = value
                auxPropertyCargarParteDecimalYEntera(value)
            End If
        End Set
    End Property


    ''' <summary>
    '''  Separa el numero recibido en su parte entera y en su parte decimal
    '''  Carga los objetos contenidos que escribe la patrte entera y la parte decimal del numero
    ''' </summary>
    Private Sub auxPropertyCargarParteDecimalYEntera(ByVal pCadenaNumerica As String)
        '---------------------------
        Dim parteEntera As String = String.Empty
        Dim parteDecimal As String = String.Empty

        '-------------------------------
        ' La cadena no puede estar vacia
        '-------------------------------
        If String.IsNullOrWhiteSpace(pCadenaNumerica) = True Then
            ' la cadena esta vacia, devovler valores[Emty]
            ' al final de este if.
        Else

            '---------------
            'Correcciones
            '---------------
            ' Si el primer caracter es una coma añadir delante un cero
            If pCadenaNumerica.StartsWith(","c, StringComparison.OrdinalIgnoreCase) = True Then
                pCadenaNumerica = "0"c & pCadenaNumerica
            End If
            ' si el ultimo caracter es una coma añadir detras un cero
            If pCadenaNumerica.EndsWith(","c, StringComparison.OrdinalIgnoreCase) = True Then
                pCadenaNumerica = pCadenaNumerica & "0"c
            End If



            '------------------------------
            ' Localizar la coma decimal y separar el numero en dos partes
            Dim posicionComaDecimal As Integer = pCadenaNumerica.IndexOf(","c)
            If posicionComaDecimal <> -1 Then
                parteEntera = pCadenaNumerica.Substring(0, posicionComaDecimal)
                parteDecimal = pCadenaNumerica.Substring((posicionComaDecimal + 1), ((pCadenaNumerica.Length - posicionComaDecimal) - 1))
            Else
                ' no hay parte decimal
                parteEntera = pCadenaNumerica
                parteDecimal = String.Empty
            End If



            '-------------------------------
        End If '/ eof ¿¿ Cadena Vacia ??
        '-------------------------------
        '' carga de valores miembro
        _localObjEscritorNumeroEntero.CadenaNumericaCorregida = parteEntera
        _localObjEscritorNumeroDecimal.CadenaNumericaCorregida = parteDecimal

    End Sub

    '-----------------------------------
    '-----------------------------------

    ' ''' <summary>
    ' '''  Cadena que contiene un numero INTEGER que representa 
    ' '''  la parte entera del numero que queremos escribir en letras
    ' ''' </summary>
    ' ''' <remarks>
    ' '''  Al cargarla se quitan los ceros no significativos de la izquieda
    ' '''  por ejemplo 00012 --> 12
    ' '''</remarks>
    'Friend ReadOnly Property CadenaNumericaParteEntera As String
    '    Get
    '        Return _localObjEscritorNumeroEntero.CadenaNumericaCorregida
    '    End Get

    'End Property

    ''' <summary>
    ''' Cadena que contiene la unidad (en singular) que califica 
    ''' a la parte entera del número. Por ejemplo Euro, patata,
    ''' </summary>
    Friend WriteOnly Property NombreUnidadParteEnteraSingular As String
        'Get
        '    Return _localObjEscritorNumeroEntero.NombreUnidadEnSingular
        'End Get
        Set(value As String)
            _localObjEscritorNumeroEntero.NombreUnidadEnSingular = value
        End Set
    End Property

    ''' <summary>
    '''  Cadena que contiene la unidad (en plural) que califica 
    '''  a la parte entera del número. Por ejemplo Euros, patatas
    ''' </summary>
    Friend WriteOnly Property NombreUnidadParteEnteraPlural As String
        'Private Get
        '    Return _localObjEscritorNumeroEntero.NombreUnidadEnPlural
        'End Get
        Set(value As String)
            _localObjEscritorNumeroEntero.NombreUnidadEnPlural = value
        End Set
    End Property


    ''' <summary>
    '''  La unidad que califica a la parte entera del número (si existe)
    '''  ¿Es del género masculino o femenino?
    ''' </summary>
    ''' <value>
    '''   <para>Enumeración <see cref="FormatoEscrituraDelUno">FormatoEscrituraDelUno</see></para>
    '''   <para>Indica la forma de escribir una terminación en [uno] por ejemplo [un], [uno, [una]</para>
    '''   <para>Valor por defecto = FormatoEscrituraDelUno.UnoSinSustantivo </para>
    ''' </value>
    Friend WriteOnly Property FormatoEscrituraParteEntera As FormatoEscrituraDelUno
        'Get
        '    Return _localObjEscritorNumeroEntero.FormaDeEscribirElUno
        'End Get
        Set(value As FormatoEscrituraDelUno)
            _localObjEscritorNumeroEntero.FormaDeEscribirElUno = value
        End Set
    End Property

    '-----------------------------------
    '-----------------------------------

    ' ''' <summary>
    ' '''  Cadena que contiene un numero INTEGER que representa 
    ' '''  la parte decimal del numero que queremos escribir en letras
    ' ''' </summary>
    'Friend ReadOnly Property CadenaNumericaParteDecimal As String
    '    Get
    '        Return _localObjEscritorNumeroDecimal.CadenaNumericaCorregida
    '    End Get

    'End Property

    ''' <summary>
    '''   Cadena que contiene la unidad decimal (en singular) que califica 
    '''   a la parte decimal del número. Por ejemplo centimo, patatilla
    ''' </summary>
    Friend WriteOnly Property NombreUnidadParteDecimalSingular As String
        'Get
        '    Return _localObjEscritorNumeroDecimal.NombreUnidadEnSingular
        'End Get
        Set(value As String)
            _localObjEscritorNumeroDecimal.NombreUnidadEnSingular = value
        End Set
    End Property

    ''' <summary>
    '''   Cadena que contiene la unidad decimal (en plural) que califica 
    '''   a la parte decimal del número. Por ejemplo centimos, patatillas
    ''' </summary>
    Friend WriteOnly Property NombreUnidadParteDecimalPlural As String
        'Get
        '    Return _localObjEscritorNumeroDecimal.NombreUnidadEnPlural
        'End Get
        Set(value As String)
            _localObjEscritorNumeroDecimal.NombreUnidadEnPlural = value
        End Set
    End Property


    ''' <summary>
    '''  La unidad que califica a la parte decimal del número (si existe) ¿es del genero masculino o femenino?
    ''' </summary>
    ''' <value>
    '''   <para>Enumeración <see cref="FormatoEscrituraDelUno">FormatoEscrituraDelUno</see></para>
    '''   <para>Indica la forma de escribir una terminación en [uno] por ejemplo [un], [uno, [una]</para>
    '''   <para>Valor por defecto = FormatoEscrituraDelUno.UnoSinSustantivo </para>
    ''' </value>
    Friend WriteOnly Property FormatoEscrituraParteDecimal As FormatoEscrituraDelUno
        'Get
        '    Return _localObjEscritorNumeroDecimal.FormaDeEscribirElUno
        'End Get
        Set(value As FormatoEscrituraDelUno)
            _localObjEscritorNumeroDecimal.FormaDeEscribirElUno = value
        End Set
    End Property


    ''' <summary>
    '''  Numero de decimales que obligatoriamente debe tener el numero. 
    '''  Valor por defecto= -1 significa que no se controla este valor
    ''' </summary>
    Friend WriteOnly Property NumeroDeDecimalesObligatorios As Integer
        'Get
        '    Return _localObjEscritorNumeroDecimal.NumeroDeDecimalesObligatorios
        'End Get
        Set(value As Integer)
            _localObjEscritorNumeroDecimal.NumeroDeDecimalesObligatorios = value
        End Set
    End Property

#End Region

#Region "Constructores"

    ''' <summary>
    '''  Constructor
    ''' </summary>
    ''' <param name="pCadenaNumerica"> 
    '''    La cadena Original que contiene un número
    '''    La cadena debe contener únicamente números [0-9]
    '''    La coma [,] como separador decimal
    '''    Como separadores de millar se admite el punto [.]  o el espacio
    '''    Ejemplo [123.456,78] [123 456,78]
    '''</param>
    ''' <remarks>
    '''    Opcionalmente la cadena puede llevar el signo  menos [-] 
    '''    para indicar que es un número negativo
    '''</remarks>
    Friend Sub New(ByVal pCadenaNumerica As String)

        If Me._localObjEscritorNumeroEntero Is Nothing Then
            _localObjEscritorNumeroEntero = New OperacionesEscribeLaParteEntera()
        End If
        If Me._localObjEscritorNumeroDecimal Is Nothing Then
            _localObjEscritorNumeroDecimal = New OperacionesEscribeLaParteDecimal()
        End If

        Me.CadenaNumericaOriginal = pCadenaNumerica
    End Sub

#End Region

#Region "EscribeElNumeroConLetras"



    ''' <summary>
    '''  Escribe en letras un número
    ''' (P.E. 45,23 -> Cuarenta y cinco con veintitrés)
    ''' </summary>
    ''' <param name="pNumero">Un numero decimal. </param>
    ''' <returns>
    '''   <para>Una cadena que contiene escrito en letras el numero pasado</para>
    '''   <para>si el numero es cero (0) devuelve una cadena con el valor [cero]</para>
    '''   <para>si el numero es una cadena vacía [Empty] se devuelve [Empty]</para>
    ''' </returns>
    Friend Function EscribeElNumeroConLetras(ByVal pNumero As Decimal) As String _
           Implements INumeroToLetras.EscribeElNumeroConLetras
        Try
            ' convertir el numero en cadena
            Dim epañolCultureInfo As System.Globalization.CultureInfo
            epañolCultureInfo = New System.Globalization.CultureInfo("es-ES")

            Dim auxNumeroComoCadena As String = String.Format(epañolCultureInfo, "{0:G}", pNumero)
            '----
            ' la prueba del algodon
            ' 2) convertir la cadena otra vez en nuemro
            Dim auxNumeroDecimal As Decimal = Decimal.Parse(auxNumeroComoCadena, Globalization.NumberStyles.Currency, epañolCultureInfo)
            ' 3) ver si el numerooriginal y el resultado de la conversion son iguales
            If auxNumeroDecimal <> pNumero Then
                Using sw As New System.IO.StringWriter(System.Globalization.CultureInfo.CurrentCulture)
                    sw.WriteLine("")
                    sw.WriteLine("La conversion [Numero -> Cadena -> Numero] no ha tenido  éxito.")
                    sw.WriteLine("Este error se dispara porque los datos numericos no son fiables")
                    sw.WriteLine("Valor del parametro     [{0}]", pNumero)
                    sw.WriteLine("Valor de la cadena      [{0}]", auxNumeroComoCadena)
                    sw.WriteLine("Valor numero convertido [{0}]", auxNumeroDecimal)
                    sw.Flush()
                    Throw New InvalidCadenaNumericaException(sw.ToString)
                End Using
            End If

            '------------------------------------------------------------------
            ' pasar la cadena a la variable y escribir el numero en letras
            Me.CadenaNumericaOriginal = auxNumeroComoCadena
            Return Me.EscribeElNumeroConLetras()
        Catch ex As Exception
            Throw New InvalidCadenaNumericaException(
                     "Problemas al convertir el numero en cadena." & Environment.NewLine & ex.Message, ex)
        End Try

        Return Me.EscribeElNumeroConLetras()
    End Function


    ''' <summary>
    '''  Escribe en letras un número
    ''' (P.E. 45,23 -> Cuarenta y cinco con veintitrés)
    ''' </summary>
    ''' <param name="pCadenaNumerica">
    '''   <para>La cadena que contiene el numero. </para>
    '''   <para>Es responsabilidad del llamador asegurarse de que 
    '''         la cadena es un numero bien formado, 
    '''         escrito en formato numérico Español es decir:</para> 
    '''   <para>El separador decimal es la coma [,]. </para>
    '''   <para>El separador de los millares es o bien el punto [.], o bien el espacio [' ']. </para>
    '''   <para>La cadena debe contener únicamente números (no están permitidas las letras),</para>
    '''   <para>Opcionalmente puede llevar un signo más [+] o menos [-] para indicar que el número es positivo o negativo.</para>
    ''' </param>
    ''' <returns>
    '''   <para>Una cadena que contiene escrito en letras el numero pasado</para>
    '''   <para>si el numero es cero (0) devuelve una cadena con el valor [cero] </para>
    '''   <para>si el numero es una cadena vacía [Empty] se devuelve [Empty]</para>
    ''' </returns>
     Friend Function EscribeElNumeroConLetras(ByVal pCadenaNumerica As String) As String Implements INumeroToLetras.EscribeElNumeroConLetras
        Me.CadenaNumericaOriginal = pCadenaNumerica
        Return Me.EscribeElNumeroConLetras()
    End Function


    ''' <summary>
    '''   Escribe en letras el número pasado en el constructor 
    '''   (P.E. 45,23 -> Cuarenta y cinco con veintitres)
    ''' </summary>
    Friend Function EscribeElNumeroConLetras() As String Implements INumeroToLetras.EscribeElNumeroConLetras

        If String.IsNullOrWhiteSpace(Me.CadenaNumericaOriginal) = True Then
            Return String.Empty
        End If

        '--------------------------
        Dim cadenaConElResultado As String = String.Empty
        Dim parteEnteraConLetras As String = String.Empty
        Dim parteDecimalConLetras As String = String.Empty

        '--------------------------
        parteEnteraConLetras = Me._localObjEscritorNumeroEntero.EscribeElNumeroConLetras
        parteDecimalConLetras = Me._localObjEscritorNumeroDecimal.EscribeElNumeroConLetras

        '--------------------------
        ' montar el resultado
        If parteEnteraConLetras.Length > 0 Then
            cadenaConElResultado = parteEnteraConLetras
            If parteDecimalConLetras.Length > 0 Then
                cadenaConElResultado = cadenaConElResultado & " con " & parteDecimalConLetras
            End If
        Else
            ' la parte entera no existe
            cadenaConElResultado = parteDecimalConLetras
        End If

        If cadenaConElResultado.Length > 0 Then
            '--------------------------
            '  Poner en mayúscula la primera letra de la cadena (Tipo oración)
            cadenaConElResultado = PonerEnMayusculaPrimeraLetra(cadenaConElResultado)
        End If

        Return cadenaConElResultado

    End Function


    ''' <summary>
    '''   Poner en mayúscula la primera letra de la cadena (Tipo oración)
    ''' </summary>
    ''' <param name="pCadena">La cadena cuya primera letra se pone en mayusculas</param>
    Protected Shared Function PonerEnMayusculaPrimeraLetra(ByVal pCadena As String) As String

        If String.IsNullOrWhiteSpace(pCadena) = True Then
            Return String.Empty
        End If

        '--------------------------
        ' quitar los espacios sobrantes
        pCadena = pCadena.Trim

        '--------------------------
        ' Poner en mayuscula la primera letra de la cadena
        pCadena = pCadena.Substring(0, 1).ToUpper(System.Globalization.CultureInfo.InvariantCulture) &
                  pCadena.Substring(1, pCadena.Length() - 1)

        '--------------------------
        Return pCadena

    End Function


#End Region



#Region "Implementacion interfaz [Dispose]  [2012-12-04] "


    ''' <summary>
    ''' Un objeto administrado es un objeto de .NET que maneja el motor de 
    ''' ejecucion de NET, por ejemplo cualquier objeto de .NET
    ''' </summary>
    Private Sub DisposeObjetosAdministrados()
        '--------------------------------
        ' --> Liberar objetos administrados), 
        '     por ejemplo cualquier objeto de .NET
        '--------------------------------
        '--------------------------------
        'If Not (Me._Arbol Is Nothing) Then
        '    If _Arbol.IsDisposed = False Then
        '        _Arbol.Dispose()
        '    End If
        '    Me._Arbol = Nothing
        'End If

        If Not (Me._localObjEscritorNumeroEntero Is Nothing) Then
            If _localObjEscritorNumeroEntero.IsDisposed = False Then
                _localObjEscritorNumeroEntero.Dispose()
            End If
            Me._localObjEscritorNumeroEntero = Nothing
        End If

        If Not (Me._localObjEscritorNumeroDecimal Is Nothing) Then
            If _localObjEscritorNumeroDecimal.IsDisposed = False Then
                _localObjEscritorNumeroDecimal.Dispose()
            End If
            Me._localObjEscritorNumeroDecimal = Nothing
        End If
    End Sub


    ''' <summary>
    '''  Establecer campos grandes como Null.
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub DisposeCamposGrandesToNothing()
         '--------------------------------
        ' --> Establecer campos grandes como Nothing.
        '     es decir todos los campos de la clase
        '--------------------------------
        'Me._CadenaGrande = Nothing
        Me._cadenaNumericaOriginal = Nothing

    End Sub


    ' ''' <summary>
    ' '''  Si la clase derivada usa objetos NO administrados, debe reemplazar esta funcion
    ' '''  Un objeto no administrado  es un recurso que NO administra el motor en  
    ' '''  tiempo de ejecución, como identificadores de  ventanas (HWND),  
    ' '''  conexiones a bases de datos, un objeto creado directamente  
    ' '''  llamando al API de Windows, etc. el Word o Excel
    ' ''' </summary>
    'Private Sub DisposeObjetosNOAdministrados()
    '    Throw New NotImplementedException("DisposeObjetosNOAdministrados - No esta escrita")

    '    '--------------------------------
    '    ' --> Liberar objetos NO administrados).
    '    '       por ejemplo una base de datos
    '    '       Solamente hay que llamar a su método [Dispose]
    '    '--------------------------------
    '    '--------------------------------
    '    'If Not (Me.connection Is Nothing) Then
    '    '    'Close conexión'
    '    '    If connection.IsDisposed = False Then
    '    '        connection.Dispose()
    '    '    End If
    '    '    '¡¡OJITO !! no se hace Nothing
    '    'End If
    '    '--------------------------------
    'End Sub


    ' *******************************************************
    ' *******************************************************


    '  Variable y propiedad para saber si se ha diposado :-) o no
    '  es una variable que actua de semaforo, solo deja pasar una vez
    '----------------------------------------
    ' Apunte Táctico
    '----------------------------------------
    ' Si se borra el atributo [<Serializable()>] de la clase
    ' También hay que borrar el atributo [<NonSerialized()>] 
    ' de la variable [_disposedValue] que esta a continuación
    '----------------------------------------



    'Private _isDisposed As Boolean ' = False (no hace falta inicializar) 

    ''' <summary>
    '''     Obtiene un valor que indica si el objeto se ha eliminado. 
    ''' </summary>
    <NonSerialized()> Private _isDisposed As Boolean ' = False (no hace falta inicializar) 


    ''' <summary>
    '''     Obtiene un valor que indica si el objeto se ha eliminado. 
    ''' </summary>
    ''' <value>
    '''   <para>Tipo: <see cref="System.Boolean">Boolean</see></para>
    '''   <para>Es true si objeto se ha eliminado; en caso contrario, es false.</para>
    ''' </value>
    ''' <remarks>
    ''' <para> Cuando esta propiedad devuelve true, el objeto se elimina y ya
    '''        no se puede hacer referencia al mismo como un objeto válido. </para>  
    ''' <para> Aunque se elimine la instancia de un objeto, ésta se guarda en 
    '''        la memoria hasta que el recolector de elementos no utilizados 
    '''        la quite de la memoria.</para>  
    '''</remarks>
    Public Overloads Property IsDisposed() As Boolean
        Get
            Return _isDisposed
        End Get
        Private Set(ByVal value As Boolean)
            _isDisposed = value
        End Set
    End Property


    ''' <summary>
    '''     Destructor del objeto
    ''' </summary>
    Protected Overrides Sub Finalize()
        ' Este método se invoca de forma automática, después de 
        ' que un objeto pase a ser inaccesible, salvo que haya  
        ' sido excluido del proceso de finalización mediante una  
        ' llamada a GC.SuppressFinalize. 
        ' -----------------------------------------------------
        ' escenario en el que el Sistema llama al metodo dispose
        ' -----------------------------------------------------
        Try
            Me.Dispose(False)
        Finally
            MyBase.Finalize()
        End Try
    End Sub


    ''' <summary>
    '''   Realiza tareas definidas por la aplicación asociadas a 
    '''   la liberación o al restablecimiento de recursos no administrados
    ''' </summary>
    Public Overloads Sub Dispose() Implements System.IDisposable.Dispose
        ' No hacer este metodo virtual.   
        ' Una clase derivada no debe ser capaz de reemplazar este metodo.    
        ' -----------------------------------------------------
        ' escenario en el que el usuario llama al metodo dispose
        ' -----------------------------------------------------
        ' No cambie este código. Coloque el código de limpieza en Dispose (ByVal que se dispone como Boolean).
        Me.Dispose(True)
        ' Decir al recolecto que no llame al destructor de este objeto
        ' porque este objeto ya esta [finalizado]
        GC.SuppressFinalize(Me)
    End Sub


    '--------------------------------------------------------------------
    ' Dispose (bool quienLLama) se ejecuta en dos escenarios distintos.
    ' Si [quienMeLLama] es igual a true, el método ha sido llamado directamente
    ' O indirectamente por el código de un usuario. 
    ' Los recursos administrados y no administrados Se puede eliminar.
    ' Si [quienMeLLama]es igual a false, el método ha sido llamado por el
    ' [runtime] desde el interior del finalizador y usted no debe hacer 
    ' referencia a otros objetos, ni siquiera para eliminarlos.
    ' Solo los recursos no administrados pueden ser eliminados.
    '--------------------------------------------------------------------
    ''' <summary>
    '''   Realiza tareas definidas por la aplicación asociadas a 
    '''   la liberación o al restablecimiento de recursos no administrados
    ''' </summary>
    ''' <remarks>
    ''' <para> ¡¡PROBLEMA!! Esta función debe tener el calificador [Overridable]</para>
    ''' <para>              pero si la clase está marcada como [NotInheritable] </para>
    ''' <para>              da error. En ese caso se puede quitar               </para>
    ''' <code>http://msdn.microsoft.com/es-es/magazine/cc163392.aspx</code>
    '''</remarks>
    Protected Overridable Overloads Sub Dispose(ByVal quienMeLLama As Boolean)
        ' Comprueba si Dispose ya ha sido llamado.  
        ' Solo se ejecuta una vez y solo una
        If Not Me.IsDisposed Then
            Try
                ' -------------------------------
                If quienMeLLama = True Then
                    ' -------------------------------
                    ' 1) Proceso de eliminar recursos SI administrados
                    ' -------------------------------
                    Call DisposeObjetosAdministrados()
                End If
                ' -------------------------------
                ' 2) Proceso de eliminar recursos NO administrados
                'Call DisposeObjetosNOAdministrados()
                ' -------------------------------
                ' 3) Proceso de eliminar cadenas grandes
                Call DisposeCamposGrandesToNothing()
                ' -------------------------------
                ' 4) TODO:  Proceso de llamar al dispose de la clase base
                ' -------------------------------
                'Call MyBase.Dispose()

            Finally
                ' Cerrar la puerta, solo se pasa una vez
                IsDisposed = True
            End Try
        End If
    End Sub


#End Region




End Class
