﻿

''' <summary>
'''    Interface para trabajar OBLIGATORIAMENTE con esta dll
''' </summary>
''' <remarks>
'''<code language="vb" title="Forma de usar la interface desde codigo">
''' <![CDATA[
'''     <summary>
'''       Ejemplo de uso de la interfaz desde código
'''     </summary>
'''     Private Sub TrabajoConInterfaces()
'''       ' Evitar un problema tonto con el cuadro de texto
'''        If Me.TextBoxLetras Is Nothing Then Exit Sub
'''        Try
'''            Dim interfaceConvertidor As NumerosToLetrasDll.INumeroToLetras = Nothing
'''            If Me.RadioButtonSoloNumeros.IsChecked = True Then
'''                interfaceConvertidor = New NumerosToLetrasDll.NumeroEscribeConLetras
'''            End If
'''            If Me.RadioButtonUnidad.IsChecked = True Then
'''                interfaceConvertidor = New NumerosToLetrasDll.UnidadesEscribeConLetras
'''            End If
'''            If Me.RadioButtonEuros.IsChecked = True Then
'''                interfaceConvertidor = New NumerosToLetrasDll.EurosEscribeConLetras
'''            End If
'''
'''            Me.TextBoxLetras.AppendText(Environment.NewLine)
'''            Me.TextBoxLetras.AppendText("(5) " & interfaceConvertidor.EscribeElNumeroConLetras(Me.TextBoxNumero.Text))
'''
'''            ' ------------------------------
'''            interfaceConvertidor = New NumerosToLetrasDll.GenericaEscribeConLetras(
'''                                pNombreUnidadParteEnteraSingular:="manzana",
'''                                pNombreUnidadParteEnteraPlural:="manzanas",
'''                                pFormatoEscrituraParteEntera:=NumerosToLetrasDll.FormatoEscrituraDelUno.UnaConSustantivoFemenino,
'''                                pNombreUnidadParteDecimalSingular:="centimanzana",
'''                                pNombreUnidadParteDecimalPlural:="centimanzanas",
'''                                pFormatoEscrituraParteDecimal:=NumerosToLetrasDll.FormatoEscrituraDelUno.UnaConSustantivoFemenino,
'''                                pNumeroDeDecimalesObligatorios:=-1)
'''
'''            Me.TextBoxLetras.AppendText(Environment.NewLine)
'''            Me.TextBoxLetras.AppendText("(6) " & interfaceConvertidor.EscribeElNumeroConLetras(Me.TextBoxNumero.Text))
'''
'''        Catch ex As Exception
'''            If Not (Me.TextBoxLetras Is Nothing) Then
'''                Me.TextBoxLetras.Text = ex.Message
'''            End If
'''        End Try
'''    End Sub
''']]>
''' </code> 
''' <list  type="bullet">
''' <item> <a href="http://es.wikipedia.org/wiki/Nombres_de_los_n%C3%BAmeros_en_espa%C3%B1ol">Anexo: Nombres de los números en español</a></item>
''' <item> <a href="http://es.wikipedia.org/wiki/Escalas_num%C3%A9ricas_larga_y_corta">Escalas numéricas larga y corta</a></item>
''' <item> <a href="http://www.saberespractico.com/estudios/cultura-general/reglas-escritura-numeros-cardinales/">Reglas para la escritura de los números cardinales </a></item>
''' <item> <a href="http://www.saberespractico.com/estudios/ortografia-numerica-escritura-de-numeros/">Reglas ortográficas para la escritura de números </a></item>
''' <item> <a href="http://www.hispanoteca.eu/Foro-preguntas/ARCHIVO-Foro/Euro%20-%20euros.htm">Hispanoteca - Como se escribe 'euro'</a></item>
''' </list>
''' </remarks>
Public Interface INumeroToLetras


    ''' <summary>
    '''   Escribe en letras el número pasado en el constructor (P.E. Cuarenta y cinco)
    ''' </summary>
    Function EscribeElNumeroConLetras() As String



    ''' <summary>
    '''  Escribe en letras un número
    ''' (P.E. 45,23 -> Cuarenta y cinco con veintitrés)
    ''' </summary>
    ''' <param name="pCadenaNumerica">
    '''   <para>La cadena que contiene el numero. </para>
    '''   <para>Es responsabilidad del llamador asegurarse de que 
    '''         la cadena es un numero bien formado, 
    '''         escrito en formato numérico Español es decir:</para> 
    '''   <para>El separador decimal es la coma [,]. </para>
    '''   <para>El separador de los millares es o bien el punto [.], o bien el espacio [' ']. </para>
    '''   <para>La cadena debe contener únicamente números (no están permitidas las letras),</para>
    '''   <para>Opcionalmente puede llevar un signo más [+] o menos [-] para indicar que el número es positivo o negativo.</para>
    ''' </param>
    ''' <returns>
    '''   <para>Una cadena que contiene escrito en letras el numero pasado</para>
    '''   <para>si el numero es cero (0) devuelve una cadena con el valor [cero] </para>
    '''   <para>si el numero es una cadena vacía [Empty] se devuelve [Empty]</para>
    ''' </returns>
    Function EscribeElNumeroConLetras(ByVal pCadenaNumerica As String) As String



    ''' <summary>
    '''  Escribe en letras un número
    ''' (P.E. 45,23 -> Cuarenta y cinco con veintitrés)
    ''' </summary>
    ''' <param name="pNumero">Un numero decimal. </param>
    ''' <returns>
    '''   <para>Una cadena que contiene escrito en letras el numero pasado</para>
    '''   <para>si el numero es cero (0) devuelve una cadena con el valor [cero]</para>
    '''   <para>si el numero es una cadena vacía [Empty] se devuelve [Empty]</para>
    ''' </returns>
    Function EscribeElNumeroConLetras(ByVal pNumero As Decimal) As String


End Interface
