﻿


'/*
'
' -----------------------------------------------------------------
' IDENTIFICACION.:
'    Versión .....: 2013/02/19
'    Module Name..: OperacionesDatosComunes 
'----------------
'    Creada inicialmente en el proyecto: [NumerosToLetrasDll]
'    Versión de la plantilla de fecha..: [2012-12-12] 
'----------------
'    Lenguaje .: .NET Framework 4.0.30319.18033 - 
'                 Microsoft Visual Basic .NET 2012 - [2013]
'    Usuario ..: AGUILA8 - Joaquin
'
'----------------
' DESCRIPCION.:
'
' Esta clase contiene los datos comunes de las clases 'Operaciones'
' es decir propiedades, y metodos
'
' Tambien funciona como clase abstrata para asegurarme que las 
' clases hijas implementan la funion [EscribeElNumeroConLetras] con los mismos parametros.
'
' En resumen
' Para escribir el numero en letras se usa la clase [OperacionesEscribeNumeroConLetras]
' Para tratar la parte entera esta la clase [OperacionesEscribeLaParteEntera]
' Para tratar la parte decimal esta la clase [OperacionesEscribeLaParteDecimal]
' Para organizar todas las operaciones esta la clase [EscribeConLetrasDirector]
' Para contener los datos comunes a todas ellas esta la clase base [OperacionesDatosComunes]
'
'
'----------------
' OBSERVACIONES.:
'    ### Falta  mas observaciones###
'
'----------------
' INTERFAZ.:
'    Implementa la interfaz IDisposable
'
'----------------
'
'----------------
#Region "Copyright"

' COPYRIGHT.:
'      Copyright (c).:  [2013]  Joaquin 'jms32' Medina Serrano
'      Emilio .......:  mailto:joaquin@medina.name
'      Web ..........:  http://joaquin.medina.name
'
'
'  Yo, titular de los derechos de autor de esta obra, la publico 
'  en los términos de las siguientes licencias:
'
'  A pesar de las ¿Exhaustivas? , ¿Intesas?, 
'  y ¿cuidadosas? (ja, ja, ja..) pruebas a que he  
'  sometido este codigo, el principio de Murphy siempre 
'  esta trabajando y dice que si algo puede ir mal seguro 
'  que va mal. Por esa razon, Este codigo se porporciona 
'  *Como esta* sin ninguna garantia de ninguna clase 
'
'  Este codigo es BirraWare, es decir, si lo empleas, 
'  estas obligado de forma ineludible a:
'  a) Indicar claramente el autor (o sea mi nombre) 
'     y el sitio Web de donde se lo has copiado 
'     (o sea mi web) 
'  b) invitar a una birrita fresquita al creador del mismo
'     (o sea soy yo el que tiene que beberse la cerveza).
'  c) Si no me localizas, me conformo con que me envies 
'     un *emilio* contandome para que lo has empleado.
'     tengo curiosidad por saber por donde circula, 
'     (la curiosidad me puede)
'  d) Si haces algo interesante enviame una copia, me gustaria verlo 
'
' Se autoriza la copia, distribución y modificación de este documento 
' bajo los términos de la licencia de documentación libre GNU,  
' versión 1.2 o cualquier otra que posteriormente publique la  
' Fundación para el Software Libre; sin secciones invariables,  
' textos de portada, ni textos de contraportada.  
' Se incluye una copia de la dicha licencia en la sección titulada  
' Licencia de Documentación Libre GNU. Se puede consultar una copia  
' de la licencia en http://www.gnu.org/copyleft/fdl.html
'
'Este archivo se encuentra bajo la licencia  
' Creative Commons de Atribución/Compartir-Igual 
'Eres libre:
'  - Para compartir – para copiar, distribuir y transmitir el trabajo
'  - Para remezclar – para adaptar el trabajo
' Bajo las siguientes condiciones: 
'  - Atribución – Debes atribuir el trabajo de la manera especificada  
'    por el autor o persona que lo haya licenciado (pero no de manera  
'    que sugiera que estas personas te respaldan o respaldan el uso  
'    que hagas del trabajo).
'  - Compartir similar – En caso de alterar, transformar o ampliar  
'    este trabajo, deberá distribuir el trabajo resultante sólo  
'    bajo la misma licencia o una similar.
'
#End Region
'----------------
' MODIFICACIONES  [aaaa-mm-dd] 
' - 2013/02/19- Creación 
' - 2013/02/19 - Revisado con FxCop 
'
' -----------------------------------------------------------------
'
'*/
'
' -------------------------------------------------
Option Explicit On
Option Strict On
Option Infer Off
Option Compare Binary




''' <summary>
'''   Clase que contiene los campos comunes y las operaciones comunes de las clases
'''   Que escriben la parte entera y la parte decimal de un numero
''' </summary>
''' <remarks>Tiene que heredarse para pode usarse</remarks>
<Serializable()> _
Friend MustInherit Class OperacionesDatosComunes
    Implements IDisposable, INumeroToLetras

    ' una observacion
    ' la case implementa la interfaz [INumeroToLetras]
    ' para implementar de la mimsa manera las funciones
    ' pero en realidad no hace falta porque no se usa para nada
    ' pero ha sido una prueba de concepto
    ' al final como no molesta l ahe dejado


    ''' <summary>
    '''    Cadena que contiene un unico espacio 
    ''' </summary>
    Friend Const ESPACIO As String = " "c


    ''' <summary>
    ''' La cadena que contiene un número que se convierte tal y como se recibe
    ''' </summary>
    Private _CadenaNumericaOriginal As String


    ''' <summary>
    '''  Cadena que contiene la unidad (en plural) que califica 
    '''  a la parte entera del número. Por ejemplo Euros, patatas
    ''' </summary>
    Friend Property NombreUnidadEnPlural As String = String.Empty


    ''' <summary>
    ''' Cadena que contiene la unidad (en singular) que califica 
    ''' a la parte entera del número. Por ejemplo Euro, patata,
    ''' </summary>
    Friend Property NombreUnidadEnSingular As String = String.Empty


    ''' <summary>
    '''  La unidad que califica a la parte entera del número (si existe)
    '''  ¿Es del género masculino o femenino?
    ''' </summary>
    ''' <value>
    '''   <para>Enumeración <see cref="FormatoEscrituraDelUno">FormatoEscrituraDelUno</see></para>
    '''   <para>Indica la forma de escribir una terminación en [uno] por ejemplo [un], [uno, [una]</para>
    '''   <para>Valor por defecto = FormatoEscrituraDelUno.UnoSinSustantivo </para>
    ''' </value>
    Friend Property FormaDeEscribirElUno As FormatoEscrituraDelUno = FormatoEscrituraDelUno.UnoSinSustantivo


    ''' <summary>
    '''  Cadena que contiene un numero INTEGER que representa 
    '''  la parte entera (o decimal) del numero que queremos escribir en letras
    ''' </summary>
    Protected Overridable Property CadenaNumericaCorregida() As String




    ''' <summary>
    ''' La cadena que contiene un número que se convierte tal y como se recibe
    ''' </summary>
    Friend WriteOnly Property CadenaNumericaOriginal As String
        'Get
        '    Return _CadenaNumericaOriginal
        'End Get

        Set(value As String)
            If _CadenaNumericaOriginal <> value Then

                '-----------------------------------------------------
                ' guardar la cadena original tal y como se recibe
                _CadenaNumericaOriginal = value

                '-----------------------------------------------------
                ' Quitar los espacios en blanco que rodeen a la cadena
                value = value.Trim

                ' La puede estar vacia
                If String.IsNullOrWhiteSpace(value) = True Then
                    _CadenaNumericaCorregida = String.Empty
                    ' Throw New ArgumentException("La cadena no contiene nada de nada. Esta vacía.")
                    ' salir de la propiedad dejando los campos dependientes de este valor en situacion incial
                Else
                    ' Hay una cadena numerica, analizarla y cargar las variables dependientes
                    ' --------------------
                    ' Comprobar y corregir la ortografía de la cadena


                    ' signos mas y menos
                    If value.IndexOf("+"c) <> -1 Then
                        Throw New InvalidCadenaNumericaException(
                                   "No se cumple el contrato de la clase. " & Environment.NewLine & _
                                  "La cadena no puede tener el signo mas [+]", value)
                    End If

                    If value.IndexOf("-"c) <> -1 Then
                        Throw New InvalidCadenaNumericaException(
                                     "No se cumple el contrato de la clase. " & Environment.NewLine & _
                                  "La cadena no puede tener el signo menos [-]", value)
                    End If

                    ' separadores de millar 
                    If value.IndexOf("."c) <> -1 Then
                        Throw New InvalidCadenaNumericaException(
                                    "No se cumple el contrato de la clase. " & Environment.NewLine & _
                                  "La cadena no puede tener el separador de millares (punto)[.]", value)
                    End If

                    '  separadores de millar (espacios)
                    If value.IndexOf(" "c) <> -1 Then
                        Throw New InvalidCadenaNumericaException(
                                     "No se cumple el contrato de la clase. " & Environment.NewLine & _
                                  "La cadena no puede tener el separador de millares (espacios)[' ']", value)
                    End If

                    ' el separador decimal
                    If value.IndexOf(","c) <> -1 Then
                        Throw New InvalidCadenaNumericaException(
                             "No se cumple el contrato de la clase. " & Environment.NewLine & _
                           "La parte entera del numero, no puede tener el separador decimal [,]", value)
                    End If



                    ' No se admiten letras
                    For Each caracter As Char In value
                        If Not (Char.IsDigit(caracter)) Then
                            Throw New InvalidCadenaNumericaException(
                                        "No se cumple el contrato de la clase. " & Environment.NewLine & _
                                      "La cadena solo debe contener dígitos numéricos (0-9)", value)
                        End If
                    Next


                    '------------------
                    ' Asignar el valor a la propiedad
                    _CadenaNumericaCorregida = value

                End If ' / -->Value <> empty
            End If
        End Set
    End Property


#Region " Funciones que tienen que escribirse en las clases derivadas"

    ''' <summary>
    '''   Escribe en letras el número pasado en el parametro
    ''' </summary>
    Friend MustOverride Overloads Function EscribeElNumeroConLetras(ByVal pCadenaNumerica As String) As String Implements INumeroToLetras.EscribeElNumeroConLetras

    ''' <summary>
    '''   Escribe en letras el número pasado en el parametro
    ''' </summary>
    Friend MustOverride Overloads Function EscribeElNumeroConLetras() As String Implements INumeroToLetras.EscribeElNumeroConLetras

  

    Private Overloads Function EscribeElNumeroConLetras(pNumero As Decimal) As String Implements INumeroToLetras.EscribeElNumeroConLetras
        Throw New NotImplementedException("las clases operaciones no trabajan NUNCA con numeros solo con cadenas de numeros")
    End Function



#End Region



#Region "Implementacion interfaz [Dispose]  [2012-12-04] "


    ' ''' <summary>
    ' ''' Un objeto administrado es un objeto de .NET que maneja el motor de 
    ' ''' ejecucion de NET, por ejemplo cualquier objeto de .NET
    ' ''' </summary>
    'Private Sub DisposeObjetosAdministrados()
    '    '--------------------------------
    '    '--------------------------------
    '    ' --> Liberar objetos administrados), 
    '    '     por ejemplo cualquier objeto de .NET
    '    '--------------------------------
    '    '--------------------------------
    '    'If Not (Me._Arbol Is Nothing) Then
    '    '    If _Arbol.IsDisposed = False Then
    '    '        _Arbol.Dispose()
    '    '    End If
    '    '    Me._Arbol = Nothing
    '    'End If
    'End Sub


    ''' <summary>
    '''  Establecer campos grandes como Null.
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub DisposeCamposGrandesToNothing()
        '--------------------------------
        ' --> Establecer campos grandes como Nothing.
        '     es decir todos los campos de la clase
        '--------------------------------
        Me._CadenaNumericaOriginal = Nothing
        Me._CadenaNumericaCorregida = Nothing
        Me._FormaDeEscribirElUno = Nothing
        Me._NombreUnidadEnPlural = Nothing
        Me._NombreUnidadEnSingular = Nothing
    End Sub


    ' ''' <summary>
    ' '''  Si la clase derivada usa objetos NO administrados, debe reemplazar esta funcion
    ' '''  Un objeto no administrado  es un recurso que NO administra el motor en  
    ' '''  tiempo de ejecución, como identificadores de  ventanas (HWND),  
    ' '''  conexiones a bases de datos, un objeto creado directamente  
    ' '''  llamando al API de Windows, etc. el Word o Excel
    ' ''' </summary>
    'Private Sub DisposeObjetosNOAdministrados()
    '    Throw New NotImplementedException("DisposeObjetosNOAdministrados - No esta escrita")

    '    '--------------------------------
    '    ' --> Liberar objetos NO administrados).
    '    '       por ejemplo una base de datos
    '    '       Solamente hay que llamar a su método [Dispose]
    '    '--------------------------------
    '    '--------------------------------
    '    'If Not (Me.connection Is Nothing) Then
    '    '    'Close conexión'
    '    '    If connection.IsDisposed = False Then
    '    '        connection.Dispose()
    '    '    End If
    '    '    '¡¡OJITO !! no se hace Nothing
    '    'End If
    '    '--------------------------------
    'End Sub


    ' *******************************************************
    ' *******************************************************


    '  Variable y propiedad para saber si se ha diposado :-) o no
    '  es una variable que actua de semaforo, solo deja pasar una vez
    '----------------------------------------
    ' Apunte Táctico
    '----------------------------------------
    ' Si se borra el atributo [<Serializable()>] de la clase
    ' También hay que borrar el atributo [<NonSerialized()>] 
    ' de la variable [_disposedValue] que esta a continuación
    '----------------------------------------



    'Private _isDisposed As Boolean ' = False (no hace falta inicializar) 
    <NonSerialized()> Private _isDisposed As Boolean ' = False (no hace falta inicializar) 


    ''' <summary>
    '''     Obtiene un valor que indica si el objeto se ha eliminado. 
    ''' </summary>
    ''' <value>
    '''   <para>Tipo: <see cref="System.Boolean">Boolean</see></para>
    '''   <para>Es true si objeto se ha eliminado; en caso contrario, es false.</para>
    ''' </value>
    ''' <remarks>
    ''' <para> Cuando esta propiedad devuelve true, el objeto se elimina y ya
    '''        no se puede hacer referencia al mismo como un objeto válido. </para>  
    ''' <para> Aunque se elimine la instancia de un objeto, ésta se guarda en 
    '''        la memoria hasta que el recolector de elementos no utilizados 
    '''        la quite de la memoria.</para>  
    '''</remarks>
    Public Overloads Property IsDisposed() As Boolean
        Get
            Return _isDisposed
        End Get
        Private Set(ByVal value As Boolean)
            _isDisposed = value
        End Set
    End Property


    ''' <summary>
    '''     Destructor del objeto
    ''' </summary>
    Protected Overrides Sub Finalize()
        ' Este método se invoca de forma automática, después de 
        ' que un objeto pase a ser inaccesible, salvo que haya  
        ' sido excluido del proceso de finalización mediante una  
        ' llamada a GC.SuppressFinalize. 
        ' -----------------------------------------------------
        ' escenario en el que el Sistema llama al metodo dispose
        ' -----------------------------------------------------
        Try
            Me.Dispose(False)
        Finally
            MyBase.Finalize()
        End Try
    End Sub


    ''' <summary>
    '''   Realiza tareas definidas por la aplicación asociadas a 
    '''   la liberación o al restablecimiento de recursos no administrados
    ''' </summary>
    Public Overloads Sub Dispose() Implements System.IDisposable.Dispose
        ' No hacer este metodo virtual.   
        ' Una clase derivada no debe ser capaz de reemplazar este metodo.    
        ' -----------------------------------------------------
        ' escenario en el que el usuario llama al metodo dispose
        ' -----------------------------------------------------
        ' No cambie este código. Coloque el código de limpieza en Dispose (ByVal que se dispone como Boolean).
        Me.Dispose(True)
        ' Decir al recolecto que no llame al destructor de este objeto
        ' porque este objeto ya esta [finalizado]
        GC.SuppressFinalize(Me)
    End Sub


    '--------------------------------------------------------------------
    ' Dispose (bool quienLLama) se ejecuta en dos escenarios distintos.
    ' Si [quienMeLLama] es igual a true, el método ha sido llamado directamente
    ' O indirectamente por el código de un usuario. 
    ' Los recursos administrados y no administrados Se puede eliminar.
    ' Si [quienMeLLama]es igual a false, el método ha sido llamado por el
    ' [runtime] desde el interior del finalizador y usted no debe hacer 
    ' referencia a otros objetos, ni siquiera para eliminarlos.
    ' Solo los recursos no administrados pueden ser eliminados.
    '--------------------------------------------------------------------
    ''' <summary>
    '''   Realiza tareas definidas por la aplicación asociadas a 
    '''   la liberación o al restablecimiento de recursos no administrados
    ''' </summary>
    ''' <remarks>
    ''' <para> ¡¡PROBLEMA!! Esta función debe tener el calificador [Overridable]</para>
    ''' <para>              pero si la clase está marcada como [NotInheritable] </para>
    ''' <para>              da error. En ese caso se puede quitar               </para>
    ''' <code>http://msdn.microsoft.com/es-es/magazine/cc163392.aspx</code>
    '''</remarks>
    Protected Overridable Overloads Sub Dispose(ByVal quienMeLLama As Boolean)
        ' Comprueba si Dispose ya ha sido llamado.  
        ' Solo se ejecuta una vez y solo una
        If Not Me.IsDisposed Then
            Try
                ' -------------------------------
                If quienMeLLama = True Then
                    ' -------------------------------
                    ' 1) Proceso de eliminar recursos SI administrados
                    ' -------------------------------
                    'Call DisposeObjetosAdministrados()
                End If
                ' -------------------------------
                ' 2) Proceso de eliminar recursos NO administrados
                'Call DisposeObjetosNOAdministrados()
                ' -------------------------------
                ' 3) Proceso de eliminar cadenas grandes
                Call DisposeCamposGrandesToNothing()
                ' -------------------------------
                ' 4) TODO:  Proceso de llamar al dispose de la clase base
                ' -------------------------------
                'Call MyBase.Dispose()

            Finally
                ' Cerrar la puerta, solo se pasa una vez
                IsDisposed = True
            End Try
        End If
    End Sub


#End Region




   
End Class
