﻿

'/*
'
' -----------------------------------------------------------------
' IDENTIFICACION.:
'    Versión .....: 2013/02/19
'    Module Name..: OperacionesEscribeLaParteDecimal 
'----------------
'    Creada inicialmente en el proyecto: [NumerosToLetrasDll]
'    Versión de la plantilla de fecha..: [2012-12-12] 
'----------------
'    Lenguaje .: .NET Framework 4.0.30319.18033 - 
'                 Microsoft Visual Basic .NET 2012 - [2013]
'    Usuario ..: AGUILA8 - Joaquin
'
'----------------
' DESCRIPCION.:
'
'En resumen
' Para escribir el numero en letras se usa la clase [OperacionesEscribeNumeroConLetras]
' Para tratar la parte entera esta la clase [OperacionesEscribeLaParteEntera]
' Para tratar la parte decimal esta la clase [OperacionesEscribeLaParteDecimal]
' Para organizar todas las operaciones esta la clase [EscribeConLetrasDirector]
' Para contener los datos comunes a todas ellas esta la clase base [OperacionesDatosComunes]
'
' Esta clase se encarga de escribir en letras la parte decimal del numero que queremos escribir en letras.
' Encapsula todo el proceso de escribir la parte decimal de un numero
' en realidad escribe en letras un numero y lo trata como un numero integer
' además le añade las unidades (o el nombre calificador de la cantidad) si esta definido.
' es una clase de trabajo que funciona como clase contenida por la clase [EscribeBase]
'
' Para escribir los números usa la clase 'contenida' [OperacionesEscribeNumeroConLetras]
'
' Si los decimales no llevan unidades se pone las unidades por defecto para evitar ambigüedades
' Por ejemplo las cifras 2,2 y 2,02  se escriben en letras de la misma forma 
' [dos con dos] sin embargo hace falta la unidad para diferenciarlas.
' [dos con dos decimas] [dos con dos centésimas]
'
' Si la cadena es un cero(0) devuelve una cadena con el valor [cero]
' Si la cadena tiene el valor [Empty] se  devuelve una cadena con el valor [Empty]
'
' La clase puede escribir y nombrar cualquier cantidad de números decimales, 
' pero las unidades estándar de los números decimales solo se nombran 
' hasta la 60 cifra decimal,  que corresponde a las [vigentillonésimas],
' las cantidades mas 'pequeñas' se muestran en formato de múltiplos 
' de 10 de esta manera --> veintitrés [10^(-63)]llonésimas
'
'----------------
' OBSERVACIONES.:
'    ### Falta  mas observaciones###
'
'----------------
' INTERFAZ.:
'    Implementa la interfaz IDisposable
'
'----------------
' BIBLIOGRAFIA.:
'  Anexo:Nombres de los números en español
'  http://es.wikipedia.org/wiki/Nombres_de_los_n%C3%BAmeros_en_espa%C3%B1ol
'
'----------------
#Region "Copyright"

' COPYRIGHT.:
'      Copyright (c).:  [2013]  Joaquin 'jms32' Medina Serrano
'      Emilio .......:  mailto:joaquin@medina.name
'      Web ..........:  http://joaquin.medina.name
'
'
'  Yo, titular de los derechos de autor de esta obra, la publico 
'  en los términos de las siguientes licencias:
'
'  A pesar de las ¿Exhaustivas? , ¿Intesas?, 
'  y ¿cuidadosas? (ja, ja, ja..) pruebas a que he  
'  sometido este codigo, el principio de Murphy siempre 
'  esta trabajando y dice que si algo puede ir mal seguro 
'  que va mal. Por esa razon, Este codigo se porporciona 
'  *Como esta* sin ninguna garantia de ninguna clase 
'
'  Este codigo es BirraWare, es decir, si lo empleas, 
'  estas obligado de forma ineludible a:
'  a) Indicar claramente el autor (o sea mi nombre) 
'     y el sitio Web de donde se lo has copiado 
'     (o sea mi web) 
'  b) invitar a una birrita fresquita al creador del mismo
'     (o sea soy yo el que tiene que beberse la cerveza).
'  c) Si no me localizas, me conformo con que me envies 
'     un *emilio* contandome para que lo has empleado.
'     tengo curiosidad por saber por donde circula, 
'     (la curiosidad me puede)
'  d) Si haces algo interesante enviame una copia, me gustaria verlo 
'
' Se autoriza la copia, distribución y modificación de este documento 
' bajo los términos de la licencia de documentación libre GNU,  
' versión 1.2 o cualquier otra que posteriormente publique la  
' Fundación para el Software Libre; sin secciones invariables,  
' textos de portada, ni textos de contraportada.  
' Se incluye una copia de la dicha licencia en la sección titulada  
' Licencia de Documentación Libre GNU. Se puede consultar una copia  
' de la licencia en http://www.gnu.org/copyleft/fdl.html
'
'Este archivo se encuentra bajo la licencia  
' Creative Commons de Atribución/Compartir-Igual 
'Eres libre:
'  - Para compartir – para copiar, distribuir y transmitir el trabajo
'  - Para remezclar – para adaptar el trabajo
' Bajo las siguientes condiciones: 
'  - Atribución – Debes atribuir el trabajo de la manera especificada  
'    por el autor o persona que lo haya licenciado (pero no de manera  
'    que sugiera que estas personas te respaldan o respaldan el uso  
'    que hagas del trabajo).
'  - Compartir similar – En caso de alterar, transformar o ampliar  
'    este trabajo, deberá distribuir el trabajo resultante sólo  
'    bajo la misma licencia o una similar.
'
#End Region
'----------------
' MODIFICACIONES  [aaaa-mm-dd] 
' - 2013/02/19- Creación 
' - 2013/02/19 - Revisado con FxCop 
'
' -----------------------------------------------------------------
'
'*/
'
' -------------------------------------------------
Option Explicit On
Option Strict On
Option Infer Off
Option Compare Binary




''' <summary>
'''   Clase que escribe un la parte decimal del un numero que queremos escribir en letras. 
'''   Incluida la unidad si la tiene
'''   En realidad escribe un numero entero sin problemas
'''   Es una clase contenida por la clase [escritorBase]
'''   encapsula todo el proceso de escribir la parte decimal de un numero
''' </summary>
<Serializable()> _
Friend Class OperacionesEscribeLaParteDecimal
    Inherits OperacionesDatosComunes
    Implements IDisposable



#Region "Variables de la clase"





    ''' <summary>
    '''  Cadena que contiene un numero INTEGER que representa 
    '''  la parte DECIMAL del numero que queremos escribir en letras 
    ''' (si existe, o [Empty] si no existe)
    ''' </summary>
    ''' <remarks>
    '''  Al cargarla se quitan los ceros no significativos de la derecha
    '''  por ejemplo 0,10 y 0,1000 tienen el mimso valor = 0,1
    '''</remarks>
    Friend Shadows Property CadenaNumericaCorregida() As String
        Get
            Return MyBase.CadenaNumericaCorregida
        End Get

        Set(value As String)
            If MyBase.CadenaNumericaCorregida <> value Then

                ' La puede estar vacia
                If String.IsNullOrWhiteSpace(value) = True Then
                    MyBase.CadenaNumericaCorregida = String.Empty
                    ' Throw New ArgumentException("La cadena no contiene nada de nada. Esta vacía.")
                    ' salir de la propiedad dejando los campos dependientes de este valor en situacion incial
                Else
                    ' Hay una cadena numerica               
                    '--------------------------
                    ' Comprobar y corregir la ortografía de la cadena
                    ' signos mas y menos
                    ' separadores de millar 
                    ' el separador decimal
                    ' No se admiten letras
                    MyBase.CadenaNumericaCorregida = value

                    '------------------------------
                    ' Correcciones parteDecimal
                    ' Observa que primero compruebo que la cadena sea correcta antes de hacer las correcciones
                    '--------------------------------
                    '---------------------------
                    ' ¡¡ Atencion !!
                    ' En los decimales, los ceros a la derecha no tienen valor
                    ' Ejemplo 0,10 y 0,1000 tienen el mimso valor = 0,1
                    ' Es decir, hay que eliminar los ceros de la derecha
                    '---------------------------
                    Do While MyBase.CadenaNumericaCorregida.EndsWith("0"c, StringComparison.OrdinalIgnoreCase) = True
                        MyBase.CadenaNumericaCorregida = MyBase.CadenaNumericaCorregida.Substring(0, MyBase.CadenaNumericaCorregida.Length - 1)
                    Loop

                End If

            End If
        End Set
    End Property


    ''' <summary>
    '''   El valor por defecto   que indica que los decimales no se ajustan 
    '''   no se tratan de manera especial, sino que se usan los que llegan.
    ''' </summary>
    Public Const DECIMALES_OBLIGATORIOS_VALOR_POR_DEFECTO As Integer = -1

    '---------------------------------------
    '---------------------------------------
    ''' <summary>
    '''  Numero de decimales que obligatoriamente debe tener el numero. 
    '''  Valor por defecto= -1 significa que no se controla este valor
    ''' </summary>
    Private _numeroDecimalesObligatorios As Integer = DECIMALES_OBLIGATORIOS_VALOR_POR_DEFECTO

    ''' <summary>
    '''  Numero de decimales que obligatoriamente debe tener el numero. 
    '''  Por ejemplo los EUROS tienen SIEMPRE dos decimales
    '''  Valor por defecto= -1 significa que no se controla este valor
    '''  el numero puede tener (o no) cualquier numero de decimales
    ''' </summary>
    Friend Property NumeroDeDecimalesObligatorios As Integer
        Get
            Return _numeroDecimalesObligatorios
        End Get
        Set(value As Integer)
            '-------------------------------
            If value < 1 Then
                value = DECIMALES_OBLIGATORIOS_VALOR_POR_DEFECTO
            End If
            '---------
            _numeroDecimalesObligatorios = value
        End Set
    End Property



    ''' <summary>
    '''  Esta función se asegura que la cadena que contiene la parte decimal 
    '''  del numero, tenga exactamente los decimales requeridos por el formato del numero
    ''' </summary>
    ''' <param name="pCadenaParteDecimalAAnalizar">La cadena que se va a analizar</param>
    ''' <param name="pNumeroDecimalesObligatorios">Los caracteres que OBLIGATORIAMENTE debe tener</param>
    ''' <returns>Una cadena con el tamaño deseado</returns>
    ''' <remarks>
    ''' <para>Esta función se asegura que la cadena que contiene la parte decimal 
    '''       del numero, tenga exactamente los decimales requeridos por el formato del numero.</para>
    ''' <para>Se recibe una cadena por ejemplo 1234, que representa a la parte 
    '''       decimal del numero, (sin coma decimal), si debe tener tres decimales,  
    '''       la cadena se corta (sin redondear) a tres decimales.  
    '''       Si debe terner cinco decimales se añaden ceros por la derecha  
    '''       hasta que tenga la cantidad deseada.</para>
    ''' <para>Por ejemplo. Los euros tienen SIEMPRE dos decimales</para>
    ''' <para>La razón de esta función es que cuando se analiza el numero y se  
    '''       separa en sus componentes (parte entera y parte decimal), las  
    '''       partes se simplifican, es decir, a la parte entera se le quitan  
    '''       los ceros no significativos por la izquierda  0012 = 12,  
    '''       mientras que a la parte decimal se le quitan los ceros no  
    '''       significativos por la derecha 0,210000 = 0,21. </para> 
    ''' <para>Y estos valores son los que se usan para escribir en letras los números.  </para>
    ''' <para>El problema se plantea cuando existen cantidades que exigen  
    '''       necesariamente un número exacto de decimales, por ejemplo euros.  
    '''       Si se recibe la cadena 22,20, se espera la cadena veintidós con veinte,  
    '''       sin embargo por el proceso de simplificación, el resultado de la  
    '''       operación de escribir el numero en letras será: veintidós con uno. </para>
    ''' <para>Este proceso y la variable miembro [NumeroDeDecimalesObligatorios]  
    '''       se lanzan en el caso de que exista una modificación del valor de  
    '''       la propiedad, que siempre ocurrirá después del constructor. </para>
    ''' <para>Existe la posibilidad alternativa de modificar la cantidad sobre  
    '''       la marcha sin crear una nueva clase, por esa razón, esta función  
    '''       se llama también cuando se carga la parte decimal del número</para>
    '''</remarks>
    Private Shared Function ControlDecimalesObligatorios(
                            ByVal pCadenaParteDecimalAAnalizar As String,
                            ByVal pNumeroDecimalesObligatorios As Integer) _
                        As String
        '----------------
        Dim valorDevuelto As String = pCadenaParteDecimalAAnalizar

        If String.IsNullOrWhiteSpace(valorDevuelto) = True Then
            valorDevuelto = String.Empty
        Else

            If pNumeroDecimalesObligatorios <> DECIMALES_OBLIGATORIOS_VALOR_POR_DEFECTO Then
                If valorDevuelto.Length > pNumeroDecimalesObligatorios Then
                    valorDevuelto = valorDevuelto.Substring(0, pNumeroDecimalesObligatorios)
                End If
                If valorDevuelto.Length < pNumeroDecimalesObligatorios Then
                    Do While (valorDevuelto.Length < pNumeroDecimalesObligatorios)
                        valorDevuelto = valorDevuelto & "0"c
                    Loop
                End If
            End If

        End If
        Return valorDevuelto
    End Function

#End Region

#Region "Constructores"


    ''' <summary>
    '''   Constructor
    ''' </summary>
    ''' <remarks></remarks>
    Friend Sub New()
        Me.new(String.Empty)
    End Sub


    Friend Sub New(ByVal pCadenaNumerica As String)
        Me.CadenaNumericaCorregida = pCadenaNumerica
    End Sub


    'Private Sub New(ByVal pCadenaNumerica As String,
    '               ByVal pNombreUnidadParteDecimalPlural As String,
    '               ByVal pNombreUnidadParteDecimalSingular As String,
    '               ByVal pFormatoEscrituraParteDecimal As FormatoEscrituraDelUno,
    '               ByVal pNumeroDeDecimalesObligatorios As Integer)

    '    Me.CadenaNumericaParteDecimal = pCadenaNumerica
    '    Me.NombreUnidadParteDecimalPlural = pNombreUnidadParteDecimalPlural
    '    Me.NombreUnidadParteDecimalSingular = pNombreUnidadParteDecimalSingular
    '    Me.FormatoEscrituraParteDecimal = pFormatoEscrituraParteDecimal
    '    Me.NumeroDeDecimalesObligatorios = pNumeroDeDecimalesObligatorios
    'End Sub

#End Region

#Region "EscribeElNumeroConLetras"


    ''' <summary>
    '''   Escribe en letras el número pasado en el parametro (P.E. 23 ->  veintitres)
    ''' </summary>
    ''' <remarks>
    '''  <para> Calficador [overrides] para sobreescribir 
    '''         la funcion [MustOverride] de la clase base</para>
    ''' </remarks>
    Friend Overloads Overrides Function EscribeElNumeroConLetras(ByVal pCadenaNumerica As String) As String
        Me.CadenaNumericaCorregida = pCadenaNumerica
        Return Me.EscribeElNumeroConLetras()
    End Function


    ''' <summary>
    '''   Escribe en letras el número pasado en el constructor (P.E. 23 -> veintitres)
    ''' </summary>
    ''' <remarks>
    '''  <para> Calficador [overrides] para sobreescribir 
    '''         la funcion [MustOverride] de la clase base</para>
    ''' </remarks>
    Friend Overloads Overrides Function EscribeElNumeroConLetras() As String

        If String.IsNullOrWhiteSpace(Me.CadenaNumericaCorregida) = True Then
            Return String.Empty
        End If

        Dim cadenaConElResultado As String = String.Empty
        Dim auxCadenaNumericaParteDecimal As String = String.Empty

        '--------------------
        ' Observacion
        ' Si las cadenas que contienen las unidades son cadenas vacias [empty]
        ' quiere decir qeu no se usan unidades decimlaes
        ' por lo que se usan las unidades por defecto
        ' y en ese caso las unidades son femeninas ( decimas, centesimas, ect)
        If Me.NombreUnidadEnSingular = String.Empty AndAlso
           Me.NombreUnidadEnPlural = String.Empty Then
            If Me.FormaDeEscribirElUno <> FormatoEscrituraDelUno.UnaConSustantivoFemenino Then
                Me.FormaDeEscribirElUno = FormatoEscrituraDelUno.UnaConSustantivoFemenino
            End If
        End If


        '--------------------------
        ' uso un variable local porque la variable [CadenaNumericaParteDecimal]
        ' esta simplificada [recuerda 0,120 , 0120000 -->> 0,12]
        ' Existen algunos problemas especificos
        ' por ejemplo 0,1 Euro> tiene que tratarse como 0,10 para que la funcion devuelva [con diez centimos]
        ' si no se hace asi se obtiene [con un decimo] que (en este caso concreto como se exigen DOS decimales) es erroneo
        '--------------------------
        auxCadenaNumericaParteDecimal = ControlDecimalesObligatorios(Me.CadenaNumericaCorregida, Me.NumeroDeDecimalesObligatorios)
        'cadenaConElResultado = escritorNumeros.EscribeElNumeroConLetras(auxCadenaNumericaParteDecimal, Me.FormaDeEscribirElUno)
        '--------------------------
        Using escritorNumeros As New OperacionesEscribeNumeroConLetras

            escritorNumeros.CadenaNumericaOriginal = auxCadenaNumericaParteDecimal
            escritorNumeros.FormaDeEscribirElUno = Me.FormaDeEscribirElUno

            cadenaConElResultado = escritorNumeros.EscribeElNumeroConLetras()

            ' poner la palabra [unidades]
            If cadenaConElResultado.Length > 0 Then
                cadenaConElResultado = cadenaConElResultado & ESPACIO & Me.GetNombreUnidadParteDecimal(auxCadenaNumericaParteDecimal)
            End If
        End Using

        '--------------------------
        Return cadenaConElResultado

    End Function

#End Region

#Region "Nombre de las unidades de la parte decimal"



    Private Function GetNombreUnidadParteDecimal(pCantidadDecimal As String) As String

        Dim resultado As String = String.Empty

        Dim numero As Decimal = Decimal.Zero

        If NombreUnidadEnPlural = String.Empty Then
            ' tomar el valor por defecto
            resultado = GetNombreUnidadParteDecimalPorDefecto(pCantidadDecimal)
        Else
            resultado = NombreUnidadEnPlural ' "centimos"
        End If

        If Decimal.TryParse(pCantidadDecimal, numero) = True Then
            If numero = 1 Then
                If NombreUnidadEnPlural = String.Empty Then
                    ' tomar el valor por defecto
                    resultado = GetNombreUnidadParteDecimalPorDefecto(pCantidadDecimal)
                Else
                    resultado = NombreUnidadEnSingular ' "centimo"
                End If
            End If
            If numero = 0 Then
                resultado = String.Empty
            End If
        End If

        ' devolver la unidad
        Return resultado
    End Function



    ''' <summary>
    '''  Devuelve el nombre de la unidad de la parte DECIMAL de la cifra 
    '''  la devuelve en singular o plural segun el contexto
    '''  Por ejemplo [centimo] [centimos] SIN LA CANTIDAD, solo la unidad 
    ''' </summary>
    ''' <param name="pCantidadDecimal">La cadena que contiene el numero del que queremos obtener la unidad</param>
    ''' <returns>
    ''' Unicamente la unidad que corresponde
    ''' Por ejemplo [centimo] [centimos] SIN LA CANTIDAD, solo la unidad  </returns>
    ''' <remarks>
    '''    <para> Lista de los primeros nombres de las unidades decimales                   </para>
    '''    <para> "décima",                 "centésima",              "milésima",           </para> 
    '''    <para> "diezmilésima",           "cienmilésima",           "millonésima",        </para> 
    '''    <para> "diezmillonésima",        "cienmillonésima",        "milmillonésima",     </para> 
    '''    <para> "diezmilmillonésima",     "cienmilmillonésima",     "billonésima",        </para> 
    '''    <para> "diezbillonésima",        "cienbillonésima",        "milbillonésima",     </para> 
    '''    <para> "diezmilbillonésima",     "cienmilbillonésima",     "trillonésima",       </para> 
    '''    <para> "dieztrillonésima",       "cientrillonésima",       "miltrillonésima",    </para> 
    '''    <para> "diezmiltrillonésima",    "cienmiltrillonésima",    "cuatrillonésima",    </para> 
    '''    <para> "diezcuatrillonésima",    "ciencuatrillonésima",    "milcuatrillonésima", </para> 
    '''    <para> "diezmilcuatrillonésima", "cienmilcuatrillonésima", "quintillonésima",    </para> 
    '''    <para> "diezquintillonésima",    "cienquintillonésima",    "milquintillonésima", </para> 
    '''    <para> "diezmilquintillonésima", "cienmilquintillonésima", "sextillonésima",     </para> 
    '''    <para> "diezsextillonésima",     "ciensextillonésima",     "milsextillonésima",  </para> 
    '''    <para> "diezmilsextillonésima",  "cienmilsextillonésima",  "septillonésima",     </para> 
    '''    <para> "diezseptillonésima",     "cienseptillonésima",     "milseptillonésima",  </para> 
    '''    <para> "diezmilseptillonésima",  "cienmilseptillonésima",  "octillonésima",      </para> 
    '''    <para> "diezoctillonésima",      "cienoctillonésima",      "miloctillonésima",   </para> 
    '''    <para> "diezmiloctillonésima",   "cienmiloctillonésima",   "novillonésima",      </para> 
    '''    <para> "dieznovillonésima",      "ciennovillonésima",      "milnovillonésima",   </para> 
    '''    <para> "diezmilnovillonésima",   "cienmilnovillonésima",   "vigentillonésima"    </para> 
    '''</remarks>
    Private Shared Function GetNombreUnidadParteDecimalPorDefecto(ByVal pCantidadDecimal As String) As String

        Const PLURAL As String = "s"c

        Dim decimales() As String = {"", "décima", "centésima", "milésima",
                                     "diezmilésima", "cienmilésima", "millonésima",
                                     "diezmillonésima", "cienmillonésima", "milmillonésima",
                                     "diezmilmillonésima", "cienmilmillonésima", "billonésima",
                                     "diezbillonésima", "cienbillonésima", "milbillonésima",
                                     "diezmilbillonésima", "cienmilbillonésima", "trillonésima",
                                     "dieztrillonésima", "cientrillonésima", "miltrillonésima",
                                     "diezmiltrillonésima", "cienmiltrillonésima", "cuatrillonésima",
                                     "diezcuatrillonésima", "ciencuatrillonésima", "milcuatrillonésima",
                                     "diezmilcuatrillonésima", "cienmilcuatrillonésima", "quintillonésima",
                                     "diezquintillonésima", "cienquintillonésima", "milquintillonésima",
                                     "diezmilquintillonésima", "cienmilquintillonésima", "sextillonésima",
                                     "diezsextillonésima", "ciensextillonésima", "milsextillonésima",
                                     "diezmilsextillonésima", "cienmilsextillonésima", "septillonésima",
                                     "diezseptillonésima", "cienseptillonésima", "milseptillonésima",
                                     "diezmilseptillonésima", "cienmilseptillonésima", "octillonésima",
                                     "diezoctillonésima", "cienoctillonésima", "miloctillonésima",
                                     "diezmiloctillonésima", "cienmiloctillonésima", "novillonésima",
                                     "dieznovillonésima", "ciennovillonésima", "milnovillonésima",
                                     "diezmilnovillonésima", "cienmilnovillonésima", "vigentillonésima"}

        'Dim decimalesPlural() As String = {"", "décimas", "centésimas", "milésimas", "millonésimas",
        '                                   "billonésimas", "trillonésimas", "cuatrillonésimas",
        '                                   "quintillonésimas", "sextillonésimas", "septillonésimas"}

        ' ----------------------
        ' cadena que se devuelve
        Dim cadenaUnidad As String = String.Empty

        If String.IsNullOrWhiteSpace(pCantidadDecimal) = False Then

            Dim posicion As Integer = pCantidadDecimal.Length
            ' Localizar la posicion de la unidad en fucnion del tamaño de la cadena
            If posicion <= decimales.GetUpperBound(0) Then
                Dim numero As Decimal = Decimal.Zero
                If Decimal.TryParse(pCantidadDecimal, numero) = True Then
                    Select Case numero
                        Case Is = 0
                            cadenaUnidad = String.Empty
                        Case Is = 1
                            cadenaUnidad = decimales(posicion)
                        Case Else
                            cadenaUnidad = decimales(posicion) & PLURAL
                    End Select
                Else
                    ' el numero es muy grande y falla al covertirlo
                    cadenaUnidad = decimales(posicion) & PLURAL
                End If
            Else
                ' el numero es muy grande y no se contempla la unidad 
                ' en la matriz con la lista de unidades
                cadenaUnidad = String.Format(System.Globalization.CultureInfo.InvariantCulture,
                                             "[10^(-{0})]llonésimas",
                                             posicion)
            End If
        End If
        Return cadenaUnidad

    End Function



#End Region

#Region "Implementacion interfaz [Dispose]  [2012-12-04] "


    ' ''' <summary>
    ' ''' Un objeto administrado es un objeto de .NET que maneja el motor de 
    ' ''' ejecucion de NET, por ejemplo cualquier objeto de .NET
    ' ''' </summary>
    'Private Sub DisposeObjetosAdministrados()
    '    '--------------------------------
    '    '--------------------------------
    '    ' --> Liberar objetos administrados), 
    '    '     por ejemplo cualquier objeto de .NET
    '    '--------------------------------
    '    '--------------------------------
    '    'If Not (Me._Arbol Is Nothing) Then
    '    '    If _Arbol.IsDisposed = False Then
    '    '        _Arbol.Dispose()
    '    '    End If
    '    '    Me._Arbol = Nothing
    '    'End If
    'End Sub


    ''' <summary>
    '''  Establecer campos grandes como Null.
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub DisposeCamposGrandesToNothing()
        '--------------------------------
        ' --> Establecer campos grandes como Nothing.
        '     es decir todos los campos de la clase
        '--------------------------------
        'Me._CadenaGrande = Nothing
        Me._numeroDecimalesObligatorios = Nothing
    End Sub


    ' ''' <summary>
    ' '''  Si la clase derivada usa objetos NO administrados, debe reemplazar esta funcion
    ' '''  Un objeto no administrado  es un recurso que NO administra el motor en  
    ' '''  tiempo de ejecución, como identificadores de  ventanas (HWND),  
    ' '''  conexiones a bases de datos, un objeto creado directamente  
    ' '''  llamando al API de Windows, etc. el Word o Excel
    ' ''' </summary>
    'Private Sub DisposeObjetosNOAdministrados()
    '    Throw New NotImplementedException("DisposeObjetosNOAdministrados - No esta escrita")

    '    '--------------------------------
    '    ' --> Liberar objetos NO administrados).
    '    '       por ejemplo una base de datos
    '    '       Solamente hay que llamar a su método [Dispose]
    '    '--------------------------------
    '    '--------------------------------
    '    'If Not (Me.connection Is Nothing) Then
    '    '    'Close conexión'
    '    '    If connection.IsDisposed = False Then
    '    '        connection.Dispose()
    '    '    End If
    '    '    '¡¡OJITO !! no se hace Nothing
    '    'End If
    '    '--------------------------------
    'End Sub


    ' *******************************************************
    ' *******************************************************


    '  Variable y propiedad para saber si se ha diposado :-) o no
    '  es una variable que actua de semaforo, solo deja pasar una vez
    '----------------------------------------
    ' Apunte Táctico
    '----------------------------------------
    ' Si se borra el atributo [<Serializable()>] de la clase
    ' También hay que borrar el atributo [<NonSerialized()>] 
    ' de la variable [_disposedValue] que esta a continuación
    '----------------------------------------



    'Private _isDisposed As Boolean ' = False (no hace falta inicializar) 
    <NonSerialized()> Private _isDisposed As Boolean ' = False (no hace falta inicializar) 


    ''' <summary>
    '''     Obtiene un valor que indica si el objeto se ha eliminado. 
    ''' </summary>
    ''' <value>
    '''   <para>Tipo: <see cref="System.Boolean">Boolean</see></para>
    '''   <para>Es true si objeto se ha eliminado; en caso contrario, es false.</para>
    ''' </value>
    ''' <remarks>
    ''' <para> Cuando esta propiedad devuelve true, el objeto se elimina y ya
    '''        no se puede hacer referencia al mismo como un objeto válido. </para>  
    ''' <para> Aunque se elimine la instancia de un objeto, ésta se guarda en 
    '''        la memoria hasta que el recolector de elementos no utilizados 
    '''        la quite de la memoria.</para>  
    '''</remarks>
    Public Overloads Property IsDisposed() As Boolean
        Get
            Return _isDisposed
        End Get
        Private Set(ByVal value As Boolean)
            _isDisposed = value
        End Set
    End Property


    ''' <summary>
    '''     Destructor del objeto
    ''' </summary>
    Protected Overrides Sub Finalize()
        ' Este método se invoca de forma automática, después de 
        ' que un objeto pase a ser inaccesible, salvo que haya  
        ' sido excluido del proceso de finalización mediante una  
        ' llamada a GC.SuppressFinalize. 
        ' -----------------------------------------------------
        ' escenario en el que el Sistema llama al metodo dispose
        ' -----------------------------------------------------
        Try
            Me.Dispose(False)
        Finally
            MyBase.Finalize()
        End Try
    End Sub


    ''' <summary>
    '''   Realiza tareas definidas por la aplicación asociadas a 
    '''   la liberación o al restablecimiento de recursos no administrados
    ''' </summary>
    Public Overloads Sub Dispose()
        ' No hacer este metodo virtual.   
        ' Una clase derivada no debe ser capaz de reemplazar este metodo.    
        ' -----------------------------------------------------
        ' escenario en el que el usuario llama al metodo dispose
        ' -----------------------------------------------------
        ' No cambie este código. Coloque el código de limpieza en Dispose (ByVal que se dispone como Boolean).
        Me.Dispose(True)
        ' Decir al recolecto que no llame al destructor de este objeto
        ' porque este objeto ya esta [finalizado]
        GC.SuppressFinalize(Me)
    End Sub


    '--------------------------------------------------------------------
    ' Dispose (bool quienLLama) se ejecuta en dos escenarios distintos.
    ' Si [quienMeLLama] es igual a true, el método ha sido llamado directamente
    ' O indirectamente por el código de un usuario. 
    ' Los recursos administrados y no administrados Se puede eliminar.
    ' Si [quienMeLLama]es igual a false, el método ha sido llamado por el
    ' [runtime] desde el interior del finalizador y usted no debe hacer 
    ' referencia a otros objetos, ni siquiera para eliminarlos.
    ' Solo los recursos no administrados pueden ser eliminados.
    '--------------------------------------------------------------------
    ''' <summary>
    '''   Realiza tareas definidas por la aplicación asociadas a 
    '''   la liberación o al restablecimiento de recursos no administrados
    ''' </summary>
    ''' <remarks>
    ''' <para> ¡¡PROBLEMA!! Esta función debe tener el calificador [Overridable]</para>
    ''' <para>              pero si la clase está marcada como [NotInheritable] </para>
    ''' <para>              da error. En ese caso se puede quitar               </para>
    ''' <code>http://msdn.microsoft.com/es-es/magazine/cc163392.aspx</code>
    '''</remarks>
    Protected Overridable Overloads Sub Dispose(ByVal quienMeLLama As Boolean)
        ' Comprueba si Dispose ya ha sido llamado.  
        ' Solo se ejecuta una vez y solo una
        If Not Me.IsDisposed Then
            Try
                ' -------------------------------
                If quienMeLLama = True Then
                    ' -------------------------------
                    ' 1) Proceso de eliminar recursos SI administrados
                    ' -------------------------------
                    'Call DisposeObjetosAdministrados()
                End If
                ' -------------------------------
                ' 2) Proceso de eliminar recursos NO administrados
                'Call DisposeObjetosNOAdministrados()
                ' -------------------------------
                ' 3) Proceso de eliminar cadenas grandes
                Call DisposeCamposGrandesToNothing()
                ' -------------------------------
                ' 4) TODO:  Proceso de llamar al dispose de la clase base
                ' -------------------------------
                Call MyBase.Dispose()

            Finally
                ' Cerrar la puerta, solo se pasa una vez
                IsDisposed = True
            End Try
        End If
    End Sub


#End Region

End Class
