﻿

'/*
'
' -----------------------------------------------------------------
' IDENTIFICACION.:
'    Versión .....: 2013/02/19
'    Module Name..: OperacionesEscribeLaParteEntera 
'----------------
'    Creada inicialmente en el proyecto: [NumerosToLetrasDll]
'    Versión de la plantilla de fecha..: [2012-12-12] 
'----------------
'    Lenguaje .: .NET Framework 4.0.30319.18033 - 
'                 Microsoft Visual Basic .NET 2012 - [2013]
'    Usuario ..: AGUILA8 - Joaquin
'
'----------------
' DESCRIPCION.:
'
'En resumen
' Para escribir el numero en letras se usa la clase [OperacionesEscribeNumeroConLetras]
' Para tratar la parte entera esta la clase [OperacionesEscribeLaParteEntera]
' Para tratar la parte decimal esta la clase [OperacionesEscribeLaParteDecimal]
' Para organizar todas las operaciones esta la clase [EscribeConLetrasDirector]
' Para contener los datos comunes a todas ellas esta la clase base [OperacionesDatosComunes]
'
' Esta clase se encarga de escribir en letras la parte entera de un numero
' encapsula todo el proceso de escribir la parte entera de un numero
' en realidad usa la clase 'contenida' [OperacionesEscribeNumeroConLetras] para escribir el numero en letras
' además le añade las unidades ( o el nombre calificador de la cantidad) si esta definido.
' es una clase de trabajo que funciona como clase contenida por la clase [EscribeBase]
'
' Para escribir los números usa la clase [OperacionesEscribeNumeroConLetras]

' Si la cadena es un cero(0) devuelve una cadena con el valor [cero]
' Si la cadena tiene el valor [Empty] se  devuelve una cadena con el valor [Empty]
'
' La clase puede escribir en letras números de cualquier tamaño pero solo 
' nombra las unidades (miles, millones billones, etc.) de los 15 primeros 
' dígitos decimales hasta los [cuatrivigentillones] 
' las unidades correspondientes a las cantidades más elevadas las muestra 
' en forma de múltiplos de 10 de esta manera --> cuatro [10^(156)]llones 
'
'----------------
' OBSERVACIONES.:
'    ### Falta  mas observaciones###
'
'----------------
' INTERFAZ.:
'    Implementa la interfaz IDisposable
'
'----------------
' BIBLIOGRAFIA.:
'  Anexo:Nombres de los números en español
'  http://es.wikipedia.org/wiki/Nombres_de_los_n%C3%BAmeros_en_espa%C3%B1ol
'
'----------------
#Region "Copyright"

' COPYRIGHT.:
'      Copyright (c).:  [2013]  Joaquin 'jms32' Medina Serrano
'      Emilio .......:  mailto:joaquin@medina.name
'      Web ..........:  http://joaquin.medina.name
'
'
'  Yo, titular de los derechos de autor de esta obra, la publico 
'  en los términos de las siguientes licencias:
'
'  A pesar de las ¿Exhaustivas? , ¿Intesas?, 
'  y ¿cuidadosas? (ja, ja, ja..) pruebas a que he  
'  sometido este codigo, el principio de Murphy siempre 
'  esta trabajando y dice que si algo puede ir mal seguro 
'  que va mal. Por esa razon, Este codigo se porporciona 
'  *Como esta* sin ninguna garantia de ninguna clase 
'
'  Este codigo es BirraWare, es decir, si lo empleas, 
'  estas obligado de forma ineludible a:
'  a) Indicar claramente el autor (o sea mi nombre) 
'     y el sitio Web de donde se lo has copiado 
'     (o sea mi web) 
'  b) invitar a una birrita fresquita al creador del mismo
'     (o sea soy yo el que tiene que beberse la cerveza).
'  c) Si no me localizas, me conformo con que me envies 
'     un *emilio* contandome para que lo has empleado.
'     tengo curiosidad por saber por donde circula, 
'     (la curiosidad me puede)
'  d) Si haces algo interesante enviame una copia, me gustaria verlo 
'
' Se autoriza la copia, distribución y modificación de este documento 
' bajo los términos de la licencia de documentación libre GNU,  
' versión 1.2 o cualquier otra que posteriormente publique la  
' Fundación para el Software Libre; sin secciones invariables,  
' textos de portada, ni textos de contraportada.  
' Se incluye una copia de la dicha licencia en la sección titulada  
' Licencia de Documentación Libre GNU. Se puede consultar una copia  
' de la licencia en http://www.gnu.org/copyleft/fdl.html
'
'Este archivo se encuentra bajo la licencia  
' Creative Commons de Atribución/Compartir-Igual 
'Eres libre:
'  - Para compartir – para copiar, distribuir y transmitir el trabajo
'  - Para remezclar – para adaptar el trabajo
' Bajo las siguientes condiciones: 
'  - Atribución – Debes atribuir el trabajo de la manera especificada  
'    por el autor o persona que lo haya licenciado (pero no de manera  
'    que sugiera que estas personas te respaldan o respaldan el uso  
'    que hagas del trabajo).
'  - Compartir similar – En caso de alterar, transformar o ampliar  
'    este trabajo, deberá distribuir el trabajo resultante sólo  
'    bajo la misma licencia o una similar.
'
#End Region
'----------------
' MODIFICACIONES  [aaaa-mm-dd] 
' - 2013/02/19- Creación 
' - 2013/02/19 - Revisado con FxCop 
'
' -----------------------------------------------------------------
'
'*/
'
' -------------------------------------------------
Option Explicit On
Option Strict On
Option Infer Off
Option Compare Binary




''' <summary>
'''   Clase que escribe un la parte entera de un numero en letras. 
'''   Incluida la unidad si la tiene
'''   En realidad escribe un numero entero sin problemas
'''   Es una clase contenida por la clase [escritorBase]
'''   encapsula todo el proceso de escribir la parte entera de un numero
''' </summary>
<Serializable()> _
Friend Class OperacionesEscribeLaParteEntera
    Inherits OperacionesDatosComunes
    Implements IDisposable


#Region "Variables de la clase"


    Private Const MENOS As String = "menos"


    '----------------------------
    ''' <summary>
    '''  El número que estamos tratando ¿es un número negativo? (true/false)
    ''' </summary>
    Private _esUnNumeroNegativo As Boolean '  = False ' regla FxCop, no inicializar innecesariamente


    ''' <summary>
    '''  El número que estamos tratando ¿es un número negativo? (true/false)
    ''' </summary>
    Friend ReadOnly Property IsUnNumeroNegativo As Boolean
        Get
            Return _esUnNumeroNegativo
        End Get
    End Property


    ''' <summary>
    '''  Cadena que contiene un numero INTEGER que representa 
    '''  la parte entera del numero que queremos escribir en letras
    ''' </summary>
    ''' <remarks>
    '''  Al cargarla se quitan los ceros no significativos de la izquieda
    '''  por ejemplo 00012 --> 12
    '''</remarks>
    Friend Shadows Property CadenaNumericaCorregida() As String
        Get
            Return MyBase.CadenaNumericaCorregida
        End Get

        Set(value As String)
            If MyBase.CadenaNumericaCorregida <> value Then

                '-----------------------------------------------------
                ' primero quitar valores dependientes
                ' dar sus valores iniciales
                Me._esUnNumeroNegativo = False
                '-----------------------------------------------------

                ' La puede estar vacia
                If String.IsNullOrWhiteSpace(value) = True Then
                    value = String.Empty
                    ' salir de la propiedad dejando los campos dependientes de este valor en situacion incial
                Else
                    ' Hay una cadena numerica, analizarla y cargar las variables dependientes

                    ' --------------------
                    ' Comprobar y corregir la ortografía de la cadena
                    ' Quitar los espacios en blanco que rodeen a la cadena
                    value = value.Trim

                    '--------------
                    ' A) Carga variable [_esUnNumeroNegativo]
                    ' Averiguar si es un número negativo
                    ' el signo (si existe) se elimina de la cadena
                    _esUnNumeroNegativo = False
                    If value.StartsWith("-"c, StringComparison.OrdinalIgnoreCase) = True Then
                        _esUnNumeroNegativo = True
                        value = value.Substring(1, value.Length - 1)
                        value = value.Trim
                    End If
                    If value.StartsWith("+"c, StringComparison.OrdinalIgnoreCase) = True Then
                        _esUnNumeroNegativo = False
                        value = value.Substring(1, value.Length - 1)
                        value = value.Trim
                    End If

                    '-------------------------------
                    ' B) Quitar los separadores de millar (Puntos)
                    If value.IndexOf("."c) <> -1 Then
                        value = value.Replace("."c, String.Empty)
                    End If
                    ' Quitar los separadores de millar (espacios)
                    If value.IndexOf(" "c) <> -1 Then
                        value = value.Replace(" "c, String.Empty)
                    End If


                    '-------------------------------
                    '------------------------------
                    ' Correcciones parteEntera
                    '--------------------------------
                    '---------------------------
                    ' ¡¡ Atencion !!
                    ' En los decimales, los ceros a la izquierda no tienen valor
                    ' Ejemplo 0012 y 00000012 tienen el mismo valor numerico -> 12
                    ' Es decir, hay que eliminar los ceros de la izquierda
                    '---------------------------
                    Do While value.StartsWith("0"c, StringComparison.OrdinalIgnoreCase) = True
                        value = value.Substring(1, value.Length - 1)
                        ' si recibo una cadena copuesta por ceros
                        ' del bucle sale un valor [empty]
                    Loop
                    '--------------------------
                    ' la parte entera para que funcione tiene que tener un numero
                    ' aunque sea un cero :-)) ¡pero solo uno!
                    If value = String.Empty Then
                        value = "0"
                    End If

                End If ' / -->Value <> empty

                '------------------
                ' Asignar el valor a la propiedad
                ' Comprobar y corregir la ortografía de la cadena
                ' signos mas y menos
                ' separadores de millar 
                ' el separador decimal
                ' No se admiten letras

                MyBase.CadenaNumericaCorregida = value

            End If
        End Set
    End Property

#End Region

#Region "Constructores"


    ''' <summary>
    '''   Constructor
    ''' </summary>
    Friend Sub New()
        Me.new(String.Empty)
    End Sub


    ''' <summary>
    '''  Constructor
    ''' </summary>
    ''' <param name="pCadenaNumerica"> 
    '''    La cadena Original que contiene un número
    '''    La cadena debe contener únicamente números [0-9]
    '''    La coma [,] como separador decimal
    '''    Como separadores de millar se admite el punto [.]  o el espacio
    '''    Ejemplo [123.456,78] [123 456,78]
    '''</param>
    ''' <remarks>
    '''    Opcionalmente la cadena puede llevar el signo  menos [-] 
    '''    para indicar que es un número negativo
    '''</remarks>
    Friend Sub New(ByVal pCadenaNumerica As String)
        Me.CadenaNumericaCorregida = pCadenaNumerica
    End Sub

#End Region

#Region "EscribeElNumeroConLetras"

    ''' <summary>
    '''   Escribe en letras el número pasado en el parametro 
    '''   (P.E. 45 -> Cuarenta y cinco )
    ''' </summary>
    ''' <remarks>
    '''  <para> Calficador [overrides] para sobreescribir 
    '''         la funcion [MustOverride] de la clase base</para>
    ''' </remarks>
    Friend Overloads Overrides Function EscribeElNumeroConLetras(ByVal pCadenaNumerica As String) As String

        Me.CadenaNumericaCorregida = pCadenaNumerica

        Return Me.EscribeElNumeroConLetras()
    End Function


    ''' <summary>
    '''   Escribe en letras el número pasado en el constructor
    '''   (P.E. 45 -> Cuarenta y cinco )
    ''' </summary>
    ''' <remarks>
    '''  <para> Calficador [overrides] para sobreescribir 
    '''         la funcion [MustOverride] de la clase base</para>
    ''' </remarks>
    Friend Overloads Overrides Function EscribeElNumeroConLetras() As String


        If String.IsNullOrWhiteSpace(Me.CadenaNumericaCorregida) = True Then
            Return String.Empty
        End If

        '--------------------
        ' Observacion
        ' Si las cadenas que contienen las unidades son cadenas vacias [empty]
        ' quiere decir qeu no se usan unidades 
        ' Luego el valor del [FormatoEscrituraParteEntera] debe ajustarse
        ' al valor [FormatoEscrituraDelUno.UnoSinSustantivo]
        If Me.NombreUnidadEnSingular = String.Empty AndAlso
           Me.NombreUnidadEnPlural = String.Empty Then
            If Me.FormaDeEscribirElUno <> FormatoEscrituraDelUno.UnoSinSustantivo Then
                Me.FormaDeEscribirElUno = FormatoEscrituraDelUno.UnoSinSustantivo
            End If
        End If


        Dim cadenaConElResultado As String = String.Empty
          '--------------------------
        Using escritorNumeros As New OperacionesEscribeNumeroConLetras
            escritorNumeros.CadenaNumericaOriginal = Me.CadenaNumericaCorregida
            escritorNumeros.FormaDeEscribirElUno = Me.FormaDeEscribirElUno
            cadenaConElResultado = escritorNumeros.EscribeElNumeroConLetras()
            '--------------------------
            ' poner la palabra [unidades]
            If cadenaConElResultado.Length > 0 Then
                cadenaConElResultado = cadenaConElResultado & ESPACIO & GetNombreUnidadParteEntera(Me.CadenaNumericaCorregida)
            End If
        End Using

        If cadenaConElResultado.Length > 0 Then
            '--------------------------
            If Me.IsUnNumeroNegativo = True Then
                cadenaConElResultado = MENOS & ESPACIO & cadenaConElResultado
            End If
        End If
        '--------------------------

        Return cadenaConElResultado

    End Function



#End Region

#Region "Nombre de las unidades de las partes entera y decimal"

    Private Function GetNombreUnidadParteEntera(pCantidadEntera As String) As String
        Dim numero As Decimal = Decimal.Zero
        Dim resultado As String = Me.NombreUnidadEnPlural '"euros"
        If Decimal.TryParse(pCantidadEntera, numero) = True Then
            If numero = 1 Then
                resultado = Me.NombreUnidadEnSingular ' "euro"
            End If
            If numero = 0 Then
                resultado = String.Empty
            End If

        End If
        ' devolver la unidad
        Return resultado
    End Function

#End Region

#Region "Implementacion interfaz [Dispose]  [2012-12-04] "


    ' ''' <summary>
    ' ''' Un objeto administrado es un objeto de .NET que maneja el motor de 
    ' ''' ejecucion de NET, por ejemplo cualquier objeto de .NET
    ' ''' </summary>
    'Private Sub DisposeObjetosAdministrados()
    '    '--------------------------------
    '    '--------------------------------
    '    ' --> Liberar objetos administrados), 
    '    '     por ejemplo cualquier objeto de .NET
    '    '--------------------------------
    '    '--------------------------------
    '    'If Not (Me._Arbol Is Nothing) Then
    '    '    If _Arbol.IsDisposed = False Then
    '    '        _Arbol.Dispose()
    '    '    End If
    '    '    Me._Arbol = Nothing
    '    'End If
    'End Sub


    ''' <summary>
    '''  Establecer campos grandes como Null.
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub DisposeCamposGrandesToNothing()
        '--------------------------------
        ' --> Establecer campos grandes como Nothing.
        '     es decir todos los campos de la clase
        '--------------------------------
        'Me._CadenaGrande = Nothing
        Me._esUnNumeroNegativo = Nothing

    End Sub


    ' ''' <summary>
    ' '''  Si la clase derivada usa objetos NO administrados, debe reemplazar esta funcion
    ' '''  Un objeto no administrado  es un recurso que NO administra el motor en  
    ' '''  tiempo de ejecución, como identificadores de  ventanas (HWND),  
    ' '''  conexiones a bases de datos, un objeto creado directamente  
    ' '''  llamando al API de Windows, etc. el Word o Excel
    ' ''' </summary>
    'Private Sub DisposeObjetosNOAdministrados()
    '    Throw New NotImplementedException("DisposeObjetosNOAdministrados - No esta escrita")

    '    '--------------------------------
    '    ' --> Liberar objetos NO administrados).
    '    '       por ejemplo una base de datos
    '    '       Solamente hay que llamar a su método [Dispose]
    '    '--------------------------------
    '    '--------------------------------
    '    'If Not (Me.connection Is Nothing) Then
    '    '    'Close conexión'
    '    '    If connection.IsDisposed = False Then
    '    '        connection.Dispose()
    '    '    End If
    '    '    '¡¡OJITO !! no se hace Nothing
    '    'End If
    '    '--------------------------------
    'End Sub


    ' *******************************************************
    ' *******************************************************


    '  Variable y propiedad para saber si se ha diposado :-) o no
    '  es una variable que actua de semaforo, solo deja pasar una vez
    '----------------------------------------
    ' Apunte Táctico
    '----------------------------------------
    ' Si se borra el atributo [<Serializable()>] de la clase
    ' También hay que borrar el atributo [<NonSerialized()>] 
    ' de la variable [_disposedValue] que esta a continuación
    '----------------------------------------



    'Private _isDisposed As Boolean ' = False (no hace falta inicializar) 
    <NonSerialized()> Private _isDisposed As Boolean ' = False (no hace falta inicializar) 


    ''' <summary>
    '''     Obtiene un valor que indica si el objeto se ha eliminado. 
    ''' </summary>
    ''' <value>
    '''   <para>Tipo: <see cref="System.Boolean">Boolean</see></para>
    '''   <para>Es true si objeto se ha eliminado; en caso contrario, es false.</para>
    ''' </value>
    ''' <remarks>
    ''' <para> Cuando esta propiedad devuelve true, el objeto se elimina y ya
    '''        no se puede hacer referencia al mismo como un objeto válido. </para>  
    ''' <para> Aunque se elimine la instancia de un objeto, ésta se guarda en 
    '''        la memoria hasta que el recolector de elementos no utilizados 
    '''        la quite de la memoria.</para>  
    '''</remarks>
    Public Overloads Property IsDisposed() As Boolean
        Get
            Return _isDisposed
        End Get
        Private Set(ByVal value As Boolean)
            _isDisposed = value
        End Set
    End Property


    ''' <summary>
    '''     Destructor del objeto
    ''' </summary>
    Protected Overrides Sub Finalize()
        ' Este método se invoca de forma automática, después de 
        ' que un objeto pase a ser inaccesible, salvo que haya  
        ' sido excluido del proceso de finalización mediante una  
        ' llamada a GC.SuppressFinalize. 
        ' -----------------------------------------------------
        ' escenario en el que el Sistema llama al metodo dispose
        ' -----------------------------------------------------
        Try
            Me.Dispose(False)
        Finally
            MyBase.Finalize()
        End Try
    End Sub


    ''' <summary>
    '''   Realiza tareas definidas por la aplicación asociadas a 
    '''   la liberación o al restablecimiento de recursos no administrados
    ''' </summary>
    Public Overloads Sub Dispose()
        ' No hacer este metodo virtual.   
        ' Una clase derivada no debe ser capaz de reemplazar este metodo.    
        ' -----------------------------------------------------
        ' escenario en el que el usuario llama al metodo dispose
        ' -----------------------------------------------------
        ' No cambie este código. Coloque el código de limpieza en Dispose (ByVal que se dispone como Boolean).
        Me.Dispose(True)
        ' Decir al recolecto que no llame al destructor de este objeto
        ' porque este objeto ya esta [finalizado]
        GC.SuppressFinalize(Me)
    End Sub


    '--------------------------------------------------------------------
    ' Dispose (bool quienLLama) se ejecuta en dos escenarios distintos.
    ' Si [quienMeLLama] es igual a true, el método ha sido llamado directamente
    ' O indirectamente por el código de un usuario. 
    ' Los recursos administrados y no administrados Se puede eliminar.
    ' Si [quienMeLLama]es igual a false, el método ha sido llamado por el
    ' [runtime] desde el interior del finalizador y usted no debe hacer 
    ' referencia a otros objetos, ni siquiera para eliminarlos.
    ' Solo los recursos no administrados pueden ser eliminados.
    '--------------------------------------------------------------------
    ''' <summary>
    '''   Realiza tareas definidas por la aplicación asociadas a 
    '''   la liberación o al restablecimiento de recursos no administrados
    ''' </summary>
    ''' <remarks>
    ''' <para> ¡¡PROBLEMA!! Esta función debe tener el calificador [Overridable]</para>
    ''' <para>              pero si la clase está marcada como [NotInheritable] </para>
    ''' <para>              da error. En ese caso se puede quitar               </para>
    ''' <code>http://msdn.microsoft.com/es-es/magazine/cc163392.aspx</code>
    '''</remarks>
    Protected Overridable Overloads Sub Dispose(ByVal quienMeLLama As Boolean)
        ' Comprueba si Dispose ya ha sido llamado.  
        ' Solo se ejecuta una vez y solo una
        If Not Me.IsDisposed Then
            Try
                ' -------------------------------
                If quienMeLLama = True Then
                    ' -------------------------------
                    ' 1) Proceso de eliminar recursos SI administrados
                    ' -------------------------------
                    'Call DisposeObjetosAdministrados()
                End If
                ' -------------------------------
                ' 2) Proceso de eliminar recursos NO administrados
                'Call DisposeObjetosNOAdministrados()
                ' -------------------------------
                ' 3) Proceso de eliminar cadenas grandes
                Call DisposeCamposGrandesToNothing()
                ' -------------------------------
                ' 4) TODO:  Proceso de llamar al dispose de la clase base
                ' -------------------------------
                Call MyBase.Dispose()

            Finally
                ' Cerrar la puerta, solo se pasa una vez
                IsDisposed = True
            End Try
        End If
    End Sub


#End Region


End Class
