﻿


'/*
'
' -----------------------------------------------------------------
' IDENTIFICACION.:
'    Versión .....: 2013/02/19
'    Module Name..: OperacionesEscribeNumeroConLetras 
'----------------
'    Creada inicialmente en el proyecto: [NumerosToLetrasDll]
'    Versión de la plantilla de fecha..: [2012-12-12] 
'----------------
'    Lenguaje .: .NET Framework 4.0.30319.18033 - 
'                 Microsoft Visual Basic .NET 2012 - [2013]
'    Usuario ..: AGUILA8 - Joaquin
'
'----------------
' DESCRIPCION.:
'
' Esta clase contiene las operaciones necesarias para escribir un número ENTERO en letras
'
' Escribe un numero en letras de cualquier tamaño, pero unicamente es capaz 
' de nombrar las unidades de un numero con 150 cifras.
' Los numeros mayores no se esciben las unidades sino multiplos de 10.
'
'La idea es que en un número decimal, el número de la parte entera, se escribe igual 
'que el número correspondiente a la parte decimal. La única diferencia está en el 
'calificador y en la forma de unirlos.

' Para escribir el numero necesita conocer el numero y si se escribe en forma masculina
' o femenina o como numero solo es decir necesito saver si tengo que escribir
' [veintinuo], [veintiún] (con acento), [veintiuna], [uno],[un](sin acento),[una]
'
' Esta clase SOLO escribe el numero
'
' En resumen
' Para escribir el numero en letras se usa la clase [OperacionesEscribeNumeroConLetras]
' Para tratar la parte entera esta la clase [OperacionesEscribeLaParteEntera]
' Para tratar la parte decimal esta la clase [OperacionesEscribeLaParteDecimal]
' Para organizar todas las operaciones esta la clase [EscribeConLetrasDirector]
' Para contener los datos comunes a todas ellas esta la clase base [OperacionesDatosComunes]
'
'La clase [EscribeConLetrasDirector] se encarga de analizar el numero y 
'separar la parte entera y la decimal, se encarga de llamar a las funciones de esta 
'clase que escriben el numero en letras, y después monta el resultado final uniendo 
'las dos cadenas obtenidas (entera) y decimal) añadiendo las unidades (si existen) 
'y las preposiciones que exige el idioma español (por ejemplo 20 euros con 41 céntimos).
'
'----------------
' OBSERVACIONES.:
'    ### Falta  mas observaciones###
'
'----------------
' INTERFAZ.:
'    Implementa la interfaz IDisposable
'
'----------------
' BIBLIOGRAFIA.:
'  Anexo:Nombres de los números en español
'  http://es.wikipedia.org/wiki/Nombres_de_los_n%C3%BAmeros_en_espa%C3%B1ol
'
'
'----------------
#Region "Copyright"

' COPYRIGHT.:
'      Copyright (c).:  [2013]  Joaquin 'jms32' Medina Serrano
'      Emilio .......:  mailto:joaquin@medina.name
'      Web ..........:  http://joaquin.medina.name
'
'
'  Yo, titular de los derechos de autor de esta obra, la publico 
'  en los términos de las siguientes licencias:
'
'  A pesar de las ¿Exhaustivas? , ¿Intesas?, 
'  y ¿cuidadosas? (ja, ja, ja..) pruebas a que he  
'  sometido este codigo, el principio de Murphy siempre 
'  esta trabajando y dice que si algo puede ir mal seguro 
'  que va mal. Por esa razon, Este codigo se porporciona 
'  *Como esta* sin ninguna garantia de ninguna clase 
'
'  Este codigo es BirraWare, es decir, si lo empleas, 
'  estas obligado de forma ineludible a:
'  a) Indicar claramente el autor (o sea mi nombre) 
'     y el sitio Web de donde se lo has copiado 
'     (o sea mi web) 
'  b) invitar a una birrita fresquita al creador del mismo
'     (o sea soy yo el que tiene que beberse la cerveza).
'  c) Si no me localizas, me conformo con que me envies 
'     un *emilio* contandome para que lo has empleado.
'     tengo curiosidad por saber por donde circula, 
'     (la curiosidad me puede)
'  d) Si haces algo interesante enviame una copia, me gustaria verlo 
'
' Se autoriza la copia, distribución y modificación de este documento 
' bajo los términos de la licencia de documentación libre GNU,  
' versión 1.2 o cualquier otra que posteriormente publique la  
' Fundación para el Software Libre; sin secciones invariables,  
' textos de portada, ni textos de contraportada.  
' Se incluye una copia de la dicha licencia en la sección titulada  
' Licencia de Documentación Libre GNU. Se puede consultar una copia  
' de la licencia en http://www.gnu.org/copyleft/fdl.html
'
'Este archivo se encuentra bajo la licencia  
' Creative Commons de Atribución/Compartir-Igual 
'Eres libre:
'  - Para compartir – para copiar, distribuir y transmitir el trabajo
'  - Para remezclar – para adaptar el trabajo
' Bajo las siguientes condiciones: 
'  - Atribución – Debes atribuir el trabajo de la manera especificada  
'    por el autor o persona que lo haya licenciado (pero no de manera  
'    que sugiera que estas personas te respaldan o respaldan el uso  
'    que hagas del trabajo).
'  - Compartir similar – En caso de alterar, transformar o ampliar  
'    este trabajo, deberá distribuir el trabajo resultante sólo  
'    bajo la misma licencia o una similar.
'
#End Region
'----------------
' MODIFICACIONES  [aaaa-mm-dd] 
' - 2013/02/19- Creación 
' - 2013/02/19 - Revisado con FxCop 
'
' -----------------------------------------------------------------
'
'*/
'
' -------------------------------------------------
Option Explicit On
Option Strict On
Option Infer Off
Option Compare Binary



''' <summary>
'''  Clase que contiene las funciones para escribir un numero en letras
'''  es la que hace el trabajo de escribir un numero en letras
''' </summary>
''' <remarks>
''' <list  type="bullet">
''' <item> <a href="http://es.wikipedia.org/wiki/Nombres_de_los_n%C3%BAmeros_en_espa%C3%B1ol">Anexo: Nombres de los números en español</a></item>
''' <item> <a href="http://es.wikipedia.org/wiki/Escalas_num%C3%A9ricas_larga_y_corta">Escalas numéricas larga y corta</a></item>
''' <item> <a href="http://www.saberespractico.com/estudios/cultura-general/reglas-escritura-numeros-cardinales/">Reglas para la escritura de los números cardinales </a></item>
''' <item> <a href="http://www.saberespractico.com/estudios/ortografia-numerica-escritura-de-numeros/">Reglas ortográficas para la escritura de números </a></item>
''' <item> <a href="http://www.hispanoteca.eu/Foro-preguntas/ARCHIVO-Foro/Euro%20-%20euros.htm">Hispanoteca - Como se escribe 'euro'</a></item>
''' </list>
''' </remarks>
<Serializable()> _
Friend Class OperacionesEscribeNumeroConLetras
    Inherits OperacionesDatosComunes
    Implements IDisposable


#Region "Variables de la clase"


    ''' <summary>
    '''  Esta propiedad de la clase base no se emplea en esta clase
    '''  ocultarla y disparar un error si se usa
    ''' </summary>
    Private Shared Shadows ReadOnly Property NombreUnidadEnPlural As String
        Get
            Throw New NotImplementedException("Aqui no se usa")
        End Get
    End Property


    ''' <summary>
    '''  Esta propiedad de la clase base no se emplea en esta clase
    '''  ocultarla y disparar un error si se usa
    ''' </summary>
    Private Shared Shadows ReadOnly Property NombreUnidadEnSingular As String
        Get
            Throw New NotImplementedException("Aqui no se usa")
        End Get
    End Property



    ' ''' <summary>
    ' ''' La cadena que contiene un número que se convierte tal y como se recibe
    ' ''' </summary>
    'Private Property CadenaNumericaOriginal As String

    '    Get
    '        Return _cadenaNumericaOriginal
    '    End Get

    '    Set(value As String)
    '        If _cadenaNumericaOriginal <> value Then

    '            '-----------------------------
    '            ' PRECONDICION
    '            ' El llamador de esta función tiene la responsabilidad de:
    '            ' comprobar que la cadena:
    '            ' sea un numero
    '            ' no tenga ni signo ni separadores de miles
    '            ' no haya espacio ni delante ni detrás
    '            ' no haya caracteres extraños (no numéricos)
    '            ' no haya coma decimal
    '            '-----------------------------

    '            ' --------------------
    '            ' Guardar el valor inical recibido antes de corregirlo
    '            _cadenaNumericaOriginal = value

    '            '--------------------------
    '            ' Comprobar y corregir la ortografía de la cadena
    '            ' signos mas y menos
    '            If value.IndexOf("+"c) <> -1 Then
    '                Throw New InvalidCadenaNumericaException(
    '                          "Funciones shared de escritura con letras. " & Environment.NewLine & _
    '                          "No se cumple el contrato de la clase. " & Environment.NewLine & _
    '                          "La cadena no puede tener el signo mas [+]", value)
    '            End If
    '            If value.IndexOf("-"c) <> -1 Then
    '                Throw New InvalidCadenaNumericaException(
    '                          "Funciones shared de escritura con letras. " & Environment.NewLine & _
    '                          "No se cumple el contrato de la clase. " & Environment.NewLine & _
    '                          "La cadena no puede tener el signo menos [-]", value)
    '            End If

    '            ' separadores de millar 
    '            If value.IndexOf("."c) <> -1 Then
    '                Throw New InvalidCadenaNumericaException(
    '                          "Funciones shared de escritura con letras. " & Environment.NewLine & _
    '                          "No se cumple el contrato de la clase. " & Environment.NewLine & _
    '                          "La cadena no puede tener el separador de millares (punto)[.]", value)
    '            End If

    '            '  separadores de millar (espacios)
    '            If value.IndexOf(" "c) <> -1 Then
    '                Throw New InvalidCadenaNumericaException(
    '                          "Funciones shared de escritura con letras. " & Environment.NewLine & _
    '                          "No se cumple el contrato de la clase. " & Environment.NewLine & _
    '                          "La cadena no puede tener el separador de millares (espacios)[' ']", value)

    '            End If


    '            ' si el ultimo caracter es una coma añadir detras un cero
    '            If value.IndexOf(","c) <> -1 Then
    '                'value = value & "0"c
    '                Throw New InvalidCadenaNumericaException(
    '                          "Funciones shared de escritura con letras. " & Environment.NewLine & _
    '                          "No se cumple el contrato de la clase. " & Environment.NewLine & _
    '                          "No se permiten separadores decimales[,]", value)
    '            End If

    '            ' No se admiten letras
    '            For Each caracter As Char In value
    '                If Not (Char.IsDigit(caracter)) Then
    '                    Throw New InvalidCadenaNumericaException(
    '                              "Funciones shared de escritura con letras. " & Environment.NewLine & _
    '                              "No se cumple el contrato de la clase. " & Environment.NewLine & _
    '                              "No se permiten letras " & _
    '                              "La cadena solo puede contener dígitos numéricos (0-9)", value)
    '                End If
    '            Next


    '            '--------------------------
    '            ' cargar la variable miembro con el resultado
    '            CadenaNumericaCorregida = value
    '        End If
    '    End Set
    'End Property


#End Region


#Region "Constructores"

    ''' <summary>
    '''  Constructor
    ''' </summary>
    Public Sub New()
        ' No hacer nada
        ' Las variables de la clase toman su valor incial 
        ' en el momento de la declaracion
        Me.New(String.Empty, FormatoEscrituraDelUno.UnoSinSustantivo)

    End Sub


    ''' <summary>
    '''  Constructor
    ''' </summary>
    ''' <param name="pCadenaNumerica">
    '''   <para>La cadena que contiene el numero. </para>
    '''   <para>Es responsabilidad del llamador asegurarse de que la cadena es un numero bien formado, 
    '''         escrito en formato numerico Español</para> 
    ''' </param>
    ''' <param name="pFormaDeEscrituraDelUno">
    '''   <para>Enumeración <see cref="FormatoEscrituraDelUno">FormatoEscrituraDelUno</see></para>
    '''   <para>Indica la forma de escribir una terminación en [uno] por ejemplo [un], [uno, [una]</para>
    ''' </param>
    ''' <remarks>
    '''   <para>Es responsabilidad del llamador asegurarse de que la cadena es un numero bien formado, 
    '''         escrito en formato numerico Español es decir:</para> 
    '''   <para>El separador decimal es la coma [,]. </para>
    '''   <para>El separador de los millares es o bien el punto [.], o bien el espacio[' ']. </para>
    '''   <para>La cadena debe contener unicamente numeros (no estan permitidas las letras),</para>
    '''   <para>No estan permitidos los signos, el signo mas  [+] o menos [-]</para>
    '''</remarks>
    Public Sub New(
                      ByVal pCadenaNumerica As String,
                      ByVal pFormaDeEscrituraDelUno As FormatoEscrituraDelUno)
        '-----------------------------------------------------
        MyBase.new()


        CadenaNumericaOriginal = pCadenaNumerica
        FormaDeEscribirElUno = pFormaDeEscrituraDelUno

    End Sub


#End Region

#Region "Funciones"

    ''' <summary>
    '''  Escribe en letras una numero ENTERO (sin parte decimal).
    ''' </summary>
    ''' <returns>
    '''   <para>Una cadena que contiene escrito en letras el numero pasado</para>
    '''   <para>si el numero es cero(0) devuelve una cadena con el valor [cero]</para>
    ''' </returns>
    ''' <remarks>
    '''  <para>Esta función debe ser llamada por la función que se encargue de 
    '''   escribir la parte entera y la parte decimal de cada número</para>
    '''  <para> Calficador [overrides] para sobreescribir 
    '''         la funcion [MustOverride] de la clase base</para>
    ''' </remarks>
    Friend Overloads Overrides Function EscribeElNumeroConLetras() As String

        ' llamar a la función que hace el trabajo real de escribir en números
        Return auxEscribeUnNumero(Me.CadenaNumericaCorregida, Me.FormaDeEscribirElUno)
    End Function


    ''' <summary>
    '''  Escribe en letras una numero ENTERO (sin parte decimal).
    ''' </summary>
    ''' <remarks>
    '''  <para> Calficador [overrides] para sobreescribir 
    '''         la funcion [MustOverride] de la clase base</para>
    ''' </remarks>
    Friend Overloads Overrides Function EscribeElNumeroConLetras(pCadenaNumerica As String) As String
        ' corregir la cadena recibida
        ' cargar la variable [_cadenaNumericaCorregida]
        Me.CadenaNumericaOriginal = pCadenaNumerica

        ' llamar a la función que hace el trabajo real de escribir en números
        Return auxEscribeUnNumero(Me.CadenaNumericaCorregida, Me.FormaDeEscribirElUno)
    End Function


    '-----------------------------------------------
    ' He comentado esta funcion porque no se usaba 
    '-----------------------------------------------
    ' ''' <summary>
    ' '''  Escribe en letras una numero ENTERO (sin parte decimal).
    ' ''' </summary>
    ' ''' <param name="pCadenaNumerica">
    ' '''  La cadena que contiene el numero. 
    ' '''  El número debe ser entero. (Sin cifras decimales)
    ' '''  Es responsabilidad del llamador asegurarse de que la cadena es un numero entero bien formado
    ' ''' </param>
    ' ''' <param name="pFormaDeEscrituraDelUno">
    ' '''   <para>Enumeración <see cref="FormatoEscrituraDelUno">FormatoEscrituraDelUno</see></para>
    ' '''   <para>Indica la forma de escribir una terminación en [uno] por ejemplo [un], [uno, [una]</para>
    ' ''' </param>
    ' ''' <returns>
    ' '''   <para>Una cadena que contiene escrito en letras el numero pasado</para>
    ' '''   <para>si el numero es cero(0) devuelve una cadena con el valor [cero]</para>
    ' '''   <para>si la cadena tiene el valor [Empty] se  devuelve una cadena con el valor [Empty] </para>
    ' ''' </returns>
    ' ''' <remarks>
    ' '''   Esta función debe ser llamada por la función que se encargue de 
    ' '''   escribir la parte entera y la parte decimal de cada número
    ' ''' </remarks>
    'Friend Overloads Function EscribeElNumeroConLetras(
    '                    ByVal pCadenaNumerica As String,
    '                    ByVal pFormaDeEscrituraDelUno As FormatoEscrituraDelUno) As String

    '    ' corregir la cadena recibida
    '    ' cargar la variable [_cadenaNumericaCorregida]
    '    Me.CadenaNumericaOriginal = pCadenaNumerica

    '    ' llamar a la función que hace el trabajo real de escribir en números
    '    Return auxEscribeUnNumero(Me.CadenaNumericaCorregida, pFormaDeEscrituraDelUno)
    'End Function


#End Region

#Region "Zona de calculos"


    ''' <summary>
    '''  Escribe en letras una numero ENTERO (sin parte decimal).
    '''  Para ello lo divide en 'periodos' de 6 cifras, y escribe periodo a periodo
    ''' </summary>
    ''' <param name="pCadenaNumerica">
    '''    La cadena que contiene el numero.
    '''    El número debe ser entero. (Sin cifras decimales)
    ''' </param>
    ''' <param name="pFormaDeEscrituraDelUno">
    '''   <para>Enumeración <see cref="FormatoEscrituraDelUno">
    '''         FormatoEscrituraDelUno</see></para>
    '''   <para>Indica la forma de escribir una terminación 
    '''         en [uno] por ejemplo [un], [uno, [una]</para>
    ''' </param>
    ''' <returns>
    '''   <para>Una cadena que contiene escrito en letras el numero pasado </para>
    '''   <para>si el numero es cero (0) devuelve una cadena Vacía [Empty] </para>
    ''' </returns>
    ''' <remarks>
    '''   <para>Esta función debe ser llamada por la función que se encargue 
    '''          de escribir la parte entera y la parte decimal de cada número </para>
    '''   <para>----------------------------------------</para>
    '''   <para>  Un apunte sobre los nombres de las 
    '''           Unidades Grandes Grandes </para>
    '''   <para>----------------------------------------</para>
    '''   <para>  Una observación  </para>
    '''   <para> 10(03) debe leerse 10 elevado a 3</para>
    '''   <para> 10(24) debe leerse 10 elevado a 24</para>
    '''   <para> 1 000 000(8) debe leerse un millón elevado a 8</para>
    '''   <para>----------------------------------------</para>
    '''   <para> 10 ( 03)                   = 1 000  mil </para>
    '''   <para> 10 ( 06)  -   1 000 000(1) = 1 000 000  un millón </para>
    '''   <para> 10 ( 12)   -  1 000 000(2) = 1 000 000 000 000  un billón </para>
    '''   <para> 10 ( 18)   -  1 000 000(3) = 1 000 000 000 000 000 000  un trillón </para>
    '''   <para> 10 ( 24)   -  1 000 000(4) = 1 000 000 000 000 000 000 000 000  un cuatrillón </para>
    '''   <para> 10 ( 30)   -  1 000 000(5) = un quintillón </para>
    '''   <para> 10 ( 36)   -  1 000 000(6) = un sextillón</para>
    '''   <para> 10 ( 40)   -  1 000 000(7) = un septillón</para>
    '''   <para> 10 ( 46)   -  1 000 000(8) = un octillón</para>
    '''   <para> 10 ( 52)   -  1 000 000(9) = un nonillón</para>
    '''   <para>----------------------------------------</para>
    '''   <para> 10 ( 60)   -  1 000 000(10)  =   un decillón </para>
    '''   <para> 10 ( 66)   -  1 000 000(11)  =   un un decillón </para>
    '''   <para> 10 ( 72)   -  1 000 000(12)  =   un duo decillón </para>
    '''   <para> 10 ( 78)   -  1 000 000(13)  =   un tri decillón </para>
    '''   <para> 10 ( 84)   -  1 000 000(14)  =   un cuatri decillón </para>
    '''   <para> 10 ( 90)   -  1 000 000(15)  =   un quinti decillón </para>
    '''   <para> 10 ( 96)   -  1 000 000(16)  =   un sexti decillón </para>
    '''   <para> 10 (102)   -  1 000 000(17)  =   un septi decillón </para>
    '''   <para> 10 (108)   -  1 000 000(18)  =   un octo decillón </para>
    '''   <para> 10 (114)   -  1 000 000(19)  =   un nove decillón </para>
    '''   <para>----------------------------------------</para>
    '''   <para> 10 (120)   -  1 000 000(20)  =   un vigentillón </para>
    '''    
    '''   <para>   -  1 000 000(30)  =   un trigentillón </para>
    '''   <para>   -  1 000 000(100) =   un centillón </para>
    '''   <para>   -  1 000 000(200) =   un bicentillón </para>
    '''   <para>   -  1 000 000(300) =   un tricentillón </para>
    '''   <para>----------------------------------------</para>
    ''' </remarks>
    Private Shared Function auxEscribeUnNumero(
                     ByVal pCadenaNumerica As String,
                     ByVal pFormaDeEscrituraDelUno As FormatoEscrituraDelUno) As String

        '-----------------------------
        ' PRECONDICION
        ' El llamador de esta función tiene la responsabilidad de:
        ' comprobar que la cadena:
        ' sea un numero
        ' no tenga ni signo ni separadores de miles
        ' no haya espacio ni delante ni detrás
        ' no haya caracteres extraños (no numéricos)
        ' no haya coma decimal
        '-----------------------------

        If String.IsNullOrWhiteSpace(pCadenaNumerica) = True Then
            Return String.Empty
        End If


        ' hago esta comprobacion por si acaso
        If pCadenaNumerica.IndexOf(","c) <> -1 Then
            Throw New InvalidCadenaNumericaException(
                       "Funciones shared de escritura con letras. " & Environment.NewLine & _
                       "No se cumple el contrato de la clase. " & Environment.NewLine & _
                       "La cadena no debe tener separador decimal [,]", pCadenaNumerica)
        End If

        ' una cadena con el valor [0] se escribe cero
        If pCadenaNumerica = "0" Then
            Return "cero"
        End If



        ' -- CONDICION de funcionamiento ----
        ' La cadena tiene que ser múltiplo de seis
        ' porque cojo las cifras de seis en seis
        ' completo la cadena con ceros a la izquierda
        '-----
        ' la funcion [MOD] Divide dos números y devuelve sólo el resto.
        Do While ((pCadenaNumerica.Length Mod 6) > 0)
            pCadenaNumerica = "0" & pCadenaNumerica
        Loop

        '--------------------------------------------------
        ' Forma de leer y escribir los números
        ' Ejemplo 
        ' 31 415 926 535 897 932 384 626 433 832 795
        '
        ' 000 031     415 926     535 897     932 384     626 433     832 795
        '
        'Treinta y un quintillones
        'cuatrocientos quince mil novecientos veintiséis cuatrillones
        'quinientos treinta y cinco mil ochocientos noventa y siete trillones
        'novecientos treinta y dos mil trescientos ochenta y cuatro billones
        'seiscientos veintiséis mil cuatrocientos treinta y tres millones
        'ochocientos treinta y dos mil setecientos noventa y cinco.
        '----------------------------------------------------------
        Const ESPACIO As String = " "c
        Const SINGULAR As String = "llón"
        Const PLURAL As String = "llones"
        Const PREPOSICION_DE As String = "de"
        Const DIGITOS_PERIODO As Integer = 6
        Dim nombresPeriodos() As String = {"", "mi", "bi", "tri", "cuatri",
                                    "quinti", "sexti", "septi", "octi",
                                    "noni", "deci", "undeci", "duodeci",
                                    "trideci", "cuatrideci", "quintideci",
                                    "sextideci", "septideci", "octodeci",
                                    "novedeci", "vigenti", "unvigenti",
                                    "duovigenti", "trivigenti", "cuatrivigenti"}

        'Dim periodosPlural() As String = {"", "millones", "billones", "trillones"


        ' La cadena donde se monta el resultado
        Dim resultadoNumeroComoTexto As String = String.Empty

        '---------------
        ' La cadena que contiene el texto sin tratar
        ' se inicializa con TODA la cadena
        Dim auxRestoCadenaSinTratar As String = pCadenaNumerica
        ' El periodo que se está tratando
        Dim auxPeriodoTratadoComoCadena As String = String.Empty
        Dim auxPeriodoTratadoComoNumero As Integer = 0

        '-------------------------------------------
        ' El PROBLEMA del millón (de)
        '-------------------------------------------
        '  por ejemplo 1 000 000 se escribe un millón DE euros
        '  por ejemplo 1 000 000 000 se escribe mil millones DE euros
        ' Se reconocen porque es una cantidad que esta seguida 
        '  de uno o varios [periodos] de 6 ceros 
        ' Cuando acaba de convertirse el numero, si el ultimo 'periodo' 
        ' es un bloque de ceros el numero acabará en una unidad 
        ' tipo millones trillones, etc. al que hay que añadir la palabra (de)
        ' Por cierto, solo en el caso de que se trate de cantidades con calificador
        Dim auxPeriodoAnteriorComoNumero As Integer = 0

        '-------------------------
        Dim numeroPeriodos As Integer =
             Convert.ToInt32(pCadenaNumerica.Length / DIGITOS_PERIODO)
        For periodo As Integer = (numeroPeriodos - 1) To 0 Step -1

            ' extraer el periodo a tratar
            auxPeriodoTratadoComoCadena =
                    auxRestoCadenaSinTratar.Substring(0, DIGITOS_PERIODO)

            auxPeriodoTratadoComoNumero = Integer.Parse(
                                 auxPeriodoTratadoComoCadena,
                                 Globalization.NumberStyles.None,
                                 System.Globalization.CultureInfo.InvariantCulture)

            auxRestoCadenaSinTratar =
                 auxRestoCadenaSinTratar.Substring(
                           DIGITOS_PERIODO,
                           (auxRestoCadenaSinTratar.Length - DIGITOS_PERIODO))

            '-------------------------------------------
            ' Si quedan más periodos, el uno tiene que apocoparse a [un] [veintiún]
            ' Ejemplo Treinta y un quintillones ... etc. etc.
            ' si es el final de la cadena el uno hay que escribirlo 
            ' completo [uno] [cuarenta y uno]
            ' resumen 
            ' A) Si NO, NO No es el ultimo ---> se acorta a [un]  [Treinta y un]
            ' B) Si es el ultimo ---> Sin nombre            [uno] [treinta y uno]
            '                         Con nombre masculino  [un]  [Treinta y un  euros   (platanos)]
            '                         Con nombre femenino   [una] [Treinta y una pesetas (patatas) ]
            '-------------------------------------------
            ' Tratar el periodo
            ' Observa que todos los nombres de las unidades que 
            ' se asignan a los periodos son todas masculinas
            ' La única variación posible es el último periodo 
            ' que puede tener tres posibilidades
            ' - ningún nombre calificativo, (por ejemplo, veintiuno) 
            ' - con un calificativo masculino (por ejemplo veinte un arboles), 
            ' - con un calificativo femenino (por ejemplo veintiuna manzana)
            ' y está determinado por el parámetro 
            ' [pFormaDeEscrituraDelUno] de esta función
            '------------------------------------
            Dim auxTextoParcial As String = String.Empty
            If auxRestoCadenaSinTratar.Length > 0 Then
                auxTextoParcial = auxEscribeUnPeriodo(
                                      auxPeriodoTratadoComoCadena,
                                      FormatoEscrituraDelUno.UnConSustantivoMasculino)
            Else
                auxTextoParcial = auxEscribeUnPeriodo(
                                      auxPeriodoTratadoComoCadena,
                                      pFormaDeEscrituraDelUno)
            End If

            '-------------------------------------
            ' El asunto del nombre de la unidad que corresponde al periodo
            '-------------------------------------
            ' He refactorizado el código 
            ' he decidido a poner la unidad como un múltiplo de 10 con  
            ' lo que ahora no existe ninguna limitación al tamaño del número  
            ' que se puede escribir, lo que ocurre es que con números muy  
            ' grandes en lugar del nombre de la unidad aparecerá entre corchetes  
            ' la potencia de 10 que corresponde a esa unidad 
            ' (que al no estar en la matriz se desconoce el nombre).
            '-------------------------------------
            Dim textoNombreUnidad As String = String.Empty
            If periodo > nombresPeriodos.GetUpperBound(0) Then
                textoNombreUnidad = String.Format(
                    System.Globalization.CultureInfo.InvariantCulture,
                    "[10^({0})]",
                    (periodo * 6))
            Else
                textoNombreUnidad = nombresPeriodos(periodo)
            End If

            If auxTextoParcial.Length > 0 Then
                resultadoNumeroComoTexto = resultadoNumeroComoTexto & auxTextoParcial

                If auxPeriodoTratadoComoNumero = 1 Then
                    resultadoNumeroComoTexto = resultadoNumeroComoTexto &
                                               ESPACIO &
                                               textoNombreUnidad
                    If periodo > 0 Then
                        resultadoNumeroComoTexto = resultadoNumeroComoTexto & SINGULAR & ESPACIO
                    End If
                Else
                    resultadoNumeroComoTexto = resultadoNumeroComoTexto &
                                               ESPACIO &
                                               textoNombreUnidad
                    If periodo > 0 Then
                        resultadoNumeroComoTexto = resultadoNumeroComoTexto & PLURAL & ESPACIO
                    End If
                End If
            End If

            '-------------------------------------------
            '[Continuación del PROBLEMA del millón (de)]
            auxPeriodoAnteriorComoNumero = auxPeriodoTratadoComoNumero
        Next

        '-------------------------------------------
        '[Continuación del PROBLEMA del millón (de)]
        If auxPeriodoAnteriorComoNumero = 0 Then
            If numeroPeriodos > 1 Then
                ' Observación... 
                ' Para escribir [de] hace falta la cantidad un millón por lo menos
                ' es decir hace falta más de un periodo , y además
                ' que el último periodo sea todo ceros 
                If pFormaDeEscrituraDelUno = FormatoEscrituraDelUno.UnaConSustantivoFemenino OrElse
                    pFormaDeEscrituraDelUno = FormatoEscrituraDelUno.UnConSustantivoMasculino Then
                    resultadoNumeroComoTexto = resultadoNumeroComoTexto & PREPOSICION_DE & ESPACIO
                End If
            End If
        End If

        '-------------------------------------
        ' Quitar los espacios sobrantes
        resultadoNumeroComoTexto = resultadoNumeroComoTexto.Trim
        '-------------------------------------
        Return resultadoNumeroComoTexto

    End Function



    ''' <summary>
    '''   Escribe en letras una periodo de seis cifras
    ''' </summary>
    ''' <param name="pCantidadPeriodo">
    '''    Cadena de seis (6) cifras que compone un periodo
    ''' </param>
    ''' <param name="pFormaDeEscrituraDelUno">
    '''   <para>Enumeración <see cref="FormatoEscrituraDelUno">
    '''         FormatoEscrituraDelUno</see></para>
    '''   <para>Indica la forma de escribir una terminación 
    '''         en [uno] por ejemplo [un], [uno, [una] </para>
    ''' </param>
    ''' <returns>
    '''   <para>Una cadena que contiene escrito en letras el numero pasado </para>
    '''   <para>si el numero es cero (0) devuelve una cadena Vacía [Empty] </para>
    ''' </returns>
    ''' <remarks>
    '''   <para>Forma de leer los números</para>
    '''   <para>Para leer los números, el español usa el procedimiento denominado 
    '''         escala numérica larga que consiste en: </para>
    '''   <para> * Numerar las cifras de derecha a izquierda, el orden de cada  
    '''            cifra es el lugar que ocupa en ese orden.</para>
    '''   <para> * Las cifras se agrupan de tres en tres de derecha a izquierda,  
    '''            cada uno de estos grupos de tres cifras se denomina clase,  
    '''            y se numeran también de derecha a izquierda.</para>
    '''   <para> * Agrupando las cifras de seis en seis de derecha a izquierda,  
    '''            o lo que es lo mismo, cada dos clases, se forman los periodos,  
    '''            que se numeran igualmente de derecha a izquierda.</para>
    '''   <para> * Hecha esta división, tenemos que el orden dentro de cada clase  
    '''            se denominan: unidad, decena y centena, la segunda clase dentro  
    '''            de cada periodo se denomina de millar,
    '''            el segundo periodo son millones,  
    '''            el tercero billones, etc. En principio esta clasificación 
    '''            puede continuar indefinidamente.</para>
    '''
    '''   <para> Por ejemplo, el número:</para>
    '''   <para> 15 936 535 897 632 384 626 433 862 795</para>
    '''
    '''   <para> Se clasificaría así:</para>
    '''   <para>    15  936    535  897    632  384   626  433   862  795    </para>
    '''   <para>    10C  9C     8C   7C     6C   5C    4C   3C    2C   1Clase</para>
    '''   <para>  5 Periodo   4 Periodo   3 Periodo  2 Periodo  1 Periodo    </para>
    '''
    '''   <para>Según esto y a la vista del esquema, el nombre de las 
    '''         cifras de izquierda a derecha sería:</para>
    '''   <para> * Unidad, decenas y centenas, para la primera clase 
    '''            del primer periodo.</para>
    '''   <para> * Unidad de millar, decenas de millar y centenas de millar, 
    '''            para la segunda clase del primer periodo.</para>
    '''   <para> * Unidad de millón, decena de millón, centena de millón,  
    '''            para la primera clase del segundo periodo.</para>
    '''   <para> * Unidad de millar de millón, decena de millar de millón,  
    '''            centena de millar de millón, para la segunda 
    '''           clase del segundo periodo.</para>
    '''   <para> * Este ciclo de seis cifras dividido en dos clases de tres  
    '''            cifras cada una que se denominan: Millón, Billón, 
    '''            Trillón, Cuatrillón, Quintillón, Sextillón, Septillón,
    '''            Octillón, etc. puede nombrar cualquier cantidad
    '''            por muchas cifras que pueda tener. </para>
    '''
    '''   <para> El número se lee:</para>
    '''   <para>  quince mil novecientos treinta y seis cuatrillones</para>
    '''   <para>  quinientos treinta y cinco mil 
    '''           ochocientos noventa y siete trillones</para>
    '''   <para>  novecientos treinta y dos mil 
    '''           trescientos ochenta y cuatro billones</para>
    '''   <para>  seiscientos veintiséis mil 
    '''           cuatrocientos treinta y tres millones</para>
    '''   <para>  ochocientos treinta y dos mil setecientos noventa y cinco</para>
    '''</remarks>
    Private Shared Function auxEscribeUnPeriodo(
                   ByVal pCantidadPeriodo As String,
                   ByVal pFormaDeEscrituraDelUno As FormatoEscrituraDelUno) As String

        '-----------------------------
        ' PRECONDICION
        ' Responsabilidad del llamador
        ' El llamador tiene que cerciorarse de que:
        ' 1) en el parámetro haya tres (3) caracteres numéricos
        ' 2) y además que no sean espacios
        '-----------------------------
        If pCantidadPeriodo.Length <> 6 Then
            Throw New InvalidCadenaNumericaException(
                      "Funciones shared de escritura con letras. " & Environment.NewLine & _
                      "Funcion shared  de escritura de un PERIODO con letras. " & Environment.NewLine & _
                      "No se cumple el contrato de la clase. " & Environment.NewLine & _
                      "La cadena tiene que tener 6 caracteres", pCantidadPeriodo)
        End If

        '------------------------------
        ' Si llega esta cadena no hago nada
        If pCantidadPeriodo = "000000" Then
            Return String.Empty
        End If


        '-------------------------------
        Const MIL As String = "mil"
        Const ESPACIO As String = " "c

        '-----------------------------
        ' ¡ ATENCION !!
        ' Un periodo está compuesto de seis cifras numéricas
        ' las seis cifras se dividen en dos grupos de tres cifras llamadas Clases
        ' cada clase se numera a partir de la izquierda
        ' resultado --> [segunda clase][Primera clase]
        ' y ese es el convenio de nombres que se sigue en esta función
        '----------------------------
        ' ejemplo de periodo
        ' 123 456 = ciento veintitrés mil cuatrocientos cincuenta y seis
        ' 2C  1C    (1C = primera clase; 2C = segunda clase)
        ' Periodo
        '---------------------------
        ' La segunda centena es la que está en la izquierda
        ' la primera centena es la que está a la derecha
        ' se empieza a contar a a partir de las unidades (por la derecha del numero)
        Dim primeraCentenaCadena As String = pCantidadPeriodo.Substring(3, 3)
        Dim segundaCentenaCadena As String = pCantidadPeriodo.Substring(0, 3)

        ' No uso TryParse, porque el contrato debe cumplirse
        Dim segundaCentenaNumero As Integer = Integer.Parse(
                   segundaCentenaCadena,
                   Globalization.NumberStyles.None,
                   System.Globalization.CultureInfo.InvariantCulture)

        Dim cadenaResultado As String = String.Empty

        '-----------------------------------------------
        '-----------------------------------------------
        ' A) Escribir primero la [segunda] centena
        Select Case segundaCentenaNumero
            Case Is = 0
                '-----------------------------------------------
                'la centena tiene el valor numerico cero(0)
                '-----------------------------------------------
                cadenaResultado = String.Empty
            Case Is = 1
                '-----------------------------------------------
                'la centena tiene el valor numerico uno (1)
                '-----------------------------------------------
                ' El problema del numero mil
                ' el numero mil se escribe [mil] no [un mil]
                ' es una excepción que se trata individualmente
                '----------------
                cadenaResultado = MIL & ESPACIO ' --> "mil"
            Case Else
                '-----------------------------------------------
                'la centena tiene el valor numerico SUPERIOR a uno (1) por ejemplo 25
                '-----------------------------------------------
                ' Cuidado en este punto
                ' el formato de escritura del uno es [un] acompañado 
                ' de sustantivo masculino  porque es:
                ' ciento veintiún mil etc. 
                ' En este caso concreto(siempre va delante de la palabra [mil])
                ' Recuerda que (clase o centena) estoy escibiendo para no liarte
                '-----------------------------------------------
                ' obtener la cadena de texto
                cadenaResultado = auxEscribeCentenas(
                     segundaCentenaCadena,
                     pFormaDeEscrituraDelUno)
                ' meter despues la palabra mil y un espacio de separacion
                cadenaResultado = cadenaResultado & ESPACIO & MIL & ESPACIO ' --> "mil"
        End Select

        '-----------------------------------------------
        '-----------------------------------------------
        ' B)  Escribir después la [primera] centena
        cadenaResultado =
              cadenaResultado &
              auxEscribeCentenas(primeraCentenaCadena, pFormaDeEscrituraDelUno)


        '-----------------------------------------------
        ' Devolver el resultado
        Return cadenaResultado
    End Function



    ''' <summary>
    '''  Escribe en letras una centena Ejemplo [cuatrocientos treinta y uno] 
    ''' </summary>
    ''' <param name="pCantidadCentena">
    '''    Cadena con tres (3) cifras que representa a una centena
    ''' </param>
    ''' <param name="pFormaDeEscrituraDelUno">
    '''   <para>Enumeración <see cref="FormatoEscrituraDelUno">
    '''         FormatoEscrituraDelUno</see></para>
    '''   <para>Indica la forma de escribir una terminación 
    '''         en [uno] por ejemplo [un], [uno, [una]</para>
    ''' </param>
    ''' <returns>
    '''   <para>Una cadena que contiene escrito en letras el numero pasado </para>
    '''   <para>si el numero es cero (0) devuelve una cadena Vacía [Empty] </para>
    ''' </returns>
    Private Shared Function auxEscribeCentenas(
                   ByVal pCantidadCentena As String,
                   ByVal pFormaDeEscrituraDelUno As FormatoEscrituraDelUno) As String

        '-----------------------------
        ' PRECONDICION
        ' Responsabilidad del llamador
        ' El llamador tiene que cerciorarse de que:
        ' 1) en el parámetro haya tres (3) caracteres numéricos
        ' 2) y además que no sean espacios
        '-----------------------------
        If pCantidadCentena.Length <> 3 Then
            Throw New InvalidCadenaNumericaException(
                      "Funciones shared de escritura con letras. " & Environment.NewLine & _
                      "Funcion shared  de escritura de una CENTENA con letras. " & Environment.NewLine & _
                      "No se cumple el contrato de la clase. " & Environment.NewLine & _
                      "La cadena tiene que tener tres carateres", pCantidadCentena)
        End If

        '------------------------------
        ' Si llega esta cadena no hago nada
        If pCantidadCentena = "000" Then
            Return String.Empty
        End If
        '-------------------------------
        ' Cadena donde montare la solución
        Dim numeroEnLetras As String = String.Empty

        '-------------------
        'matrices
        'Dim centenasMatrizMasculino() As String =
        '    {"", "ciento", "doscientos", "trescientos",
        '-------------------

        Dim centenasMatriz() As String =
             {"", "ciento", "doscient", "trescient",
              "cuatrocient", "quinient", "seiscient",
              "setecient", "ochocient", "novecient"}

        Const MASCULINO As String = "os"
        Const FEMENINO As String = "as"
        Const CIEN As String = "cien"
        Const ESPACIO As String = " "c
        '-------------------
        ' El problema del número cien
        ' el número cien se escribe [cien] no [un cien], ni [ciento]
        ' es una excepción que se trata individualmente
        ' Lo que hago es dar el valor de [cien] por defecto 
        ' Luego miro a ver si la cantidad es distinta del numero '100' y entonces
        ' miro en la matriz el valor que le corresponde
        ' después trato las decenas para obtener su valor como texto
        ' números como [ciento uno], [ciento veintiuno], etc.
        '-------------------
        ' El problema del masculino o femenino
        ' Los múltiplos de [cien] son sensibles al masculino o femenino 
        ' del sustantivo que las acompaña 
        ' Por ejemplo  [doscientos] tomates, [doscientas] patatas
        '
        ' Exceptuando el numero [cien] que se escribe siempre igual 
        ' independientemente del genero de la palabra que las acompaña 
        ' Por ejemplo [cien] tomates [cien] patatas
        '-------------------

        ' Cadena con la solución
        numeroEnLetras = CIEN
        If pCantidadCentena <> "100" Then
            ' ----------------
            ' Análisis del trío de números
            ' No uso TryParse, porque el contrato debe cumplirse
            Dim centenaNumero As Integer = Integer.Parse(
                pCantidadCentena.Substring(0, 1),
                Globalization.NumberStyles.None,
                System.Globalization.CultureInfo.InvariantCulture)
            '----------------------------
            'El texto de las centenas
            Dim centenaCadena As String = centenasMatriz(centenaNumero)
            ' Añadir la terminación masculina o femenina
            ' pero solo si el numero es 200 o superior
            ' doscientos hombres, doscientas patatas
            ' cien hombres, cien patatas
            If centenaNumero > 1 Then
                Select Case pFormaDeEscrituraDelUno
                    Case FormatoEscrituraDelUno.UnConSustantivoMasculino
                        centenaCadena = centenaCadena & MASCULINO ' doscientos
                    Case FormatoEscrituraDelUno.UnoSinSustantivo
                        centenaCadena = centenaCadena & MASCULINO ' doscientos
                    Case FormatoEscrituraDelUno.UnaConSustantivoFemenino
                        centenaCadena = centenaCadena & FEMENINO ' doscientas
                    Case Else
                        ' Problemas en la enumeracion
                        ' normalmente por añadir o quitar  de la enumeracion
                        Throw New System.ComponentModel.InvalidEnumArgumentException(
                            "(auxEscribeCentenas) FormaEscrituraDelUno")
                End Select
            End If

            '----------
            ' El texto de las decenas y unidades
            ' Extraer las decenas y unidades y pasarlo a la función que los trata
            Dim auxTextoDecenas As String = auxEscribeDecenas(
                         pCantidadCentena.Substring(1, 2),
                         pFormaDeEscrituraDelUno)
            '----------
            ' Meter un espacio para separar las centenas de las decenas
            ' solo si existe un texto en las dos variables
            ' de esta forma solo meto el espacio cuando hce falta
            If centenaCadena.Length > 0 AndAlso auxTextoDecenas.Length > 0 Then
                centenaCadena = centenaCadena & ESPACIO
            End If
            '----------
            ' Montar el texto de salida
            numeroEnLetras = centenaCadena & auxTextoDecenas

        End If
        Return numeroEnLetras
    End Function




    ''' <summary>
    '''  Escribe en letras una decena [treinta y uno] [cuarenta y dos] [veinte]
    ''' </summary>
    ''' <param name="pCantidadDecena">
    '''   Cadena con dos(2) cifras que representa a una decena
    ''' </param>
    ''' <param name="pFormaDeEscrituraDelUno">
    '''   <para>Enumeración <see cref="FormatoEscrituraDelUno">
    '''         FormatoEscrituraDelUno</see></para>
    '''   <para>Indica la forma de escribir una terminación 
    '''         en [uno] por ejemplo [un], [uno, [una]</para>
    ''' </param>
    ''' <returns>
    '''   <para>Una cadena que contiene escrito en letras el numero pasado </para>
    '''   <para>si el numero es cero (0) devuelve una cadena Vacía [Empty] </para>
    ''' </returns>
    Private Shared Function auxEscribeDecenas(
                   ByVal pCantidadDecena As String,
                   ByVal pFormaDeEscrituraDelUno As FormatoEscrituraDelUno) As String

        '-----------------------------
        ' PRECONDICION
        ' Responsabilidad del llamador
        ' El llamador tiene que cerciorarse de que:
        ' 1) en el parámetro haya dos caracteres numéricos
        ' 2) y además que no sean espacios
        '-----------------------------

        If pCantidadDecena.Length <> 2 Then
            Throw New InvalidCadenaNumericaException(
                       "Funciones shared de escritura con letras. " & Environment.NewLine & _
                       "Funcion shared  de escritura de una DECENA con letras. " & Environment.NewLine & _
                       "No se cumple el contrato de la clase. " & Environment.NewLine & _
                       "La cadena tiene que tener dos caracteres", pCantidadDecena)
        End If

        '------------------------------
        ' Excepción -> Numero cero
        ' Si llega esta cadena devuelvo una cadena vacía
        If pCantidadDecena = "00" Then
            Return String.Empty
        End If

        ' ----------------
        ' Análisis del parámetro   
        ' Averiguar el número que hay en las unidades y en las decenas 

        Dim unidadCadena As String = pCantidadDecena.Substring(1, 1)
        Dim decenaCadena As String = pCantidadDecena.Substring(0, 1)

        ' No uso TryParse, porque el contrato debe cumplirse
        Dim unidadNumero As Integer = Integer.Parse(
            unidadCadena,
            Globalization.NumberStyles.None,
            System.Globalization.CultureInfo.InvariantCulture)

        Dim decenaNumero As Integer = Integer.Parse(
            decenaCadena,
            Globalization.NumberStyles.None,
            System.Globalization.CultureInfo.InvariantCulture)

        Dim decenaTratadaNumero As Integer = (decenaNumero * 10) + unidadNumero

        '-------------------------------------
        ' Constantes
        Const CONCETOR As String = " y "

        '-------------------
        'matrices con los números en letras
        Dim diezDiecinueveMatriz() As String =
            {"", "once", "doce", "trece", "catorce",
             "quince", "dieciséis", "diecisiete",
             "dieciocho", "diecinueve"}

        '--------------------------
        ' ¡Atención!
        ' En la matriz figura [veinti] y no [veintiuno], 
        ' porque es la función [auxTratamientoDelNumeroUno]
        ' la que se encarga de escribirlo de forma adecuada
        ' [veintiún], [veintiuno], [veintiuna]
        '--------------------------
        Dim veinteVeintinueveMatriz() As String =
            {"", "veinti", "veintidós", "veintitrés",
             "veinticuatro", "veinticinco", "veintiséis",
             "veintisiete", "veintiocho", "veintinueve"}

        Dim decenasMatriz() As String =
            {"", "diez", "veinte", "treinta", "cuarenta",
             "cincuenta", "sesenta", "setenta",
             "ochenta", "noventa"}

        '----------------------------
        '----------------------------
        ' Casos posibles
        ' - número comprendido entre 11 y 19
        ' - número comprendido entre 21 y 29
        ' - número comprendido entre 31 y 99
        ' - números tipo 30, 40, 60
        ' - números de una cifra, 3,5,7
        '----------------------------

        '----------
        ' El texto de las decenas y unidades
        Dim auxTextoSalida As String = String.Empty
        '----------
        ' Número de dos cifras
        If decenaNumero > 0 AndAlso unidadNumero > 0 Then
            '----------
            ' Número comprendido entre 11 y 19
            If decenaTratadaNumero > 10 AndAlso decenaTratadaNumero < 20 Then
                auxTextoSalida = diezDiecinueveMatriz(unidadNumero)
            End If
            '----------
            ' Número comprendido entre 21 y 29
            If decenaTratadaNumero > 20 AndAlso decenaTratadaNumero < 30 Then
                auxTextoSalida = veinteVeintinueveMatriz(unidadNumero)
                ' problema con el 21 veintiuno  o veintiun mil
                ' el caso del numero terminado en uno
                If unidadNumero = 1 Then
                    auxTextoSalida =
                    auxTratamientoDelNumeroUno(auxTextoSalida, pFormaDeEscrituraDelUno)
                End If
            End If

        End If

        '----------
        ' Número comprendido entre 31 y 99
        If decenaTratadaNumero > 30 Then
            ' Ejemplo 42, 51 
            auxTextoSalida = decenasMatriz(decenaNumero) & CONCETOR
            ' Escribe las unidades
            ' Trata de forma adecuada el caso del numero uno
            auxTextoSalida = auxTextoSalida &
                             auxEscribeUnidades(unidadCadena, pFormaDeEscrituraDelUno)
        End If

        '----------
        ' Decenas enteras - Números tipo 30, 40, 60
        If decenaNumero > 0 AndAlso unidadNumero = 0 Then
            auxTextoSalida = decenasMatriz(decenaNumero)
        End If

        '----------
        ' Números de una cifra, 3,5,7
        If decenaNumero = 0 AndAlso unidadNumero > 0 Then
            ' Escribe las unidades
            ' Trata de forma adecuada el caso del numero uno
            auxTextoSalida = auxEscribeUnidades(unidadCadena, pFormaDeEscrituraDelUno)
        End If

        ''----------
        '' Excepción --> el cero 00
        'If decenaNumero = 0 AndAlso unidadNumero = 0 Then
        '    ' no debe llegar aquí nunca 
        '    ' devolver [Empty]
        '    auxTextoSalida = String.Empty
        'End If
        '----------
        ' Devolver el texto 
        Return auxTextoSalida
    End Function




    ''' <summary>
    '''  Escribe en letras una unidad
    ''' </summary>
    ''' <param name="pUnidad">
    '''    Cadena con una(1) cifra que representa a una unidad
    ''' </param>
    ''' <param name="pFormaDeEscrituraDelUno">
    '''   <para>Enumeración <see cref="FormatoEscrituraDelUno">
    '''         FormatoEscrituraDelUno</see>
    '''   </para>
    '''   <para>Indica la forma de escribir una terminación en 
    '''         [uno] por ejemplo [un], [uno, [una]
    '''   </para>
    ''' </param>
    ''' <returns>
    '''   <para>Una cadena que contiene escrito
    '''         en letras el numero pasado</para>
    ''' </returns>
    Private Shared Function auxEscribeUnidades(
                   ByVal pUnidad As String,
                   ByVal pFormaDeEscrituraDelUno As FormatoEscrituraDelUno) As String

        '-----------------------------
        ' PRECONDICION
        ' Responsabilidad del llamador
        ' El llamador tiene que cerciorarse de que:
        ' 1) en el parámetro haya un carácter
        ' 2) y además que no sean espacios
        '-----------------------------
        Dim unidadNumero As Integer
        unidadNumero = Integer.Parse(pUnidad,
                                     Globalization.NumberStyles.None,
                                     System.Globalization.CultureInfo.InvariantCulture)
        '--------------------------
        ' ¡Atención!
        ' [uno], no figura porque es la función [auxTratamientoDelNumeroUno]
        ' la que se encarga de escribirlo de forma adecuada
        Dim unidadesMatriz() As String = {"cero", "", "dos", "tres", "cuatro",
                                       "cinco", "seis", "siete", "ocho", "nueve"}
        ' cargar el texto de salida correspondiente al numero
        Dim auxTextoSalida As String = unidadesMatriz(unidadNumero)
        '--------------
        ' El caso del numero uno
        If unidadNumero = 1 Then
            auxTextoSalida = auxTratamientoDelNumeroUno(auxTextoSalida, pFormaDeEscrituraDelUno)
        End If
        Return auxTextoSalida
    End Function




    ''' <summary>
    '''  El numero terminado en  [uno] se escribe de forma diferente 
    '''  en función del sustantivo que lo califica
    '''  Por ejemplo 
    '''    No hay sustantivo           [uno], [veintiuno], [cuarenta y uno]
    '''    Con un sustantivo masculino [un euro],     [veintiún coches]
    '''    Con un sustantivo femenino  [una manzana], [treinta y una peseta]
    '''</summary>
    ''' <param name="pNumeroterminadoEnUno">
    '''    Cadena que contiene (necesariamente) escrito un numero 
    '''    que termina en [un]. por ejemplo [treinta y un]
    ''' </param>
    ''' <param name="pFormaDeEscrituraDelUno">
    '''   <para>Enumeración <see cref="FormatoEscrituraDelUno">
    '''         FormatoEscrituraDelUno</see>
    '''   </para>
    '''   <para>Indica la forma de escribir una terminación en [uno] 
    '''         por ejemplo [un], [uno, [una]
    '''   </para>
    ''' </param>
    ''' <returns>
    '''   Una cadena que contiene la cadena recibida a la que se le 
    '''   ha añadido la vocal 'o' o la vocal 'a' segun proceda.
    '''   [treinta y un], [treinta y un0], [treinta y una] 
    ''' </returns>
    Private Shared Function auxTratamientoDelNumeroUno(
                            ByVal pNumeroterminadoEnUno As String,
                            ByVal pFormaDeEscrituraDelUno As FormatoEscrituraDelUno) As String
        '---------------------------------------------
        'Problema 
        ' El acento de las palabras terminadas en [un], 
        '  por ejemplo [un euro] se escribe sin acento, 
        '  pero [veintiún euros] se escribe con acento
        '
        'La forma de distinguir cuando hay que usar el acento y cuando no, 
        '  es mirar a ver si viene alguna cadena, 
        '  Si se recibe una cadena    se escribe [ún] acentuada, 
        '  Si no se recibe una cadena se escribe [un] sin acento.
        '---------------------------------------------

        Const UN_CON_ACENTO As String = "ún"
        Const UN_SIN_ACENTO As String = "un"
        Const MASCULINO As String = "uno"
        Const FEMENINO As String = "una"

        Dim auxTextoSalida As String = pNumeroterminadoEnUno

        Select Case pFormaDeEscrituraDelUno
            Case FormatoEscrituraDelUno.UnConSustantivoMasculino
                ' el valor [un] es el valor de texto que figura en las matrices
                ' no hacer nada, devolver el valor recibido
                If pNumeroterminadoEnUno.Length = 0 Then
                    auxTextoSalida = UN_SIN_ACENTO
                Else
                    auxTextoSalida = auxTextoSalida & UN_CON_ACENTO
                End If
            Case FormatoEscrituraDelUno.UnoSinSustantivo
                auxTextoSalida = auxTextoSalida & MASCULINO ' uno
            Case FormatoEscrituraDelUno.UnaConSustantivoFemenino
                auxTextoSalida = auxTextoSalida & FEMENINO ' una
            Case Else
                ' Problemas en la enumeracion
                ' normalmente por añadir o quitar elementos
                Throw New System.ComponentModel.InvalidEnumArgumentException(
                    "(auxTratamientoDelNumeroUno) FormaEscrituraDelUno")
        End Select

        Return auxTextoSalida
    End Function



#End Region




#Region "Implementacion interfaz [Dispose]  [2012-12-04] "


    ' ''' <summary>
    ' ''' Un objeto administrado es un objeto de .NET que maneja el motor de 
    ' ''' ejecucion de NET, por ejemplo cualquier objeto de .NET
    ' ''' </summary>
    'Private Sub DisposeObjetosAdministrados()
    '    '--------------------------------
    '    '--------------------------------
    '    ' --> Liberar objetos administrados), 
    '    '     por ejemplo cualquier objeto de .NET
    '    '--------------------------------
    '    '--------------------------------
    '    'If Not (Me._Arbol Is Nothing) Then
    '    '    If _Arbol.IsDisposed = False Then
    '    '        _Arbol.Dispose()
    '    '    End If
    '    '    Me._Arbol = Nothing
    '    'End If
    'End Sub


    ' ''' <summary>
    ' '''  Establecer campos grandes como Null.
    ' ''' </summary>
    ' ''' <remarks></remarks>
    'Private Sub DisposeCamposGrandesToNothing()
    '     '--------------------------------
    '    ' --> Establecer campos grandes como Nothing.
    '    '     es decir todos los campos de la clase
    '    '--------------------------------
    '    'Me._CadenaGrande = Nothing
    'End Sub


    ' ''' <summary>
    ' '''  Si la clase derivada usa objetos NO administrados, debe reemplazar esta funcion
    ' '''  Un objeto no administrado  es un recurso que NO administra el motor en  
    ' '''  tiempo de ejecución, como identificadores de  ventanas (HWND),  
    ' '''  conexiones a bases de datos, un objeto creado directamente  
    ' '''  llamando al API de Windows, etc. el Word o Excel
    ' ''' </summary>
    'Private Sub DisposeObjetosNOAdministrados()
    '    Throw New NotImplementedException("DisposeObjetosNOAdministrados - No esta escrita")

    '    '--------------------------------
    '    ' --> Liberar objetos NO administrados).
    '    '       por ejemplo una base de datos
    '    '       Solamente hay que llamar a su método [Dispose]
    '    '--------------------------------
    '    '--------------------------------
    '    'If Not (Me.connection Is Nothing) Then
    '    '    'Close conexión'
    '    '    If connection.IsDisposed = False Then
    '    '        connection.Dispose()
    '    '    End If
    '    '    '¡¡OJITO !! no se hace Nothing
    '    'End If
    '    '--------------------------------
    'End Sub


    ' *******************************************************
    ' *******************************************************


    '  Variable y propiedad para saber si se ha diposado :-) o no
    '  es una variable que actua de semaforo, solo deja pasar una vez
    '----------------------------------------
    ' Apunte Táctico
    '----------------------------------------
    ' Si se borra el atributo [<Serializable()>] de la clase
    ' También hay que borrar el atributo [<NonSerialized()>] 
    ' de la variable [_disposedValue] que esta a continuación
    '----------------------------------------



    'Private _isDisposed As Boolean ' = False (no hace falta inicializar) 
    <NonSerialized()> Private _isDisposed As Boolean ' = False (no hace falta inicializar) 


    ''' <summary>
    '''     Obtiene un valor que indica si el objeto se ha eliminado. 
    ''' </summary>
    ''' <value>
    '''   <para>Tipo: <see cref="System.Boolean">Boolean</see></para>
    '''   <para>Es true si objeto se ha eliminado; en caso contrario, es false.</para>
    ''' </value>
    ''' <remarks>
    ''' <para> Cuando esta propiedad devuelve true, el objeto se elimina y ya
    '''        no se puede hacer referencia al mismo como un objeto válido. </para>  
    ''' <para> Aunque se elimine la instancia de un objeto, ésta se guarda en 
    '''        la memoria hasta que el recolector de elementos no utilizados 
    '''        la quite de la memoria.</para>  
    '''</remarks>
    Public Overloads Property IsDisposed() As Boolean
        Get
            Return _isDisposed
        End Get
        Private Set(ByVal value As Boolean)
            _isDisposed = value
        End Set
    End Property


    ''' <summary>
    '''     Destructor del objeto
    ''' </summary>
    Protected Overrides Sub Finalize()
        ' Este método se invoca de forma automática, después de 
        ' que un objeto pase a ser inaccesible, salvo que haya  
        ' sido excluido del proceso de finalización mediante una  
        ' llamada a GC.SuppressFinalize. 
        ' -----------------------------------------------------
        ' escenario en el que el Sistema llama al metodo dispose
        ' -----------------------------------------------------
        Try
            Me.Dispose(False)
        Finally
            MyBase.Finalize()
        End Try
    End Sub


    ''' <summary>
    '''   Realiza tareas definidas por la aplicación asociadas a 
    '''   la liberación o al restablecimiento de recursos no administrados
    ''' </summary>
    Public Overloads Sub Dispose()
        ' No hacer este metodo virtual.   
        ' Una clase derivada no debe ser capaz de reemplazar este metodo.    
        ' -----------------------------------------------------
        ' escenario en el que el usuario llama al metodo dispose
        ' -----------------------------------------------------
        ' No cambie este código. Coloque el código de limpieza en Dispose (ByVal que se dispone como Boolean).
        Me.Dispose(True)
        ' Decir al recolecto que no llame al destructor de este objeto
        ' porque este objeto ya esta [finalizado]
        GC.SuppressFinalize(Me)
    End Sub


    '--------------------------------------------------------------------
    ' Dispose (bool quienLLama) se ejecuta en dos escenarios distintos.
    ' Si [quienMeLLama] es igual a true, el método ha sido llamado directamente
    ' O indirectamente por el código de un usuario. 
    ' Los recursos administrados y no administrados Se puede eliminar.
    ' Si [quienMeLLama]es igual a false, el método ha sido llamado por el
    ' [runtime] desde el interior del finalizador y usted no debe hacer 
    ' referencia a otros objetos, ni siquiera para eliminarlos.
    ' Solo los recursos no administrados pueden ser eliminados.
    '--------------------------------------------------------------------
    ''' <summary>
    '''   Realiza tareas definidas por la aplicación asociadas a 
    '''   la liberación o al restablecimiento de recursos no administrados
    ''' </summary>
    ''' <remarks>
    ''' <para> ¡¡PROBLEMA!! Esta función debe tener el calificador [Overridable]</para>
    ''' <para>              pero si la clase está marcada como [NotInheritable] </para>
    ''' <para>              da error. En ese caso se puede quitar               </para>
    ''' <code>http://msdn.microsoft.com/es-es/magazine/cc163392.aspx</code>
    '''</remarks>
    Protected Overridable Overloads Sub Dispose(ByVal quienMeLLama As Boolean)
        ' Comprueba si Dispose ya ha sido llamado.  
        ' Solo se ejecuta una vez y solo una
        If Not Me.IsDisposed Then
            Try
                ' -------------------------------
                If quienMeLLama = True Then
                    ' -------------------------------
                    ' 1) Proceso de eliminar recursos SI administrados
                    ' -------------------------------
                    'Call DisposeObjetosAdministrados()
                End If
                ' -------------------------------
                ' 2) Proceso de eliminar recursos NO administrados
                'Call DisposeObjetosNOAdministrados()
                ' -------------------------------
                ' 3) Proceso de eliminar cadenas grandes
                'Call DisposeCamposGrandesToNothing()
                ' -------------------------------
                ' 4) TODO:  Proceso de llamar al dispose de la clase base
                ' -------------------------------
                Call MyBase.Dispose()

            Finally
                ' Cerrar la puerta, solo se pasa una vez
                IsDisposed = True
            End Try
        End If
    End Sub


#End Region




End Class
