﻿


'/*
'
' -----------------------------------------------------------------
' IDENTIFICACION.:
'    Versión .....: 2013/02/19
'    Module Name..: GenericaEscribeConLetras 
'----------------
'    Creada inicialmente en el proyecto: [NumerosToLetrasDll]
'    Versión de la plantilla de fecha..: [2012-12-12] 
'----------------
'    Lenguaje .: .NET Framework 4.0.30319.18033 - 
'                 Microsoft Visual Basic .NET 2012 - [2013]
'    Usuario ..: AGUILA8 - Joaquin
'
'----------------
' DESCRIPCION.:
'
' Clase para escribir cualquier numero en letras acompañado de cualquier unidad (peras, manzanas, etc)
' En el constructor hay que pasar toda la informacion que necesita la clase para trabajar
'
' Utiliza su clase 'Contenida' [EscribeConLetrasDirector] 
' para realizar las operaciones de escritura
'
'----------------
' OBSERVACIONES.:
'    ### Falta  mas observaciones###
'
'----------------
' INTERFAZ.:
'     Implementa la interfaz IDisposable, INumeroToLetras
'
'----------------
#Region "Copyright"

' COPYRIGHT.:
'      Copyright (c).:  [2013]  Joaquin 'jms32' Medina Serrano
'      Emilio .......:  mailto:joaquin@medina.name
'      Web ..........:  http://joaquin.medina.name
'
'
'  Yo, titular de los derechos de autor de esta obra, la publico 
'  en los términos de las siguientes licencias:
'
'  A pesar de las ¿Exhaustivas? , ¿Intesas?, 
'  y ¿cuidadosas? (ja, ja, ja..) pruebas a que he  
'  sometido este codigo, el principio de Murphy siempre 
'  esta trabajando y dice que si algo puede ir mal seguro 
'  que va mal. Por esa razon, Este codigo se porporciona 
'  *Como esta* sin ninguna garantia de ninguna clase 
'
'  Este codigo es BirraWare, es decir, si lo empleas, 
'  estas obligado de forma ineludible a:
'  a) Indicar claramente el autor (o sea mi nombre) 
'     y el sitio Web de donde se lo has copiado 
'     (o sea mi web) 
'  b) invitar a una birrita fresquita al creador del mismo
'     (o sea soy yo el que tiene que beberse la cerveza).
'  c) Si no me localizas, me conformo con que me envies 
'     un *emilio* contandome para que lo has empleado.
'     tengo curiosidad por saber por donde circula, 
'     (la curiosidad me puede)
'  d) Si haces algo interesante enviame una copia, me gustaria verlo 
'
' Se autoriza la copia, distribución y modificación de este documento 
' bajo los términos de la licencia de documentación libre GNU,  
' versión 1.2 o cualquier otra que posteriormente publique la  
' Fundación para el Software Libre; sin secciones invariables,  
' textos de portada, ni textos de contraportada.  
' Se incluye una copia de la dicha licencia en la sección titulada  
' Licencia de Documentación Libre GNU. Se puede consultar una copia  
' de la licencia en http://www.gnu.org/copyleft/fdl.html
'
'Este archivo se encuentra bajo la licencia  
' Creative Commons de Atribución/Compartir-Igual 
'Eres libre:
'  - Para compartir – para copiar, distribuir y transmitir el trabajo
'  - Para remezclar – para adaptar el trabajo
' Bajo las siguientes condiciones: 
'  - Atribución – Debes atribuir el trabajo de la manera especificada  
'    por el autor o persona que lo haya licenciado (pero no de manera  
'    que sugiera que estas personas te respaldan o respaldan el uso  
'    que hagas del trabajo).
'  - Compartir similar – En caso de alterar, transformar o ampliar  
'    este trabajo, deberá distribuir el trabajo resultante sólo  
'    bajo la misma licencia o una similar.
'
#End Region
'----------------
' MODIFICACIONES  [aaaa-mm-dd] 
' - 2013/02/19- Creación 
' - 2013/02/19 - Revisado con FxCop 
'
' -----------------------------------------------------------------
'
'*/
'
' -------------------------------------------------
Option Explicit On
Option Strict On
Option Infer Off
Option Compare Binary



''' <summary>
'''  Clase para escribir cualquier numero en letras acompañado de cualquier unidad (peras, manzanas, etc)
''' </summary>
''' <remarks>
'''<code language="vb" title="Forma de usar la clase desde código">
''' <![CDATA[
'''<summary>
'''    Ejemplo de uso de la clase desde código 
'''</summary>
'''Private Sub trabajoConClases()
'''    ' Evitar un problema tonto con el cuadro de texto
'''    If Me.TextBoxLetras Is Nothing Then Exit Sub
'''
'''    Try
'''        Me.TextBoxLetras.Clear()
'''
'''        ' la clase generica para cualquier unidad
'''        Using objEscitor = New NumerosToLetrasDll.GenericaEscribeConLetras(
'''                            pNombreUnidadParteEnteraSingular:="manzana",
'''                            pNombreUnidadParteEnteraPlural:="manzanas",
'''                            pFormatoEscrituraParteEntera:=NumerosToLetrasDll.FormatoEscrituraDelUno.UnaConSustantivoFemenino,
'''                            pNombreUnidadParteDecimalSingular:="centimanzana",
'''                            pNombreUnidadParteDecimalPlural:="centimanzanas",
'''                            pFormatoEscrituraParteDecimal:=NumerosToLetrasDll.FormatoEscrituraDelUno.UnaConSustantivoFemenino,
'''                            pNumeroDeDecimalesObligatorios:=-1)
'''
'''            Me.TextBoxLetras.AppendText(Environment.NewLine)
'''            Me.TextBoxLetras.AppendText("(4) " & objEscitor.EscribeElNumeroConLetras(Me.TextBoxNumero.Text))
'''        End Using
'''
'''    Catch ex As Exception
'''        If Not (Me.TextBoxLetras Is Nothing) Then
'''            Me.TextBoxLetras.Text = ex.Message
'''        End If
'''    End Try
'''End Sub
''']]>
''' </code> 
''' 
''' <code language="vb" title="Forma de usar la interface desde código">
''' <![CDATA[
'''     <summary>
'''       Ejemplo de uso de la interfaz desde código
'''     </summary>
'''     Private Sub TrabajoConInterfaces()
'''       ' Evitar un problema tonto con el cuadro de texto
'''        If Me.TextBoxLetras Is Nothing Then Exit Sub
'''        Try
'''            Dim interfaceConvertidor As NumerosToLetrasDll.INumeroToLetras = Nothing
'''            ' ------------------------------
'''            interfaceConvertidor = New NumerosToLetrasDll.GenericaEscribeConLetras(
'''                                pNombreUnidadParteEnteraSingular:="manzana",
'''                                pNombreUnidadParteEnteraPlural:="manzanas",
'''                                pFormatoEscrituraParteEntera:=FormatoEscrituraDelUno.UnaConSustantivoFemenino,
'''                                pNombreUnidadParteDecimalSingular:="centimanzana",
'''                                pNombreUnidadParteDecimalPlural:="centimanzanas",
'''                                pFormatoEscrituraParteDecimal:=FormatoEscrituraDelUno.UnaConSustantivoFemenino,
'''                                pNumeroDeDecimalesObligatorios:=-1)
'''            ' ------------------------------
'''            Me.TextBoxLetras.AppendText(Environment.NewLine)
'''            Me.TextBoxLetras.AppendText("(6) " & interfaceConvertidor.EscribeElNumeroConLetras(Me.TextBoxNumero.Text))
'''
'''        Catch ex As Exception
'''            If Not (Me.TextBoxLetras Is Nothing) Then
'''                Me.TextBoxLetras.Text = ex.Message
'''            End If
'''        End Try
'''    End Sub
''']]>
''' </code> 
''' <list  type="bullet">
''' <item> <a href="http://es.wikipedia.org/wiki/Nombres_de_los_n%C3%BAmeros_en_espa%C3%B1ol">Anexo: Nombres de los números en español</a></item>
''' <item> <a href="http://es.wikipedia.org/wiki/Escalas_num%C3%A9ricas_larga_y_corta">Escalas numéricas larga y corta</a></item>
''' <item> <a href="http://www.saberespractico.com/estudios/cultura-general/reglas-escritura-numeros-cardinales/">Reglas para la escritura de los números cardinales </a></item>
''' <item> <a href="http://www.saberespractico.com/estudios/ortografia-numerica-escritura-de-numeros/">Reglas ortográficas para la escritura de números </a></item>
''' <item> <a href="http://www.hispanoteca.eu/Foro-preguntas/ARCHIVO-Foro/Euro%20-%20euros.htm">Hispanoteca - Como se escribe 'euro'</a></item>
''' </list>
''' </remarks>
<Serializable()> _
Public Class GenericaEscribeConLetras
    Implements INumeroToLetras, IDisposable



  
    ''' <summary>
    '''   El objeto contenido que encapsula toda la 
    '''   problemática de convertir un numero en letras
    ''' </summary>
    ''' <remarks>
    '''   Observación
    '''   Lo uso como objeto contenido porque así evito que se vea fuera de la DLL
    '''</remarks>
    Private _objEscritor As EscribeConLetrasDirector ' = Nothing
    ' regla Fxcop No inicializar innecesariamente




    ''' <summary>
    '''  Constructor generico para cualquier unidad
    ''' </summary>
    ''' <param name="pNombreUnidadParteEnteraSingular">
    '''  El sustantivo en SINGULAR que califica la parte ENTERA 
    '''  Se espera un valor [string.empty] o bien, una cadena que 
    '''  contiene un sustantivo (en singular) que califica la parte 
    '''  entera del número. Por ejemplo Euro, patata.
    ''' </param>
    ''' <param name="pNombreUnidadParteEnteraPlural">
    '''  El sustantivo en PLURAL que califica la parte ENTERA 
    '''  Se espera un valor [string.empty] o bien, una cadena 
    '''  que contiene un sustantivo (en plural) Por ejemplo Euros, patatas
    ''' </param>
    ''' <param name="pFormatoEscrituraParteEntera">
    '''  El formato de escritura del valor [uno] en la parte ENTERA. 
    '''  El sustantivo que califica a la parte entera del número  (si existe)
    '''   ¿es del género masculino o femenino? Por ejemplo, euro(s) es masculino, patata(s) es femenina
    '''  (si no existe) se espera un valor [FormatoEscrituraDelUno.UnoSinSustantivo]
    ''' </param>
    ''' <param name="pNombreUnidadParteDecimalSingular">
    '''  El sustantivo en SINGULAR que califica la parte DECIMAL 
    '''  Se espera un valor [string.empty] o bien, una cadena que 
    '''  contiene un sustantivo (en singular) que califica la parte 
    '''  decimal del número. Por ejemplo céntimo, patatilla
    ''' </param>
    ''' <param name="pNombreUnidadParteDecimalPlural">
    '''  El sustantivo en PLURAL que califica la parte DECIMAL. 
    '''  Se espera un valor [string.empty] o bien, una cadena que 
    '''  contiene un sustantivo (en plural) 
    '''  Por ejemplo. Por ejemplo céntimos, patatillas
    ''' </param>
    ''' <param name="pFormatoEscrituraParteDecimal">
    '''  El formato de escritura del valor [uno] en la parte DECIMAL. 
    '''  El sustantivo que califica a la parte decimal del número  (si existe) 
    '''  ¿es del género masculino o femenino? 
    '''  Por ejemplo, céntimo(s) es masculino, patatilla(s) es femenina
    '''  (si no existe) se espera un valor [FormatoEscrituraDelUno.UnoSinSustantivo]
    ''' </param>
    ''' <param name="pNumeroDeDecimalesObligatorios">
    '''    El numero de decimales que obligatoriamente debe tener el número.
    '''    Por ejemplo los EUROS,  SIEMPRE tienen DOS (2) decimales. 
    '''    Su valor por defecto= [-1] valor [OperacionesEscribeLaParteDecimal.DECIMALES_OBLIGATORIOS_VALOR_POR_DEFECTO]
    '''    que significa que no se controla este valor, 
    '''    Es decir, el numero puede tener (o no) cualquier numero de decimales
    ''' </param>
    ''' <remarks>
    '''   <para>Enumeración <see cref="FormatoEscrituraDelUno">FormatoEscrituraDelUno</see></para>
    '''   <para>Indica la forma de escribir una terminación en [uno] por ejemplo [un], [uno, [una]</para>
    '''   <para>Valor por defecto = FormatoEscrituraDelUno.UnoSinSustantivo </para>
    ''' </remarks>
    Public Sub New(ByVal pNombreUnidadParteEnteraSingular As String,
                   ByVal pNombreUnidadParteEnteraPlural As String,
                   ByVal pFormatoEscrituraParteEntera As FormatoEscrituraDelUno,
                   ByVal pNombreUnidadParteDecimalSingular As String,
                   ByVal pNombreUnidadParteDecimalPlural As String,
                   ByVal pFormatoEscrituraParteDecimal As FormatoEscrituraDelUno,
                   ByVal pNumeroDeDecimalesObligatorios As Integer)

        '---------------------------------
        ' Llamar al constructor de la clase contenida
        '---------------------------------
        _objEscritor = New EscribeConLetrasDirector(String.Empty)

        '---------------------------------
        ' Cargar Los valores para la parte entera
        '---------------------------------
        ' El nombre de la unidad o esta en singular y plural o no esta
        If pNombreUnidadParteEnteraSingular.Length > 0 AndAlso pNombreUnidadParteEnteraPlural.Length = 0 Then
            Throw New InvalidCadenaNumericaException(
              "Parte ENTERA del numero. " & Environment.NewLine & _
              "Falta el nombre de la unidad en plural. " & Environment.NewLine & _
              "El nombre de la unidad en singular recibido es [" & pNombreUnidadParteEnteraSingular & "]")
        End If
        ' El nombre de la unidad o esta en singular y plural o no esta
        If pNombreUnidadParteEnteraSingular.Length = 0 AndAlso pNombreUnidadParteEnteraPlural.Length > 0 Then
            Throw New InvalidCadenaNumericaException(
              "Parte ENTERA del numero. " & Environment.NewLine & _
              "Falta el nombre de la unidad en singular. " & Environment.NewLine & _
              "El nombre de la unidad en plural recibido es [" & pNombreUnidadParteEnteraPlural & "]")
        End If




        _objEscritor.NombreUnidadParteEnteraSingular = pNombreUnidadParteEnteraSingular
        _objEscritor.NombreUnidadParteEnteraPlural = pNombreUnidadParteEnteraPlural
        _objEscritor.FormatoEscrituraParteEntera = pFormatoEscrituraParteEntera


        '---------------------------------
        ' Cargar Los valores para la parte decimal
        '---------------------------------
        ' El nombre de la unidad o esta en singular y plural o no esta
        If pNombreUnidadParteDecimalSingular.Length > 0 AndAlso pNombreUnidadParteDecimalPlural.Length = 0 Then
            Throw New InvalidCadenaNumericaException(
              "Parte DECIMAL del numero. " & Environment.NewLine & _
              "Falta el nombre de la unidad en plural. " & Environment.NewLine & _
              "El nombre de la unidad en singular recibido es [" & pNombreUnidadParteDecimalSingular & "]")
        End If
        ' El nombre de la unidad o esta en singular y plural o no esta
        If pNombreUnidadParteDecimalSingular.Length = 0 AndAlso pNombreUnidadParteDecimalPlural.Length > 0 Then
            Throw New InvalidCadenaNumericaException(
              "Parte DECIMAL del numero. " & Environment.NewLine & _
              "Falta el nombre de la unidad en singular. " & Environment.NewLine & _
              "El nombre de la unidad en plural recibido es [" & pNombreUnidadParteDecimalPlural & "]")
        End If

        _objEscritor.NombreUnidadParteDecimalPlural = pNombreUnidadParteDecimalPlural
        _objEscritor.NombreUnidadParteDecimalSingular = pNombreUnidadParteDecimalSingular
        _objEscritor.FormatoEscrituraParteDecimal = pFormatoEscrituraParteDecimal
        _objEscritor.NumeroDeDecimalesObligatorios = pNumeroDeDecimalesObligatorios

    End Sub




    ''' <summary>
    '''  Constructor generico para cualquier unidad
    ''' </summary>
    ''' <param name="pNombreUnidadParteEnteraSingular">
    '''  El sustantivo en SINGULAR que califica la parte ENTERA 
    '''  Se espera un valor [string.empty] o bien, una cadena que 
    '''  contiene un sustantivo (en singular) que califica la parte 
    '''  entera del número. Por ejemplo Euro, patata.
    ''' </param>
    ''' <param name="pNombreUnidadParteEnteraPlural">
    '''  El sustantivo en PLURAL que califica la parte ENTERA 
    '''  Se espera un valor [string.empty] o bien, una cadena 
    '''  que contiene un sustantivo (en plural) Por ejemplo Euros, patatas
    ''' </param>
    ''' <param name="pFormatoEscrituraParteEntera">
    '''  El formato de escritura del valor [uno] en la parte ENTERA. 
    '''  El sustantivo que califica a la parte entera del número  (si existe)
    '''   ¿es del género masculino o femenino? Por ejemplo, euro(s) es masculino, patata(s) es femenina
    '''  (si no existe) se espera un valor [FormatoEscrituraDelUno.UnoSinSustantivo]
    ''' </param>
    ''' <param name="pNombreUnidadParteDecimalSingular">
    '''  El sustantivo en SINGULAR que califica la parte DECIMAL 
    '''  Se espera un valor [string.empty] o bien, una cadena que 
    '''  contiene un sustantivo (en singular) que califica la parte 
    '''  decimal del número. Por ejemplo céntimo, patatilla
    ''' </param>
    ''' <param name="pNombreUnidadParteDecimalPlural">
    '''  El sustantivo en PLURAL que califica la parte DECIMAL. 
    '''  Se espera un valor [string.empty] o bien, una cadena que 
    '''  contiene un sustantivo (en plural) 
    '''  Por ejemplo. Por ejemplo céntimos, patatillas
    ''' </param>
    ''' <param name="pFormatoEscrituraParteDecimal">
    '''  El formato de escritura del valor [uno] en la parte DECIMAL. 
    '''  El sustantivo que califica a la parte decimal del número  (si existe) 
    '''  ¿es del género masculino o femenino? 
    '''  Por ejemplo, céntimo(s) es masculino, patatilla(s) es femenina
    '''  (si no existe) se espera un valor [FormatoEscrituraDelUno.UnoSinSustantivo]
    ''' </param>
    ''' <remarks>
    '''   <para>Enumeración <see cref="FormatoEscrituraDelUno">FormatoEscrituraDelUno</see></para>
    '''   <para>Indica la forma de escribir una terminación en [uno] por ejemplo [un], [uno, [una]</para>
    '''   <para>Valor por defecto = FormatoEscrituraDelUno.UnoSinSustantivo </para>
    ''' </remarks>
    Public Sub New(ByVal pNombreUnidadParteEnteraSingular As String,
                   ByVal pNombreUnidadParteEnteraPlural As String,
                   ByVal pFormatoEscrituraParteEntera As FormatoEscrituraDelUno,
                   ByVal pNombreUnidadParteDecimalSingular As String,
                   ByVal pNombreUnidadParteDecimalPlural As String,
                   ByVal pFormatoEscrituraParteDecimal As FormatoEscrituraDelUno)

        Me.New(pNombreUnidadParteEnteraSingular, pNombreUnidadParteEnteraPlural, pFormatoEscrituraParteEntera,
               pNombreUnidadParteDecimalSingular, pNombreUnidadParteDecimalPlural, pFormatoEscrituraParteDecimal,
               OperacionesEscribeLaParteDecimal.DECIMALES_OBLIGATORIOS_VALOR_POR_DEFECTO)

    End Sub



    ''' <summary>
    '''   Escribe en letras el número pasado en 
    '''   el constructor (P.E. Cuarenta y cinco)
    ''' </summary>
    Public Function EscribeElNumeroConLetras() As String _
        Implements INumeroToLetras.EscribeElNumeroConLetras
        Return _objEscritor.EscribeElNumeroConLetras
    End Function


    ''' <summary>
    '''  Escribe en letras un número
    ''' (P.E. 45,23 -> Cuarenta y cinco con veintitrés)
    ''' </summary>
    ''' <param name="pNumero">Un numero decimal. </param>
    ''' <returns>
    '''   <para>Una cadena que contiene escrito en letras el numero pasado</para>
    '''   <para>si el numero es cero (0) devuelve una cadena con el valor [cero]</para>
    '''   <para>si el numero es una cadena vacía [Empty] se devuelve [Empty]</para>
    ''' </returns>
    Public Function EscribeElNumeroConLetras(pNumero As Decimal) As String _
        Implements INumeroToLetras.EscribeElNumeroConLetras
        Return _objEscritor.EscribeElNumeroConLetras(pNumero)
    End Function



    ''' <summary>
    '''  Escribe en letras un número
    ''' (P.E. 45,23 -> Cuarenta y cinco con veintitrés)
    ''' </summary>
    ''' <param name="pCadenaNumerica">
    '''   <para>La cadena que contiene el numero. </para>
    '''   <para>Es responsabilidad del llamador asegurarse de que 
    '''         la cadena es un numero bien formado, 
    '''         escrito en formato numérico Español es decir:</para> 
    '''   <para>El separador decimal es la coma [,]. </para>
    '''   <para>El separador de los millares es o bien 
    '''         el punto [.], o bien el espacio [' ']. </para>
    '''   <para>La cadena debe contener únicamente números 
    '''         (no están permitidas las letras),</para>
    '''   <para>Opcionalmente puede llevar un signo más [+] o menos [-] 
    '''         para indicar que el número es positivo o negativo.</para>
    ''' </param>
    ''' <returns>
    '''   <para>Una cadena que contiene escrito en letras el numero pasado</para>
    '''   <para>si el numero es cero (0) devuelve una cadena con el valor [cero] </para>
    '''   <para>si el numero es una cadena vacía [Empty] se devuelve [Empty]</para>
    ''' </returns>
    Public Function EscribeElNumeroConLetras(pCadenaNumerica As String) As String _
            Implements INumeroToLetras.EscribeElNumeroConLetras
        Return _objEscritor.EscribeElNumeroConLetras(pCadenaNumerica)
    End Function


#Region "Implementacion interfaz [Dispose]  [2012-12-04] "


    ''' <summary>
    ''' Un objeto administrado es un objeto de .NET que maneja el motor de 
    ''' ejecucion de NET, por ejemplo cualquier objeto de .NET
    ''' </summary>
    Private Sub DisposeObjetosAdministrados()
        '--------------------------------
        '--------------------------------
        ' --> Liberar objetos administrados), 
        '     por ejemplo cualquier objeto de .NET
        '--------------------------------
        '--------------------------------
        If Not (Me._objEscritor Is Nothing) Then
            If _objEscritor.IsDisposed = False Then
                _objEscritor.Dispose()
            End If
            Me._objEscritor = Nothing
        End If
    End Sub


    ' ''' <summary>
    ' '''  Establecer campos grandes como Null.
    ' ''' </summary>
    ' ''' <remarks></remarks>
    'Private Sub DisposeCamposGrandesToNothing()
    '    '--------------------------------
    '    ' --> Establecer campos grandes como Nothing.
    '    '     es decir todos los campos de la clase
    '    '--------------------------------
    '    'Me._CadenaGrande = Nothing
    'End Sub


    ' ''' <summary>
    ' '''  Si la clase derivada usa objetos NO administrados, debe reemplazar esta funcion
    ' '''  Un objeto no administrado  es un recurso que NO administra el motor en  
    ' '''  tiempo de ejecución, como identificadores de  ventanas (HWND),  
    ' '''  conexiones a bases de datos, un objeto creado directamente  
    ' '''  llamando al API de Windows, etc. el Word o Excel
    ' ''' </summary>
    'Private Sub DisposeObjetosNOAdministrados()
    '    Throw New NotImplementedException("DisposeObjetosNOAdministrados - No esta escrita")

    '    '--------------------------------
    '    ' --> Liberar objetos NO administrados).
    '    '       por ejemplo una base de datos
    '    '       Solamente hay que llamar a su método [Dispose]
    '    '--------------------------------
    '    '--------------------------------
    '    'If Not (Me.connection Is Nothing) Then
    '    '    'Close conexión'
    '    '    If connection.IsDisposed = False Then
    '    '        connection.Dispose()
    '    '    End If
    '    '    '¡¡OJITO !! no se hace Nothing
    '    'End If
    '    '--------------------------------
    'End Sub


    ' *******************************************************
    ' *******************************************************


    '  Variable y propiedad para saber si se ha diposado :-) o no
    '  es una variable que actua de semaforo, solo deja pasar una vez
    '----------------------------------------
    ' Apunte Táctico
    '----------------------------------------
    ' Si se borra el atributo [<Serializable()>] de la clase
    ' También hay que borrar el atributo [<NonSerialized()>] 
    ' de la variable [_disposedValue] que esta a continuación
    '----------------------------------------



    'Private _isDisposed As Boolean ' = False (no hace falta inicializar) 
    <NonSerialized()> Private _isDisposed As Boolean ' = False (no hace falta inicializar) 


    ''' <summary>
    '''     Obtiene un valor que indica si el objeto se ha eliminado. 
    ''' </summary>
    ''' <value>
    '''   <para>Tipo: <see cref="System.Boolean">Boolean</see></para>
    '''   <para>Es true si objeto se ha eliminado; en caso contrario, es false.</para>
    ''' </value>
    ''' <remarks>
    ''' <para> Cuando esta propiedad devuelve true, el objeto se elimina y ya
    '''        no se puede hacer referencia al mismo como un objeto válido. </para>  
    ''' <para> Aunque se elimine la instancia de un objeto, ésta se guarda en 
    '''        la memoria hasta que el recolector de elementos no utilizados 
    '''        la quite de la memoria.</para>  
    '''</remarks>
    Public Overloads Property IsDisposed() As Boolean
        Get
            Return _isDisposed
        End Get
        Private Set(ByVal value As Boolean)
            _isDisposed = value
        End Set
    End Property


    ''' <summary>
    '''     Destructor del objeto
    ''' </summary>
    Protected Overrides Sub Finalize()
        ' Este método se invoca de forma automática, después de 
        ' que un objeto pase a ser inaccesible, salvo que haya  
        ' sido excluido del proceso de finalización mediante una  
        ' llamada a GC.SuppressFinalize. 
        ' -----------------------------------------------------
        ' escenario en el que el Sistema llama al metodo dispose
        ' -----------------------------------------------------
        Try
            Me.Dispose(False)
        Finally
            MyBase.Finalize()
        End Try
    End Sub


    ''' <summary>
    '''   Realiza tareas definidas por la aplicación asociadas a 
    '''   la liberación o al restablecimiento de recursos no administrados
    ''' </summary>
    Public Overloads Sub Dispose() Implements System.IDisposable.Dispose
        ' No hacer este metodo virtual.   
        ' Una clase derivada no debe ser capaz de reemplazar este metodo.    
        ' -----------------------------------------------------
        ' escenario en el que el usuario llama al metodo dispose
        ' -----------------------------------------------------
        ' No cambie este código. Coloque el código de limpieza en Dispose (ByVal que se dispone como Boolean).
        Me.Dispose(True)
        ' Decir al recolecto que no llame al destructor de este objeto
        ' porque este objeto ya esta [finalizado]
        GC.SuppressFinalize(Me)
    End Sub


    '--------------------------------------------------------------------
    ' Dispose (bool quienLLama) se ejecuta en dos escenarios distintos.
    ' Si [quienMeLLama] es igual a true, el método ha sido llamado directamente
    ' O indirectamente por el código de un usuario. 
    ' Los recursos administrados y no administrados Se puede eliminar.
    ' Si [quienMeLLama]es igual a false, el método ha sido llamado por el
    ' [runtime] desde el interior del finalizador y usted no debe hacer 
    ' referencia a otros objetos, ni siquiera para eliminarlos.
    ' Solo los recursos no administrados pueden ser eliminados.
    '--------------------------------------------------------------------
    ''' <summary>
    '''   Realiza tareas definidas por la aplicación asociadas a 
    '''   la liberación o al restablecimiento de recursos no administrados
    ''' </summary>
    ''' <remarks>
    ''' <para> ¡¡PROBLEMA!! Esta función debe tener el calificador [Overridable]</para>
    ''' <para>              pero si la clase está marcada como [NotInheritable] </para>
    ''' <para>              da error. En ese caso se puede quitar               </para>
    ''' <code>http://msdn.microsoft.com/es-es/magazine/cc163392.aspx</code>
    '''</remarks>
    Protected Overridable Overloads Sub Dispose(ByVal quienMeLLama As Boolean)
        ' Comprueba si Dispose ya ha sido llamado.  
        ' Solo se ejecuta una vez y solo una
        If Not Me.IsDisposed Then
            Try
                ' -------------------------------
                If quienMeLLama = True Then
                    ' -------------------------------
                    ' 1) Proceso de eliminar recursos SI administrados
                    ' -------------------------------
                    Call DisposeObjetosAdministrados()
                End If
                ' -------------------------------
                ' 2) Proceso de eliminar recursos NO administrados
                'Call DisposeObjetosNOAdministrados()
                ' -------------------------------
                ' 3) Proceso de eliminar cadenas grandes
                'Call DisposeCamposGrandesToNothing()
                ' -------------------------------
                ' 4) TODO:  Proceso de llamar al dispose de la clase base
                ' -------------------------------
                'Call MyBase.Dispose()
            Finally
                ' Cerrar la puerta, solo se pasa una vez
                IsDisposed = True
            End Try
        End If
    End Sub

#End Region

End Class
