﻿

Friend NotInheritable Class ManzanasEscribeConLetras
    Inherits GenericaEscribeConLetras


#Region "Informacion de los parámetros del constructor de la clase base"


    ' <summary>
    '  Constructor generico para cualquier unidad
    ' </summary>
    ' <param name="pNombreUnidadParteEnteraSingular">
    '    Se espera un valor [string.empty] o bien, una cadena que  
    '    contiene la palabra (en singular) que califica 
    '    a la parte entera del número. Por ejemplo Euro, patata,
    ' </param>
    ' <param name="pNombreUnidadParteEnteraPlural">
    '    Se espera un valor [string.empty] o bien, una cadena que  
    '    contiene la palabra (en plural) que califica 
    '    a la parte entera del número. Por ejemplo Euros, patatas
    ' </param>
    ' <param name="pFormatoEscrituraParteEntera">
    '   La unidad que califica a la parte entera del número 
    '  (si existe) ¿es del genero masculino o femenino?
    '  (si no existe) se espera un valor [FormatoEscrituraDelUno.UnoSinSustantivo]
    ' </param>
    ' <param name="pNombreUnidadParteDecimalSingular">
    '    Se espera un valor [string.empty] o bien, una cadena que  
    '    contiene la palabra (en singular) que califica 
    '    a la parte decimal del número. Por ejemplo centimo, patatilla
    ' </param>
    ' <param name="pNombreUnidadParteDecimalPlural">
    '    Se espera un valor [string.empty] o bien, una cadena que  
    '    contiene la palabra (en plural) que califica 
    '    a la parte decimal del número. Por ejemplo centimos, patatillas
    ' </param>
    ' <param name="pFormatoEscrituraParteDecimal">
    '  La unidad que califica a la parte decimal del número 
    '  (si existe) ¿es del genero masculino o femenino?
    '  (si no existe) se espera un valor [FormatoEscrituraDelUno.UnoSinSustantivo]
    ' </param>
    ' <param name="pNumeroDeDecimalesObligatorios">
    '     Se espera el valor numerico [-1]
    '     Numero de decimales que obligatoriamente debe tener el numero. 
    '     Por ejemplo los EUROS,  SIEMPRE tienen DOS(2)  decimales
    '     Valor por defecto= -1 significa que no se controla este valor
    '     Es decir, el numero puede tener (o no) cualquier numero de decimales
    ' </param>
    ' <remarks>
    '   <para>Enumeración <see cref="FormatoEscrituraDelUno">FormatoEscrituraDelUno</see></para>
    '   <para>Indica la forma de escribir una terminación en [uno] por ejemplo [un], [uno, [una]</para>
    '   <para>Valor por defecto = FormatoEscrituraDelUno.UnoSinSustantivo </para>
    ' </remarks>
#End Region

    ''' <summary>
    '''  Constructor 
    ''' </summary>
    Public Sub New()
        MyBase.New("Manzana", "Manzanas", FormatoEscrituraDelUno.UnaConSustantivoFemenino,
                   "centimanzana", "centimanzanas", FormatoEscrituraDelUno.UnaConSustantivoFemenino, -1)
    End Sub


#Region "Codigo refactorizado"

    ' ''' <summary>
    ' '''  Constructor
    ' ''' </summary>
    'Public Sub New()
    '    Me.New(String.Empty)
    'End Sub


    ' ''' <summary>
    ' '''  Constructor
    ' ''' </summary>
    ' ''' <param name="pCadenaNumerica"> 
    ' '''    La cadena Original que contiene un número
    ' '''    La cadena debe contener únicamente números [0-9]
    ' '''    La coma [,] como separador decimal
    ' '''    Como separadores de millar se admite el punto [.]  o el espacio
    ' '''    Ejemplo [123.456,78] [123 456,78]
    ' '''</param>
    ' ''' <remarks>
    ' '''    Opcionalmente la cadena puede llevar el signo  menos [-] 
    ' '''    para indicar que es un número negativo
    ' '''</remarks>
    'Friend Sub New(ByVal pCadenaNumerica As String)
    '    MyBase.New(pCadenaNumerica)

    '    ' los 'euros' tienen SIEMPRE dos decimales (maximo)
    '    Me.NumeroDeDecimalesObligatorios = 2

    '    Me.NombreUnidadParteEnteraSingular = "Manzana"
    '    Me.NombreUnidadParteEnteraPlural = "Manzanas"
    '    Me.FormatoEscrituraParteEntera = FormatoEscrituraDelUno.UnaConSustantivoFemenino


    '    Me.NombreUnidadParteDecimalSingular = "centiManzana"
    '    Me.NombreUnidadParteDecimalPlural = "centiManzanas"
    '    Me.FormatoEscrituraParteDecimal = FormatoEscrituraDelUno.UnaConSustantivoFemenino ' escribe un centimo
    'End Sub

#End Region


End Class
