﻿


'/*
'
' -----------------------------------------------------------------
' IDENTIFICACION.:
'    Versión .....: 2013/02/19
'    Module Name..: UnidadesEscribeConLetras 
'----------------
'    Creada inicialmente en el proyecto: [NumerosToLetrasDll]
'    Versión de la plantilla de fecha..: [2012-12-12] 
'----------------
'    Lenguaje .: .NET Framework 4.0.30319.18033 - 
'                 Microsoft Visual Basic .NET 2012 - [2013]
'    Usuario ..: AGUILA8 - Joaquin
'
'----------------
' DESCRIPCION.:
'
' Esta clase escribe un numero en letras
' las unidades las califica con la palabra [unidades], ejemplo [dos unidades]
' Los decimales tambien se califican para evitar ambigüedades
' por ejemplo [2,1] y [2,01] se escriben en letras igual [dos con uno]
' pero lo correcto es calificar la parte decimal escribiendo
' [dos unidades con una decima]
' [dos unidades con una centésima]
'
' Utiliza su clase base [GenericaEscribeConLetras] 
' para realizar las operaciones de escritura
'
'----------------
' OBSERVACIONES.:
'    ### Falta  mas observaciones###
'
'----------------
' INTERFAZ.:
'     Implementa la interfaz IDisposable, INumeroToLetras
'
'----------------
#Region "Copyright"

' COPYRIGHT.:
'      Copyright (c).:  [2013]  Joaquin 'jms32' Medina Serrano
'      Emilio .......:  mailto:joaquin@medina.name
'      Web ..........:  http://joaquin.medina.name
'
'
'  Yo, titular de los derechos de autor de esta obra, la publico 
'  en los términos de las siguientes licencias:
'
'  A pesar de las ¿Exhaustivas? , ¿Intesas?, 
'  y ¿cuidadosas? (ja, ja, ja..) pruebas a que he  
'  sometido este codigo, el principio de Murphy siempre 
'  esta trabajando y dice que si algo puede ir mal seguro 
'  que va mal. Por esa razon, Este codigo se porporciona 
'  *Como esta* sin ninguna garantia de ninguna clase 
'
'  Este codigo es BirraWare, es decir, si lo empleas, 
'  estas obligado de forma ineludible a:
'  a) Indicar claramente el autor (o sea mi nombre) 
'     y el sitio Web de donde se lo has copiado 
'     (o sea mi web) 
'  b) invitar a una birrita fresquita al creador del mismo
'     (o sea soy yo el que tiene que beberse la cerveza).
'  c) Si no me localizas, me conformo con que me envies 
'     un *emilio* contandome para que lo has empleado.
'     tengo curiosidad por saber por donde circula, 
'     (la curiosidad me puede)
'  d) Si haces algo interesante enviame una copia, me gustaria verlo 
'
' Se autoriza la copia, distribución y modificación de este documento 
' bajo los términos de la licencia de documentación libre GNU,  
' versión 1.2 o cualquier otra que posteriormente publique la  
' Fundación para el Software Libre; sin secciones invariables,  
' textos de portada, ni textos de contraportada.  
' Se incluye una copia de la dicha licencia en la sección titulada  
' Licencia de Documentación Libre GNU. Se puede consultar una copia  
' de la licencia en http://www.gnu.org/copyleft/fdl.html
'
'Este archivo se encuentra bajo la licencia  
' Creative Commons de Atribución/Compartir-Igual 
'Eres libre:
'  - Para compartir – para copiar, distribuir y transmitir el trabajo
'  - Para remezclar – para adaptar el trabajo
' Bajo las siguientes condiciones: 
'  - Atribución – Debes atribuir el trabajo de la manera especificada  
'    por el autor o persona que lo haya licenciado (pero no de manera  
'    que sugiera que estas personas te respaldan o respaldan el uso  
'    que hagas del trabajo).
'  - Compartir similar – En caso de alterar, transformar o ampliar  
'    este trabajo, deberá distribuir el trabajo resultante sólo  
'    bajo la misma licencia o una similar.
'
#End Region
'----------------
' MODIFICACIONES  [aaaa-mm-dd] 
' - 2013/02/19- Creación 
' - 2013/02/19 - Revisado con FxCop 
'
' -----------------------------------------------------------------
'
'*/
'
' -------------------------------------------------
Option Explicit On
Option Strict On
Option Infer Off
Option Compare Binary



''' <summary>
'''   Escribe en letras un numero con cifras decimales
'''   ejemplo [dos unidades con 21 centesima]
''' </summary>
''' <remarks>
'''<code language="vb" title="Forma de usar la clase desde código">
''' <![CDATA[
'''<summary>
'''    Ejemplo de uso de la clase desde código 
'''</summary>
'''Private Sub trabajoConClases()
'''    ' Evitar un problema tonto con el cuadro de texto
'''    If Me.TextBoxLetras Is Nothing Then Exit Sub
'''
'''    Try
'''        Me.TextBoxLetras.Clear()
'''
'''        ' escribe doce unidades con treinta y dos centesimas
'''        Using objEscitor = New NumerosToLetrasDll.UnidadesEscribeConLetras
'''            Me.TextBoxLetras.AppendText(Environment.NewLine)
'''            Me.TextBoxLetras.AppendText("(2) " & objEscitor.EscribeElNumeroConLetras(Me.TextBoxNumero.Text))
'''        End Using
'''
'''    Catch ex As Exception
'''        If Not (Me.TextBoxLetras Is Nothing) Then
'''            Me.TextBoxLetras.Text = ex.Message
'''        End If
'''    End Try
'''End Sub
''']]>
''' </code> 
''' 
''' <code language="vb" title="Forma de usar la interface desde código">
''' <![CDATA[
'''     <summary>
'''       Ejemplo de uso de la interfaz desde código
'''     </summary>
'''     Private Sub TrabajoConInterfaces()
'''       ' Evitar un problema tonto con el cuadro de texto
'''        If Me.TextBoxLetras Is Nothing Then Exit Sub
'''        Try
'''            Dim interfaceConvertidor As NumerosToLetrasDll.INumeroToLetras = Nothing
'''            interfaceConvertidor = New NumerosToLetrasDll.UnidadesEscribeConLetras
'''
'''            Me.TextBoxLetras.AppendText(Environment.NewLine)
'''            Me.TextBoxLetras.AppendText("(5) " & interfaceConvertidor.EscribeElNumeroConLetras(Me.TextBoxNumero.Text))
'''
'''        Catch ex As Exception
'''            If Not (Me.TextBoxLetras Is Nothing) Then
'''                Me.TextBoxLetras.Text = ex.Message
'''            End If
'''        End Try
'''    End Sub
''']]>
''' </code> 
''' 
''' <list  type="bullet">
''' <item> <a href="http://es.wikipedia.org/wiki/Nombres_de_los_n%C3%BAmeros_en_espa%C3%B1ol">Anexo: Nombres de los números en español</a></item>
''' <item> <a href="http://es.wikipedia.org/wiki/Escalas_num%C3%A9ricas_larga_y_corta">Escalas numéricas larga y corta</a></item>
''' <item> <a href="http://www.saberespractico.com/estudios/cultura-general/reglas-escritura-numeros-cardinales/">Reglas para la escritura de los números cardinales </a></item>
''' <item> <a href="http://www.saberespractico.com/estudios/ortografia-numerica-escritura-de-numeros/">Reglas ortográficas para la escritura de números </a></item>
''' <item> <a href="http://www.hispanoteca.eu/Foro-preguntas/ARCHIVO-Foro/Euro%20-%20euros.htm">Hispanoteca - Como se escribe 'euro'</a></item>
''' </list>
''' </remarks>
Public NotInheritable Class UnidadesEscribeConLetras
    Inherits GenericaEscribeConLetras


#Region "Informacion de los parámetros del constructor de la clase base"

    '
    'El sustantivo en SINGULAR que califica la parte ENTERA 
    ' Se espera un valor [string.empty] o bien, una cadena que  
    ' contiene un sustantivo (en singular) que califica  
    ' la parte entera del número. Por ejemplo Euro, patata, 
    ' 
    'El sustantivo en PLURAL que califica la parte ENTERA  
    ' Se espera un valor [string.empty] o bien, una cadena que  
    ' contiene un sustantivo (en plural) Por ejemplo Euros, patatas 
    ' 
    'El formato de escritura del valor [uno] en la parte ENTERA.  
    ' El sustantivo que califica a la parte entera del número  (si existe) 
    '  ¿es del género masculino o femenino? 
    '  Por ejemplo, euro(s) es masculino, patata(s) es femenina 
    '  
    ' 
    'El sustantivo en SINGULAR que califica la parte DECIMAL  
    ' Se espera un valor [string.empty] o bien, una cadena que  
    ' contiene un sustantivo (en singular) que califica la  
    ' parte decimal del número.  
    ' Por ejemplo céntimo, patatilla 
    ' 
    'El sustantivo en PLURAL que califica la parte DECIMAL.  
    ' Se espera un valor [string.empty] o bien, una cadena que  
    ' contiene un sustantivo (en plural)  
    ' Por ejemplo. Por ejemplo céntimos, patatillas 
    ' 
    'El formato de escritura del valor [uno] en la parte DECIMAL.  
    ' El sustantivo que califica a la parte decimal del número  (si existe) 
    '  ¿es del género masculino o femenino? 
    '  Por ejemplo, céntimo(s) es masculino, patatilla(s) es femenina 
    ' 
    'El numero de decimales que obligatoriamente debe tener el número.  
    ' Por ejemplo los EUROS,  SIEMPRE tienen DOS (2)  decimales.  
    ' Su valor por defecto= [-1] que significa que no se controla este valor,  
    ' Es decir, el numero puede tener (o no) cualquier numero de decimales 
    ' 
    ' 
#End Region


    ''' <summary>
    '''  Constructor 
    ''' </summary>
    Public Sub New()
        MyBase.New("unidad", "unidades", FormatoEscrituraDelUno.UnaConSustantivoFemenino,
                   String.Empty, String.Empty, FormatoEscrituraDelUno.UnoSinSustantivo,
                   OperacionesEscribeLaParteDecimal.DECIMALES_OBLIGATORIOS_VALOR_POR_DEFECTO)
    End Sub




#Region "Codigo refactorizado"

    'Inherits EscritorBase

    ' ''' <summary>
    ' '''  Constructor
    ' ''' </summary>
    'Public Sub New()
    '    Me.New(String.Empty)
    'End Sub


    ' ''' <summary>
    ' '''  Constructor
    ' ''' </summary>
    ' ''' <param name="pCadenaNumerica"> 
    ' '''    La cadena Original que contiene un número
    ' '''    La cadena debe contener únicamente números [0-9]
    ' '''    La coma [,] como separador decimal
    ' '''    Como separadores de millar se admite el punto [.]  o el espacio
    ' '''    Ejemplo [123.456,78] [123 456,78]
    ' '''</param>
    ' ''' <remarks>
    ' '''    Opcionalmente la cadena puede llevar el signo  menos [-] 
    ' '''    para indicar que es un número negativo
    ' '''</remarks>
    'Public Sub New(ByVal pCadenaNumerica As String)
    '    MyBase.New(pCadenaNumerica)

    '    Me.NombreUnidadParteEnteraSingular = "unidad"
    '    Me.NombreUnidadParteEnteraPlural = "unidades"
    '    Me.FormatoEscrituraParteEntera = FormatoEscrituraDelUno.UnaConSustantivoFemenino ' escribe una unidad

    'End Sub

#End Region


End Class
