﻿Class MainWindow 
    Private Sub ButtonConvertir_Click(sender As System.Object, e As System.Windows.RoutedEventArgs)
        Call TrabajoConInterfaces()
    End Sub

    Private Sub ButtonCancelar_Click(sender As System.Object, e As System.Windows.RoutedEventArgs)
        Me.Close()
    End Sub

    Private Sub TextBoxNumero_TextChanged(sender As Object, e As System.Windows.Controls.TextChangedEventArgs) Handles TextBoxNumero.TextChanged
        Call trabajoConClases()
    End Sub

    Private Sub RadioButtonSoloNumeros_Click(sender As System.Object, e As System.Windows.RoutedEventArgs)
        Call TrabajoConInterfaces()
    End Sub

    Private Sub trabajoConClases()
        Try
            ' Evitar un problema tonto con el cuadro de texto
            If Me.TextBoxLetras Is Nothing Then Exit Sub

            Me.TextBoxLetras.Clear()

            ' escribe doce con treinta y dos centesimas
            Using objEscitor = New NumerosToLetrasDll.NumeroEscribeConLetras
                'Me.TextBoxLetras.AppendText(Environment.NewLine)
                Me.TextBoxLetras.AppendText("(1) " & objEscitor.EscribeElNumeroConLetras(Me.TextBoxNumero.Text))
            End Using

            ' escribe doce unidades con treinta y dos centesimas
            Using objEscitor = New NumerosToLetrasDll.UnidadesEscribeConLetras
                Me.TextBoxLetras.AppendText(Environment.NewLine)
                Me.TextBoxLetras.AppendText("(2) " & objEscitor.EscribeElNumeroConLetras(Me.TextBoxNumero.Text))
            End Using

            ' escribe doce euros con veinte centimos
            Using objEscitor = New NumerosToLetrasDll.EurosEscribeConLetras 'EscribeEurosConLetras
                Me.TextBoxLetras.AppendText(Environment.NewLine)
                Me.TextBoxLetras.AppendText("(3) " & objEscitor.EscribeElNumeroConLetras(Me.TextBoxNumero.Text))
            End Using

            ' la clase generica para cualquier unidad
            Using objEscitor = New NumerosToLetrasDll.GenericaEscribeConLetras(
                                pNombreUnidadParteEnteraSingular:="manzana",
                                pNombreUnidadParteEnteraPlural:="manzanas",
                                pFormatoEscrituraParteEntera:=NumerosToLetrasDll.FormatoEscrituraDelUno.UnaConSustantivoFemenino,
                                pNombreUnidadParteDecimalSingular:="centimanzana",
                                pNombreUnidadParteDecimalPlural:="centimanzanas",
                                pFormatoEscrituraParteDecimal:=NumerosToLetrasDll.FormatoEscrituraDelUno.UnaConSustantivoFemenino,
                                pNumeroDeDecimalesObligatorios:=-1)

                Me.TextBoxLetras.AppendText(Environment.NewLine)
                Me.TextBoxLetras.AppendText("(4) " & objEscitor.EscribeElNumeroConLetras(Me.TextBoxNumero.Text))
            End Using

        Catch ex As Exception
            If Not (Me.TextBoxLetras Is Nothing) Then
                Me.TextBoxLetras.Text = ex.Message
            End If
        End Try
    End Sub



    '/* Forma de usar la interface desde codigo **/
    Private Sub TrabajoConInterfaces()
        Try

            ' Evitar un problema tonto con el cuadro de texto
            If Me.TextBoxLetras Is Nothing Then Exit Sub

            Me.TextBoxLetras.Clear()

            Dim interfaceConvertidor As NumerosToLetrasDll.INumeroToLetras = Nothing

            If Me.RadioButtonSoloNumeros.IsChecked = True Then
                interfaceConvertidor = New NumerosToLetrasDll.NumeroEscribeConLetras
            End If
            If Me.RadioButtonUnidad.IsChecked = True Then
                interfaceConvertidor = New NumerosToLetrasDll.UnidadesEscribeConLetras
            End If
            If Me.RadioButtonEuros.IsChecked = True Then
                interfaceConvertidor = New NumerosToLetrasDll.EurosEscribeConLetras
            End If

            Me.TextBoxLetras.AppendText(Environment.NewLine)
            Me.TextBoxLetras.AppendText("(5) " & interfaceConvertidor.EscribeElNumeroConLetras(Me.TextBoxNumero.Text))

            ' ------------------------------
            interfaceConvertidor = New NumerosToLetrasDll.GenericaEscribeConLetras(
                                pNombreUnidadParteEnteraSingular:="manzana",
                                pNombreUnidadParteEnteraPlural:="manzanas",
                                pFormatoEscrituraParteEntera:=NumerosToLetrasDll.FormatoEscrituraDelUno.UnaConSustantivoFemenino,
                                pNombreUnidadParteDecimalSingular:="centimanzana",
                                pNombreUnidadParteDecimalPlural:="centimanzanas",
                                pFormatoEscrituraParteDecimal:=NumerosToLetrasDll.FormatoEscrituraDelUno.UnaConSustantivoFemenino,
                                pNumeroDeDecimalesObligatorios:=-1)

            Me.TextBoxLetras.AppendText(Environment.NewLine)
            Me.TextBoxLetras.AppendText("(6) " & interfaceConvertidor.EscribeElNumeroConLetras(Me.TextBoxNumero.Text))

        Catch ex As Exception
            If Not (Me.TextBoxLetras Is Nothing) Then
                Me.TextBoxLetras.Text = ex.Message
            End If
        End Try
    End Sub




End Class
